/**
 * Loss screen for the lockpicking minigame.
 * @param {string} id Scene id. Used to create controllers.
 * @param {string} key Unique key-space for the lockpicking minigame.
 */
function LockPickingWinScreen(id, key) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;

    var uniqueIdentifier = arguments.callee.name;
    var elementId = id + "_" + key + "_" + uniqueIdentifier;

    var image = new LockPickingPreloadingWinScreen();

    var ctrl = new ChoiceController(id, elementId);
    var visible = ctrl.has() && ctrl.get();

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    // PUBLIC MEMBERS \\        this.public = "test";

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns the HTML.
     */
    this.build = function () {
        var screen = `<img ${visible ? `` : `style="display:none;"`} class="win" src=${image.url} id="${elementId}">`;
        return screen;
    };

    /**
     * Registers all the required listeners.
     */
    this.registerListeners = function () {

    };

    /**
     * Preloads all assets required, if they have not yet already been loaded.
     */
    this.preload = function () {
        return image.preload();
    };

    /**
     * Causes the element to fade out.
     */
    this.fade = function () {
        ctrl.set(false);
        $("#" + elementId).fadeOut(400);
    };

    /**
     * Causes the element to show.
     */
    this.show = function () {
        ctrl.set(true);
        $("#" + elementId).fadeIn(400);
    };
}
