/**
 * A class representing a single save.
 * Helper class for the SaveGameManager.
 * Should not be used outside of that class.
 * Only works one way (TO json).
 * @param {Character} character The kobold to save.
 * @param {string} currentScene The current scene. 
 * @param {string} currentSceneName The name of the current scene. 
 * @param {string} currentSceneFolder The subfolder of the current scene. 
 * @param {string} saveComment A comment to add to the save.
 * @param {int} scroll The scroll level of the main scene.
 * @param {string} timeStamp The time at which the save was made.
 */
function KoboldAdventureSave(character, currentScene, currentSceneName, currentSceneFolder, saveComment, scroll, timeStamp) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    // PUBLIC MEMBERS \\        this.public = "test";
    this.kobold = character;
    this.scene = currentScene;
    this.sceneName = currentSceneName;
    this.folder = currentSceneFolder;
    this.comment = saveComment;
    this.sceneScroll = scroll || 0;
    this.time = timeStamp;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};
    
    /**
     * Returns a JSON representation of this save.
     * @returns A JSON representation of this save.
     */
    this.toJson = function(){
        return JSON.stringify(that);
    };
}

