/**
 * Controller for the Farmer's Maid scene.
 * @param {string} sceneId The id of the scene.
 */
function FarmerMaidController(sceneId) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var id = sceneId;
    SceneController.call(this, id);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    // PUBLIC MEMBERS \\        this.public = "test";
    this.nextSceneReady = false;
    this.nextSceneName = "SlaveAfternoonTwo";
    this.nextFolderName = "Enslavement/DayTwo";

    this.misc = new MiscController(id, "misc");

    this.arrival = new ContinueController(id, "arrival");
    this.gender = new ChangeController(id, "gender", function () {
        if (that.misc.gender() !== GenderEnum.FEMALE) {
            global.kobold.body.setGender(GenderEnum.FEMALE);
        }
    }, function () {
        return "";
    });
    this.claws = new ChangeController(id, "claws", function () {
        global.kobold.status.physical.decrease(30, "Claw removal");
        global.kobold.status.mental.decrease(30, "Claw removal");
        global.kobold.status.stamina.decrease(30, "Pleading for mercy");
    }, function () {
        return "";
    });
    this.teeth = new ChangeController(id, "teeth", function () {
        global.kobold.status.physical.decrease(30, "Tooth removal");
        global.kobold.status.mental.decrease(30, "Tooth removal");
        global.kobold.status.stamina.decrease(30, "Screaming for help");
    }, function () {
        return "";
    });
    this.brandmark = new ChangeController(id, "brandmark", function () {
        global.kobold.status.physical.decrease(30, "Brandmarked");
        global.kobold.status.mental.decrease(30, "Brandmarked");
        global.kobold.status.stamina.decrease(30, "Begging for death");
    }, function () {
        return "";
    });
    this.recover = new ChangeController(id, "recover", function () {
        if (that.gender.get() === FarmerMaidGenderChoice.BLACKOUT) {
            global.kobold.status.physical.decrease(90, "Claws and teeth removed");
            global.kobold.status.mental.decrease(90, "Claws and teeth removed");
            global.kobold.status.stamina.decrease(90, "Screaming, pleading and begging");
        }
        global.kobold.status.exertion.decrease(90, "A slave is always ready");
        global.kobold.inventory.equipment.wear(new MaidOutfit());
    }, function () {
        return "";
    });
    this.preMaid = new ContinueController(id, "preMaid");
    this.maid = new ChoiceController(id, "maid");
    this.postMaid = new ContinueController(id, "postMaid");
    this.preParents = new ContinueController(id, "preParents");
    this.parents = new ChoiceController(id, "parents");
    this.postParents = new ContinueController(id, "postParents");
    this.amorousFuck = new ChangeController(id, "amorousFuck", function () {
        global.kobold.body.vaginalVirgin = false;
    }, function () {
        return "";
    });
    this.absentBlowjob = new ChangeController(id, "absentBlowjob", function () {
        global.kobold.body.oralVirgin = false;
    }, function () {
        return "";
    });
    this.daily = new ContinueController(id, "daily");
    this.amorousDaily = new ChangeController(id, "amorousDaily", function () {
        global.kobold.body.analVirgin = false;
        global.kobold.body.oralVirgin = false;
    }, function () {
        return "";
    });

    this.toofar = new ChoiceController(id, "toofar");
    this.toofarRun = new ChangeController(id, "toofarRun", function () {
        global.kobold.body.analVirgin = false;
        global.kobold.body.oralVirgin = false;
    }, function () {
        return "";
    });
    this.toofarTell = new ChoiceController(id, "toofarTell");
    this.toofarServe = new ChangeController(id, "toofarServe", function () {
        global.kobold.body.vaginalVirgin = false;
    }, function () {
        return "";
    });

    this.girlfriend = new ChoiceController(id, "girlfriend");
    this.jealous = new ChoiceController(id, "jealous");
    this.girlfriendKill = new ChangeController(id, "girlfriendKill", function () {
        global.kobold.body.vaginalVirgin = false;
    }, function () {
        return "";
    });
    this.frame = new ChoiceController(id, "frame");


    this.drunk = new ChoiceController(id, "drunk");
    this.postDrunk = new ContinueController(id, "postDrunk");
    this.preDeath = new ContinueController(id, "preDeath");
    this.death = new ChoiceController(id, "death");


    this.parentsChoice = {
        LEAVE: 1,
        WATCH: 2,
        HANDJOB: 3,
        BLOWJOB: 4,
        NOPEN: 5,
        FUCK: 6
    };

    this.fragments = {};
    this.fragments.dog = new FarmerMaidDrunkDeclineDog(this);
    this.fragments.satisfied = new FarmerMaidDrunkSatisfy(this);
    this.fragments.amorousDaily = new FarmerMaidAmorousDaily(this);
    this.fragments.absentDaily = new FarmerMaidAbsentDaily(this);
    this.fragments.abusiveDaily = new FarmerMaidAbusiveDaily(this);
    this.fragments.blowjob = new FarmerMaidAbsentBlowjob(this);
    this.fragments.handjob = new FarmerMaidAbsentHandjob(this);
    this.fragments.recover = new FarmerMaidRecover(this);

    this.subControllers = {};

    this.bgm = new AudioController(id, "res/audio/enslavement/maid.mp3", 100);

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

}
