/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidArrival(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = false;
    var subController = ctrl.arrival;
    var changeController = false;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new FarmerMaidGender(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            Tugging you by your arm, the farmer leads you towards a shack, not too far away from his home.
                            The two of you come to a halt in front of it.
                            Instead of stepping inside, the human turns around, keeping a firm hold on you to make sure you don't [i]escape[/i].
                            He seems to be waiting for someone, or [i]something[/i].
                        [/p]
                        [p]
                            You're too [i]intimidated[/i] by the farmer's solid grasp and broad posture to ask what it is you are doing here.
                            Instead, you inspect the building.
                            Through the open door, you can see various metal tools hanging from the wooden wall.
                            A well-lit kiln stands next to it, the handles of a few iron pokers sticking out.
                            This must be the [i]workshop[/i] the human was talking about.
                            Looks kind of like a miniature smithy, although you don't see any anvils around.
                        [/p]
                        [p]
                            After more than a minute of silent waiting, a group of burly men approach from far side of the village.
                            The anthro horses from the auction are there,
                            along with several humans who look like they've working the fields for their entire lives.
                            They seem to know your new [i]owner[/i].
                            Seeing the entourage, you swallow deeply, fearing this might be a [i]sexual[/i] thing.
                            He's going to [b]sell[/b] your body to every man in town!
                        [/p]
                        [p]
                            The men heartily greet the farmer.
                            "[color=purple]Hey Romeo.[/color]"
                            Romeo?
                            Is that his name?
                            Or is he being made fun of?
                            "[color=purple]So this is the new purchase, eh?[/color]"
                            asks one of the horses, referring to you.
                            They're all going to take turns fucking you, aren't they?
                            "[color=purple]Two hundred, was it? Expensive little lizard.[/color]"
                            You feel sick.
                            Your stomach starts to churn.
                            "[color=red]Yeah, but my house'll finally be clean, for once.
                            If only my wife was less lazy, eh?[/color]"
                        [/p]
                        [p]
                            Any minute now, they're going to lower their pants,
                            whip out their dicks and fuck you until you can barely even walk anymore.
                            "[color=red]Anyway, let's get down to business, shall we?
                            I've got crops to water before dark.[/color]"
                            Oh no.
                            This is it.
                            "[color=red]Did you bring the goods?[/color]"
                            Wait, what?
                            [i]The goods[/i]?
                            "[color=purple]Yeah, yeah.
                            Hold'em still.[/color]"
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        global.ui.applyTheme("hamlet_day");
        ctrl.bgm.loop();
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}
