/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidDrunk(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.daily;
    var subController = ctrl.drunk;
    var changeController = false;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";
    var thirdId = arguments.callee.name + "ButtonThree";
    var fourthId = arguments.callee.name + "ButtonFour";

    var firstNext = new FarmerMaidDrunkDecline(ctrl);
    var secondNext = new FarmerMaidDrunkGetHard(ctrl);
    var thirdNext = new FarmerMaidDrunkTrick(ctrl);
    var fourthNext = new FarmerMaidDrunkPiss(ctrl);

    var firstChoice = FarmerMaidDrunkChoice.DECLINE;
    var secondChoice = FarmerMaidDrunkChoice.HARD;
    var thirdChoice = FarmerMaidDrunkChoice.TRICK;
    var fourthChoice = FarmerMaidDrunkChoice.PISS;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        global.kobold.history.shared.varanar.dayThree.afternoon.parlorRan = true;
        var toReturn = `[p]
                            A few weeks after you've broken the news,
                            Falco goes out to have some [i]fun[/i] with his delinquent friends.
                            That never amounts to much good.
                            You recall the time he accidentally caused the well in the middle of the hamlet to collapse.
                            Juliet was [b]so[/b] mad at him!
                            You hope he won't cause any [i]destruction[/i] this time around.
                        [/p]
                        [p]
                            A few hours later, early in the afternoon,
                            while you're busy mopping the floor,
                            the front door suddenly and wildly swings open.
                            In stumbles your avian partner.
                            He sluggishly steps inside of the house, almost losing his balance when closing the door behind him.
                            "[color=yellow]Heeeyyyy there, pretty thing...[i]hic[/i]![/color]"
                            His speech is slurred and the hefty stench of [b]alcohol[/b] wafts from his beak.
                            You're pretty certain he's drunk.
                            [b]Very[/b] drunk.
                            [b]Hammered[/b].
                        [/p]
                        [p]
                            Still a little upset about his reaction to you telling him you're pregnant several weeks ago,
                            you give Falco the cold shoulder,
                            concentrating on the floor instead of validating his booze-fueled rambling.
                            As the drunken father of your child approaches you, he carelessly knocks over your mop bucket, water spilling everywhere!
                            As he caressingly grabs you from behind, you can no longer ignore him.
                            Agitated, you grumpily asks the bird what he wants?!
                            Can't he see you're trying to [b]clean[/b] here?!
                        [/p]
                        [p]
                            What he wants soon becomes clear, the eagle pressing his feathery body against your back,
                            erotically grinding his bulge against your barely dressed rear.
                            "[color=yellow]All I want is [b]you[/b].[/color]"
                            He places a peck on the back of your neck, and starts fiddling with his belt-buckle.
                            You sigh out loud, and reluctantly lift your tail.
                        [/p]
                        [p]
                            Falco whips out his member, and begins to rub it against your loins.
                            When you think he's about to insert himself, he instead starts to jerk off,
                            seemingly having trouble [i]getting it up[/i].
                            Whiskeydick.
                            Serves him right, getting drunk in the middle of the day.
                            He frantically tries to get hard, but half-mast is all he can manage.
                            He looks like he [b]really[/b] wants this.
                            You actually kind of [i]feel bad[/i] for him.
                        [/p]
                        [p]
                            After a minute of trying, the bird frustratedly relents, realizing he [b]won't[/b] be fucking you right now.
                            Then, a different base need strikes his mind.
                            "[color=yellow]I really have to...[i]hic[/i]...take a [b]leak[/b].[/color]"
                            What?
                            If he needs to pee, then why the heck is he still here?!
                            Go outside, dumb eagle.
                            "[color=yellow]Come on, let me do it [b]inside[/b] of you.[/color]"
                            What?
                            No!
                            The door's right there!
                            "[color=yellow]I won't [b]make[/b] it there...[i]hic[/]!
                            If I have to pish on the floor, mom'll get [b]mad[/b] at me.
                            And it'll be [b]your[/b] fault![/color]"
                        [/p]
                        [p]
                            He's getting quite [i]upset[/i] about this.
                            You think he may be one of those [i]angry[/i] drunks.
                            Perhaps denying the avian wouldn't be the best of ideas.
                            You really don't want him to do [i]that[/i] inside of you, though.
                            It's [i]dirty[/i].
                        [/p]`;
        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === firstChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice dangeraura ${selected}" id="${firstId}" ${disabled}>Decline</button>`;

        var tooltip = global.parser.parse(`Push him away. Tell him to go do his business outside. 
                                            [warn]You should probably [b]take a different approach[/b],
                                            unless you are ready to get [b]seriously hurt[/b].[/warn]`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 190px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === secondChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${secondId}" ${disabled}>Get him hard</button>`;

        var tooltip = global.parser.parse(`He can't pee if he's erect. Let's see if you can do a better job than he can.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 180px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildThirdChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === thirdChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${thirdId}" ${disabled}>Trick him</button>`;

        var tooltip = global.parser.parse(`Squeeze his length with your thighs to make it seem like he's inside of you.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 190px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFourthChoice() {
        var disabled = subController.has()? "disabled" : "";
        var isSelected = subController.get() === fourthChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${fourthId}" ${disabled}>Allow it</button>`;

        var tooltip = global.parser.parse(`Guide him in.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 110px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You:</div>`;
        choice += `<div class="choicerow" style="margin-bottom: 10px;">`;
        choice += buildFirstChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `</div>`;
        choice += `<div class="choicerow">`;
        choice += buildThirdChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildFourthChoice();
        choice += `</div>`;
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId), $("#" + thirdId), $("#" + fourthId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(firstChoice);
            loadNextPart(firstNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(secondChoice);
            loadNextPart(secondNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerThirdListener() {
        $("#" + thirdId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(thirdChoice);
            loadNextPart(thirdNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerFourthListener() {
        $("#" + fourthId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(fourthChoice);
            loadNextPart(fourthNext);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += firstNext.build();
        part += secondNext.build();
        part += thirdNext.build();
        part += fourthNext.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        firstNext.registerListeners();
        secondNext.registerListeners();
        thirdNext.registerListeners();
        fourthNext.registerListeners();

        if (subController.has()) {
            return;
        }

        registerFirstListener();
        registerSecondListener();
        registerThirdListener();
        registerFourthListener();
    };
}

var FarmerMaidDrunkChoice = {
    DECLINE: 1,
    HARD: 2,
    TRICK: 3,
    PISS: 4
};
