/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidGirlfriendAccept(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = FarmerMaidGirlfriendChoice.ACCEPT;
    var reqController = ctrl.girlfriend;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var name = ctrl.misc.name();
        var toReturn = `[p]
                            This is how you imagined being a maid would be,
                            at the start of your enslavement.
                            No abuse, no molestation, just you, a broom, a duster, a mop and a house to tidy.
                            While his girlfriend can be a bit [i]bossy[/i] at times,
                            you learn that if you just give her what she wants,
                            she becomes a lot easier to deal with.
                            She isn't around a lot anyway.
                            Always out running [i]errands[/i] during the day.
                        [/p]
                        [p]
                            A few months later, the inevitable happens.
                            Falco's girlfriend has gotten pregnant.
                            The news that he's going to become a parent seems to improve the avian's demeanor, by a lot.
                            You get the feeling he starts to [b]respect[/b] you for the things you do around the house,
                            instead of taking you for granted.
                            After being coddled for his entire life, he's finally starting to mature.
                            Perhaps it's all the farm work turning him into a [b]man[/b].
                            Or maybe it really [i]is[/i] his impending fatherhood.
                        [/p]
                        [p]
                            You get a bit more scraps thrown your way, which you are grateful for.
                            Other than that, you keep working, and so does he.
                            His girlfriend continues to be mostly [i]absent[/i].
                            Even late into her pregnancy, she still goes to wander around the hamlet on a daily basis.
                            You wonder what she's doing all the time.
                            She sure as heck isn't going grocery shopping like Juliet used to.
                            Perhaps she's visiting her own family, or something?
                        [/p]
                        [p]
                            You keep wondering what the human gets up to during the day for several months more.
                            Then, during the birth of their child,
                            it finally becomes clear to you.
                            A healthy baby girl.
                            But instead of a beak, talons, feathers or other avian features,
                            Falco's daughter has a thin coat of brown fur.
                        [/p]
                        [p]
                            [c]
                                [b]
                                    Maid end.
                                [/b]
                            [/c]
                        [/p]
                        [p]
                            [nl]
                            [small]
                                You have reached one of Kobold Adventure's irreversible endings.
                                Your actions have sealed the fate of ${name}.
                                This is where their storyline ends.
                                By saving the game, you can review your timeline using the aStory feature available via the menu.
                                If you wish to tempt fate once more, reload an earlier save, or start a new game and try again.
                                Remember: all things, both good and bad, must always come to an end.
                                The journey is as important as the destination is.
                                Is heaven worth going through hell for?
                            [/small]
                        [/p]`;

        return global.parser.parse(toReturn);
    }


    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {

    };
}
