/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidTooFarFight(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = FarmerMaidTooFarTellChoice.FIGHT;
    var reqController = ctrl.toofarTell;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var name = ctrl.misc.name();
        var toReturn = `[p]
                            Your natural fight or flight responses kicking in, you drop into a combat stance.
                            If the bird wants a tussle, he can bring it on.
                            You bet he's never been in a scrap his entire life.
                            Advantage: kobold.
                            Besides, you've already made it this far, through torture and an entire year's worth of serving these filthy humans.
                            Not to mention the hardships you went through [b]before[/b] your enslavement.
                            You're not going to let your tale end at the hand of some stupid, young eagle!
                        [/p]
                        [p]
                            Falco makes his move, an overhead swing with his knife.
                            You swiftly dodge to the side, but before you manage to counter-attack comes another swipe,
                            this time more of a stab!
                            You dodge backwards, grabbing a conveniently placed stool off the ground and hurling it towards the avian.
                            The wooden piece of furniture hits him in the shoulder, forcing him back a little.
                            With an angry squawk, he kicks the tiny chair away.
                            It seems that all you've managed to do is piss him off even more.
                        [/p]
                        [p]
                            The two of you circle one another, the boy threateningly waving his knife around.
                            He's wielding it like an [b]amateur[/b],
                            but even an untrained fighter can do some serious damage with a sharp blade against an unarmed opponent.
                            He lashes out again, charging towards you, intent on stabbing your gut the way he did his father.
                            But unlike the farmer, you [i]aren't[/i] too flabbergasted to react.
                        [/p]
                        [p]
                            You skillfully push Falco's arm to the side, making his knife harmlessly soar right past you!
                            His defences down, you find the perfect opportunity to strike.
                            You instinctively swing your hand at the eagle's throat,
                            but it is only when your fingers [i]tap[/i] against his feathery neck instead of sinking into his skin,
                            that you remember that you [b]have[/b] no more claws to rake his flesh with!
                        [/p]
                        [p]
                            For a moment, the two of you awkwardly stare at eachother.
                            Then, the bird regains his composure, and [b]sinks[/b] his blade into your chest,
                            stabbing your very heart through a gap in between your ribs.
                        [/p]
                        [p]
                            You stare into his hate-filled eyes, your face uncontrollably drooping.
                            You try to speak, but no words leave your mouth.
                            Your legs grow weak.
                            Your sight goes black.
                            As Falco retracts the knife from your chest,
                            you fall forwards to the ground.
                            The rapidly expanding puddle of your blood mixes with Romeo's.
                        [/p]
                        [p]
                            During your last few moments of consciousness, you think back to when you were little.
                            Playing on the streets of Varanar, with other kobold children.
                            Begging for scraps.
                            How overly ecstatic you got when someone flipped a single coin your way.
                            That is what you want to dream of.
                            But all too soon your thoughts are enveloped by a deep, dark, all-consuming void,
                            as your dying mind can no longer sustain the illusion of peacefulness.
                            Together with you, so too die your memories.
                        [/p]
                        [p]
                            [c]
                                [b]
                                    Reverse vixen end.
                                [/b]
                            [/c]
                        [/p]
                        [p]
                            [nl]
                            [small]
                                You have reached one of Kobold Adventure's irreversible endings.
                                Your actions have sealed the fate of ${name}.
                                This is where their storyline ends.
                                By saving the game, you can review your timeline using the aStory feature available via the menu.
                                If you wish to tempt fate once more, reload an earlier save, or start a new game and try again.
                                Remember: all things, both good and bad, must always come to an end.
                                The journey is as important as the destination is.
                                Is heaven worth going through hell for?
                            [/small]
                        [/p]`;

        return global.parser.parse(toReturn);
    }


    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {

    };
}
