/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidPreAbusive(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.postMaid;
    var subController = ctrl.preParents;
    var changeController = false;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new FarmerMaidAbusive(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            Over the course of the later half of your first month,
                            you continue to stumble upon Falco and Juliet,
                            the bird's [i]hormonal outbursts[/i] growing more severe as time progresses.
                        [/p]
                        [p]
                            A few days after you first encountered them,
                            you find the avian and his mother in the dining room.
                            He's rubbing her bare tits from behind, to his heart's content,
                            while she's trying to eat her meagre lunch, hoping that by [b]ignoring[/b] him, he'll get bored and go away.
                            Bad idea.
                            While you don't stick around to watch, they stay inside of that room for an entire hour,
                            until finally the eagle emerges, a thoroughly sated look on his face.
                        [/p]
                        [p]
                            A week after, while you're busy cleaning the living room,
                            Falco walks in and takes a seat right next to his mother on the couch.
                            He repeatedly places his feathery hand upon her thigh, but she slaps it away time after time again.
                            He doesn't relent, however.
                            After a dozen tries, Juliet reluctantly ceases her efforts to stop him, a defeated sigh denoting her unwillingness.
                            Her son eagerly presses his palm in between her legs,
                            and begins to [b]rub[/b] her loins through her pants right in front of you.
                            Disgusted, you leave the room.
                        [/p]
                        [p]
                            You sleep with a troubled conscience, but at least you're glad [b]you[/b] aren't the one being molested.
                            Things get even worse at the start of your second month.
                            You catch the two on Romeo's bed,
                            the avian ontop of the human,
                            pinning her to the mattress while eagerly kissing her,
                            not an easy feat considering his beak.
                            Oh well, at least that's one room less for you to clean today.
                        [/p]
                        [p]
                            You rarely see the man of the house.
                            He often leaves to work his field long before you get up, and he comes home late, after everyone's already gone to sleep.
                            He must not get a lot of sleep.
                            No wonder his son is running rampant, without a stern father figure around in his life.
                        [/p]
                        [p]
                            Another week later, you find them in the kitchen, where it all began.
                            Juliet is leaning against the counter,
                            her tits bared and her pants pulled down to her knees, her hairy cunt fully exposed.
                            She embarrassedly stares off the the side,
                            while her son leers at her half-naked frame,
                            wildly jerking his uncut, humanoid member.
                            Huh, so he has a [b]human[/b] dick?
                            That's not what you [i]pictured[/i] him with.
                            Must be because he's a crossbreed or something.
                            As the bird shoots you a lewd, suggestive wink,
                            you walk away, fearing he might go after you next.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}
