/**
 * End section of Varanar, Afternoon Three.
 * @param {AfternoonThreeParlorController} controller The Varanar, Afternoon Three controller.
 */
function AfternoonThreeParlorSpareFree(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = ctrl.secondFightChoice.FREE;
    var reqController = ctrl.itemGetFight;
    var changeController = ctrl.spareFree;

    var nextSceneReady = ctrl.nextSceneReady;
    var nextSceneName = ctrl.nextSceneName;
    var nextFolderName = ctrl.nextFolderName;

    var continueId = arguments.callee.name + "ButtonOne";

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        global.kobold.history.shared.varanar.dayThree.afternoon.parlorFreed = true;
        var toReturn = `[p]
                            After a minute of indulging in the rare feeling of [b]pride[/b],
                            your mind settles down from the adrenaline rush that fueled your vicious attack.
                            You did it!
                            You beat the insane man that tried to enslave you!
                            Now to free your fellow kobolds from his apalling rule.
                        [/p]
                        [p]
                            You walk over to the door leading to the [i]break room[/i],
                            and triumphantly swing it open, drawing the attention of the three slaves inside.
                            "[color=blue]Yes, mast-[/color]" the blue one speaks, realizing you aren't the human halfway through her sentence.
                            "[color=blue]Huh? Who are you? A client?[/color]"
                            The green one looks past you, and notices Tychus laying on the floor.
                        [/p]
                        [p]
                            "[color=green]Master?![/color]"
                            Before even offering you a chance to explain what's going on,
                            he rushes past you, crudely pushing you out of the way to check up on the human.
                            The blue one follows suit, kneeling besides Tychus' body.
                            The red one doesn't seem to care all too much.
                            She casually saunters out of the break room, and casually leans against a wall, observing the display.
                        [/p]
                        [p]
                            "[color=green]Master, [b]no[/b]!
                            You [b]KILLED[/b] him![/color]" the green kobold laments hysterically,
                            his loud crying and plentiful tears stressing his apparent [i]fondness[/i] of Tychus.
                            The blue one, luckily, is a bit less [i]indoctrinated[/i], and a bit more [b]reasonable[/b].
                            She presses her hand against her master's chest, and notices the human is still breathing.
                            "[color=blue]Shhh, Green.
                            It's okay, the master's still alive.
                            Look, he's breathing.
                            See?[/color]"
                        [/p]
                        [p]
                            It's like a sparkle of hope lights up in the green kobold's eyes,
                            his Stockholm-syndrome affected mind overjoyous that the human is still alive.
                            He curls up next to Tychus' body, and begins disturbingly rocking back and forth, calming himself down.
                            "[color=green]Master's still alive.[/color]"
                            "[color=blue]That's right, Green.
                            The master'll be fine.
                            I'm going to talk to the client now, okay?[/color]"
                            The only response Blue gets is a slight nod, the other kobold barely even acknowledging her existence,
                            too focused on the person that kept him in captivity.
                        [/p]
                        [p]
                            Rising to her feet, the blue kobold walks over to you, addressing you in a hushed voice, to shield Green from the truth.
                            "[color=blue]Thank goodness.
                            I thought I'd be trapped here forever.
                            Are you with the guild?
                            Did they send you to rescue me?[/color]"
                            Guild?
                            You're not really part of any guild, no.
                            "[color=blue]Oh.
                            Doesn't matter.
                            Thank you regardless.
                            Please excuse Green, he's been here for a [b]long[/b] time.
                            After months of [b]whipping[/b] and [b]torture[/b], your brain kind of starts to go [i]haywire[/i].
                            And I think he was sort of [i]special[/i] to begin with.
                            I hope you understand.[/color]"
                        [/p]
                        [p]
                            You can't imagine what that would be like, but you [i]get it[/i].
                            You ask Blue what she thinks you should do next.
                            She seems far more versed in [i]handling[/i] her [b]emotional[/b] friend than you are,
                            and you'd hate to have to leave someone behind because they [i]think[/i] they like it here.
                            "[color=blue]Don't worry.
                            I'll take him and Red somewhere safe.[/color]"
                            You ask if they have [i]real[/i] names, instead of y'know...[i]colors[/i].
                            "[color=blue]The others, I don't know.
                            They never told, I never asked.
                            Me?
                            My name actually [i]was[/i] Blue.
                            [i]Before[/i] coming to this [b]accursed[/b] place, that is.[/color]"
                        [/p]
                        [p]
                            Oh.
                            [i]Oh.[/i]
                            You didn't mean to offend or anything.
                            "[color=blue]It's fine.
                            Look, it'd be better if we [i]weren't[/i] seen coming out of this building together.
                            How about you get going,
                            and I'll be out with the rest in a minute or two, alright?[/color]"
                            You agree with the blue-scaled kobold's plan.
                            She asks if you've seen Orange around, but you half-heartedly tell her not to worry about Orange.
                            Shrugging, she thanks you one final time, and then you head for the front door, looking both ways to ensure your [i]privacy[/i].
                            Nobody's there.
                        [/p]
                        [p]
                            You cast one final gaze back at the three kobolds.
                            Red seems to understand what's going on, and is pilfering some items from the lobby, preparing to leave.
                            Blue's talking to Green, trying to get him on his feet, lying and saying they're going for a [i]walk[/i].
                            Whatever it takes, you suppose.
                        [/p]
                        [p]
                            You stride out into the empty streets, and wait around the corner.
                            A few minutes later, as she promised, Blue and the other two emerge from the massage parlor.
                            They head the opposite way you went, and disappear into the first side-street.
                            You jog after them, but as you turn the same corner they did, you find not a single trace of the group of three.
                        [/p]
                        [p]
                            Odd.
                            There aren't really any other ways to go.
                            In fact, you think this street is a [b]dead end[/b].
                            Weird.
                            Very weird.
                            Almost like [b]magic[/b].
                            You wonder what that [i]guild[/i] was that Blue spoke of.
                        [/p]
                        [p]
                            Oh well, you'd better get out of here yourself.
                            [b]Before[/b] Tychus wakes up to find his slaves [i]liberated[/i].
                            You walk towards the mercantile district.
                            The sun is slowly starting to set.
                            The afternoon is turning into a dark and cold winter evening.
                            It's time to figure out where you're going to sleep.
                            Maybe tomorrow, you can set some more kobolds free.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the continue button.
     */
    function buildChoice() {
        var disabled = ctrl.continued();
        var choice = `<div class="choicecontainer">`;
        choice += `<button class="button bigbutton continuebutton" id="${continueId}" ${disabled ? "disabled" : ""}>`;
        choice += `Continue &gt;&gt`;
        choice += `</button>`;
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next scene.
     * @param {string} sceneName Name of the scene to load.
     * @param {string} folder Folder of the scene to load.
     */
    function loadNextPart(sceneName, folder) {
        global.ui.fadeOutContent(function () {
            global.sceneEnd();
            global.sceneLoader.loadScene(sceneName, folder);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerContinueListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.continue();
            loadNextPart(nextSceneName, nextFolderName);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        global.ui.applyTheme("varanar_generic");
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        if (!nextSceneReady) {
            part += `<span class="todo">There is no content beyond this point.</span>`;
        }
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        if (ctrl.continued()) {
            return;
        }

        if (nextSceneReady) {
            registerContinueListener();
        }
    };
}
