/**
 * Ruby section of Varanar, Afternoon Three.
 * @param {AfternoonThreeRubyController} controller The Varanar, Afternoon Three controller.
 */
function AfternoonThreeRubyApproach(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = AfternoonThreeInvestigateScreamChoice.APPROACH;
    var reqController = ctrl.scream;
    var subController = ctrl.screamApproach;
    var changeController = ctrl.screamApproach;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";

    var firstNext = new AfternoonThreeRubyBargain(ctrl);
    var secondNext = new AfternoonThreeRubyApproachHandOver(ctrl);

    var firstChoice = AfternoonThreeRubyApproachChoice.BARGAIN;
    var secondChoice = AfternoonThreeRubyApproachChoice.HAND;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var charisma = ctrl.misc.charisma();
        var dick = ctrl.misc.dick();
        global.kobold.history.shared.varanar.dayThree.afternoon.rubyt1 = charisma < 6;
        global.kobold.history.shared.varanar.dayThree.afternoon.rubyt2 = charisma === 6;
        global.kobold.history.shared.varanar.dayThree.afternoon.rubyt3 = charisma > 6;
        global.kobold.history.shared.varanar.dayThree.afternoon.rubyDickt4 = dick > SizeEnum.LARGER;
        global.kobold.history.shared.varanar.dayThree.afternoon.rubyDickt3 = dick > SizeEnum.AVERAGE;
        global.kobold.history.shared.varanar.dayThree.afternoon.rubyDickt2 = dick > SizeEnum.SMALLEST;
        global.kobold.history.shared.varanar.dayThree.afternoon.rubyDickt1 = dick > SizeEnum.NONE;

        var toReturn = `[p]
                            This is shaping up to be a [b]dangerous[/b] situation.
                            For her, because she's making a target of herself;
                            and for you should she spot the necklace in your hands.
                            As a precaution, you hide the pendant in your coin pouch.
                            You know, to be on the safe side.
                        [/p]
                        [p]
                            With the locket hidden,
                            you step out into view, turning the corner to the street the dragoness is in.
                            Finishing her [i]argument[/i] with the balcony-bold, her gaze returns to ground-level.
                            While there are many other kobolds like you around, you are the only one [i]staring[/i] at her.
                            It doesn't take long for her to [b]notice[/b], returning your inquisitive gaze with a [b]hateful[/b] glare.
                        [/p]
                        [p]
                            There's a hint of unbridled, primal fury in her red, raging eyes, probably some leftover from her ancient feral ancestry.
                            You find it hard to repress the instinct to [b]tremble[/b].
                            Fortunately, as the woman advances upon you, she realizes that [b]you[/b] are not the one who stole from her.
                            Her visage and her stance both mellow out, ever so slightly.
                        [/p]
                        [p]
                            The chubby dragoness comes to a halt in front of you,
                            straightening her dress and fixing her posture to look as regal as possible, given the circumstances.
                            She's breathing heavily, the chase and all the yelling clearly having tired her out.
                            The woman doesn't strike you as the [i]sporty[/i] type to begin with.
                        [/p]
                        [p]
                            No, she's more of the [b]pampered princess[/b] kind.
                            Every word that escapes her lips only serves to reinforce that stereotype.
                            "[color=cyan]Ugh, [b]finally[/b] one of you saw reason!
                            Do you know where the thief went?
                            Where is my locket?
                            I [b]demand[/b] that you guide me to it [b]right now[/b]![/color]"
                        [/p]
                        [p]
                            She's [b]definitely[/b] not used to taking [i]no[/i] for an answer, especially not from [i]your kind[/i].
                            In her eyes, kobolds are most likely no more than [b]slaves[/b] and [b]servants[/b],
                            or in the worst case even [b]cattle[/b] that hasn't been [b]butchered[/b] yet.
                            At least she doesn't think [b]you[/b] have her locket.
                            Just that you can lead her to it.
                            You sense an opportunity in the making.
                        [/p]
                        [p]
                            Even though her dress is dirty and slightly ragged, you doubt the woman is [i]poor[/i].
                            She [b]is[/b] a dragoness, after all.
                            And the way she talks makes you believe she might even be some kind of [i]nobility[/i].
                            She's bound to have at least [b]some[/b] coin on her, or maybe some jewelry.
                            And as all dragons, she's [b]stunningly[/b] beautiful.
                            A little chubby, but [i]curvy[/i] in [b]all[/b] the right places.
                        [/p]
                        [p]
                            Her eyes glimmer, her voice is sonorous when not distorted with anger,
                            and her scales are a deep, bright, [b]pristine[/b] shade of red.
                            You bet she's [b]soft[/b] to the touch.
                            That her body has spent [b]days[/b] soaking in milk, mud and other expensive bathing fluids.
                            You find yourself absent-mindedly eyeing her up and down for a few moments, before snapping back to reality.
                            You could get [b]a lot[/b] out of this situation, if you play your cards right.
                        [/p]
                        [p]
                            Or you could be a [i]good[/i] person and simply give it back.
                            That's what a knight would do.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === firstChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${firstId}" ${disabled}>Bargain</button>`;

        var tooltip = global.parser.parse(`What can she offer you in return?`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 230px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === secondChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${secondId}" ${disabled}>Hand it over</button>`;

        var tooltip = global.parser.parse(`Don't be mean. Give the lady her locket back.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 180px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You:</div>`;
        choice += buildFirstChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(firstChoice);
            loadNextPart(firstNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(secondChoice);
            loadNextPart(secondNext);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        global.ui.imageBackground.hide();
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += firstNext.build();
        part += secondNext.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        firstNext.registerListeners();
        secondNext.registerListeners();

        if (subController.has()) {
            return;
        }

        registerFirstListener();
        registerSecondListener();
    };
}

var AfternoonThreeRubyApproachChoice = {
    BARGAIN: 1,
    HAND: 2
};
