/**
 * Ruby section of Varanar, Afternoon Three.
 * @param {AfternoonThreeRubyController} controller The Varanar, Afternoon Three controller.
 */
function AfternoonThreeRubyBody(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = AfternoonThreeRubyBargainChoice.BODY;
    var reqController = ctrl.bargain;
    var subController = ctrl.body;
    var changeController = ctrl.body;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";

    var firstNext = new AfternoonThreeRubyBodyMean(ctrl);
    var secondNext = new AfternoonThreeRubyBodyNice(ctrl);

    var firstChoice = AfternoonThreeRubyBodyChoice.MEAN;
    var secondChoice = AfternoonThreeRubyBodyChoice.NICE;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var male = ctrl.misc.baseGender() === GenderEnum.MALE;
        global.kobold.history.shared.varanar.dayThree.afternoon.rubyBody = true;
        var t1 = global.kobold.history.shared.varanar.dayThree.afternoon.rubyt1;
        var t2 = global.kobold.history.shared.varanar.dayThree.afternoon.rubyt2;
        var t3 = global.kobold.history.shared.varanar.dayThree.afternoon.rubyt3;
        var toReturn = ``;

        if (t1) {
            toReturn += `
                        [p]
                            You kind of [i]regret[/i] not having handed the dragoness the locket straight away.
                            That walk through the streets was [b]humiliating[/b].
                            Kobolds were staring at you.
                            And the worst thing about it is that the lady is entirely [b]oblivious[/b] to how much she was pissing everyone off.
                            You turn to face the woman, but your eyes wander away from her snarling face, towards her shapely, if chubby, body.
                            Wicked, lewd thoughts form inside of your mind.
                        [/p]
                        [p]
                            It doesn't take long for her to notice you staring.
                            "[color=cyan]Stop looking at me like that, [b]peasant[/b]!
                            Go in there already![/color]"
                            But her curves have already have you hooked.
                            Arousal and attraction well up inside of you.
                            You wonder.
                            Should you extort the dragoness, how far could you take it?
                            What is she willing to give in return for her locket?
                        [/p]
                        [p]
                            Your eyes meet hers once more.
                            A mischievous grin forms on your face.
                            Lust clouding your mind, removing your inhibitions.
                            You flat-out tell the lady that if she wants her precious heirloom back,
                            then she'll have to act like the dragoness [b]whore[/b] that she is.
                            If she bends over, spreads her legs and lifts her tail, perhaps you'll consider fetching the trinket.
                        [/p]
                        [p]
                            For a moment, all angriness fades from the woman's face.
                            In its place comes confusion, then disbelief.
                            Realizing she [i]didn't[/i] mishear you, a shocked look creeps onto her visage.
                            It actually feels kind of [i]exhilarating[/i],
                            to know that you're one of the few kobolds who've ever had the pleasure to blackmail a dragoness.
                            To brazenly speak your mind in front of a coddled [b]bitch[/b],
                            and to watch her struggle to even [b]comprehend[/b] your demands.
                            You like it.
                        [/p]
                        [p]
                            At the end of a good bit of imposing silence, the lady seemingly recovers her composure.
                            "[color=cyan]I'm going to [b]pretend[/b] I didn't hear that.
                            Now go get my-[/color]"
                            You cut her off before she can even finish her [i]command[/i].
                            No.
                            You weren't joking.
                            If she wants you to get her locket for her,
                            then you want a piece of her [b]fat ass[/b].
                            And if she doesn't want to put out for you,
                            then she can go [b]dig around[/b] in the dirt [b]herself[/b].
                        [/p]
                        [p]
                            You are clearly upsetting the woman.
                            That comment about her [i]weight[/i], especially, brought a mixture of tears and [b]frustration[/b] to her eyes.
                            Rage boils up inside of the fiery, red-scaled dragoness.
                            She begins to wildly and incoherently [b]screech[/b] one insult after the other at you,
                            sometimes not even bothering to finish one before starting the other.
                            "[color=cyan]You're [b]serious[/b]?!
                            How [b]dare[/b] you!
                            You [b]insolent[/b], good-for-nothing, wretched, wicked, [b]ugly[/b] little thing!
                            You stupid, dumb...
                            I'd [b]never[/b] sink so low as to be [b]used[/b] by a [b]filthy[/b] cretin like you![/color]"
                        [/p]
                        [p]
                            You listen to her stammer on for a while longer.
                            It's actually kind of [i]amusing[/i].
                            She's all bark and no bite.
                            A chained dog, shackled by the need to find her locket once more.
                            You're out of her reach.
                            And if she wants her treat, she's going to have to [b]work[/b] for it.
                        [/p]
                        [p]
                            After about a minute of empty threats, meaningless insults and a few odd references to her [i]father[/i],
                            it finally looks like the chubby bitch is starting to run out of steam.
                            "[color=cyan]I'm [b]not[/b] going to-[/color]"
                            Once again, you cut her off mid-sentence, relishing in being able to exert [b]dominance[/b], for once.
                            You ask the woman how much the locket means to her.
                            "[color=cyan]It's an important keepsake!
                            I can't lose it in some [b]slum[/b] like this.[/color]"
                            Well, if she wants her [i]important keepsake[/i] back, then you want to [b]fuck[/b].
                            Simple as that.
                        [/p]
                        [p]
                            The lady is almost reduced to tears.
                            "[color=cyan]You can't make me do this!
                            You [b]can't[/b]!
                            I [b]demand[/b] that you cease this nonsense [b]at once[/b]!
                            Go bring me my locket [b]now[/b]!
                            Or else I'll-[/color]"
                            Or else she'll what?
                            Go home empty-handed, crying about how you were mean to her?
                            Ask for another kobold's help?
                            Good luck with that.
                            They'll want exactly the same as what you are asking for, if not more than just a single romp.
                            If they'll help at all.
                        [/p]
                        [p]
                            She can run away and fetch the guards,
                            but good luck finding this same alleyway once more,
                            through the twisting maze of streets that is the kobold district.
                            There's probably a dozen or more alleys exactly like it.
                            And by the time she does find this spot once more,
                            her locket may already be gone.
                        [/p]
                        [p]
                            So she's stuck with [b]you[/b].
                            And frankly, you're getting [b]sick[/b] of her [b]shit[/b].
                            You've led her bratty, whining ass all the way here, despite her constant complaints and insults.
                            You could have ignored her and went about your day.
                            But you didn't.
                            She should be grateful for that.
                            You [b]deserve[/b] a reward.
                            And if she's not going to give you what you want, then she can kiss her locket goodbye,
                            because without your help, she's [b]never[/b] going to see it again.
                        [/p]
                        [p]
                            The dragoness can no longer hold back her tears.
                            They liberally flow down over her cheeks, before dripping to the ground below.
                            Her regal posture falters, replaced  by a trembling stance that radiates fear and uncertainty.
                            Her voice, slightly hoarse from all the yelling, has lost most of its booming charm.
                            "[color=cyan]Y-you really want to...
                            This isn't some kind of [b]sick[/b] and [b]twisted[/b] joke?
                            Heavens protect me.
                            Father, I'm sorry.[/color]"
                        [/p]
                        [p]
                            Good enough.
                            You take the woman's words as a sign she's giving in to your demands.
                            You reach forwards, and forcefully grab her hand.
                            Her scales are [b]soft[/b] and [b]warm[/b].
                            The lady flinches.
                            She [b]wants[/b] to fight against your grasp [b]so badly[/b],
                            but thinking of her locket keeps her pacified and docile, for now.
                            She doesn't resist as you lead her into the abandoned hovel.
                        [/p]
                        [p]
                            The inside of the shack doesn't look [i]too[/i] bad.
                            While definitely decaying, there's signs of someone having lived here at one point or another.
                            You'd reckon it's been at least a few months since anyone's last stepped foot in here.
                            A pretty unhygienic mattress dominates most of the muddy dirt-floor.
                            You're surprised it hasn't been stolen yet.
                            Then again, you're not sure whether those stains on it are [i]food[/i]-, [i]cum[/i]- or [b]blood[/b]-stains.
                        [/p]
                        [p]
                            Does it even matter?
                            You're not the one who'll be on bottom this time around.
                            If anything, you're pleased that there's something to lay on,
                            so [i]her highness[/i] won't have to wallow in the dirt.
                            The dragoness recoils at the sight of the filthy sack of straw.
                            "[color=cyan]Y-you're making me lie down on [i]that[/i]?!
                            But that's a kobold's bed.
                            It's all [b]dirty[/b] and [b]grimy[/b]![/color]"
                        [/p]
                        [p]
                            You wordless push the lady forwards, towards the bed.
                            If it's dirty and grimy, then it fits her soul perfectly.
                            And if she doesn't stop complaining,
                            it'll fit her [b]cunt[/b] as well by the time you're done with her.
                            Your threat suffices to silence the woman.
                            Will you keep being mean to her, or will you relent and show her some kindness?
                        [/p]`;
        } else if (t2) {
            toReturn += `
                        [p]
                            The dragoness is kind of [b]mean[/b].
                            While somewhat [i]tolerable[/i] when speaking to you,
                            it is [b]very[/b] clear that you are the [b]exception[/b], and not the rule.
                            She constantly berates and belittles kobolds as a whole.
                            And you don't think that's very appropriate.
                            You turn to face the lady, but your eyes wander away from her expectant face, towards her shapely, if chubby, body.
                            Wicked, lewd thoughts form inside of your mind.
                        [/p]
                        [p]
                            It doesn't take long for her to notice your ogling.
                            "[color=cyan]S-stop that!
                            It's embarrassing!
                            You're not [b]worthy[/b] of looking at me, let alone in [b]that[/b] manner![/color]"
                            Arousal and attraction well up inside of you.
                            You wonder.
                            Should you extort the dragoness, how far could you take it?
                            What is she willing to give in return for her locket?
                        [/p]
                        [p]
                            Your eyes meet hers once more.
                            A mischievous grin forms on your face.
                            Lust clouds your mind, removing your inhibitions.
                            You only live once, right?
                            And fortune favors the bold.
                            You flat-out tell the lady that if she wants her locket back,
                            then you want to have [b]sex[/b] with her.
                        [/p]
                        [p]
                            For a moment, all angriness fades from the woman's face.
                            In its place comes confusion, then disbelief.
                            Realizing she [i]didn't[/i] mishear you, a shocked look creeps onto her visage.
                            It actually feels kind of [i]exhilarating[/i],
                            to know that you're one of the few kobolds who've ever had the pleasure to blackmail a dragoness.
                            To outright [b]tell her[/b] that you want to [b]fuck[/b],
                            and have her actually [b]consider[/b] actually doing it.
                        [/p]
                        [p]
                            At the end of a good bit of imposing silence, the lady seemingly recovers her composure.
                            Still, she's quite a bit [i]shook[/i] from your proposal.
                            "[color=cyan]I-I'm a [b]dragon[/b]!
                            Even if I [b]wanted[/b] to bed a [b]lowly kobold[/b] like [b]you[/b],
                            I simply [b]can't[/b]!
                            Think of the [b]scandal[/b], should anyone find out.
                            My reputation would be [b]ruined[/b]![/color]"
                            Well, then she can go fetch her pendant herself.
                            If she would rather dig through the [b]dirt[/b] than spend some [b]quality time[/b] with you,
                            so be it.
                        [/p]
                        [p]
                            You are clearly upsetting the woman.
                            You know that she [b]isn't[/b] going to retrieve her locket [i]herself[/i].
                            She didn't [i]immediately[/i] discard the idea of the two of you having sex, though.
                            So, some part of her mind must understand that she won't see her heirloom again without spreading her legs for you.
                            Or maybe she isn't as averse to the whole idea as she makes herself out to be.
                        [/p]
                        [p]
                            "[color=cyan]Listen, you're not [i]too bad[/i] as far as kobolds go,
                            but you can't seriously expect me to lift my tail for someone I met mere minutes ago![/color]"
                            Well, you can say the same.
                            Why should [b]you[/b] go get her locket, despite not even knowing her?
                            "[color=cyan]Because [b]I[/b] am a dragon, and [b]you[/b] are a [b]kobold[/b].
                            You are [b]supposed[/b] to serve me![/color]"
                            That's nice and all, but you're in the [b]kobold district[/b].
                            The one place in Varanar where your kind [b]doesn't[/b] have to take shit from other races, dragons included!
                        [/p]
                        [p]
                            Instead of arguing about it, why don't the two of you go get [i]more acquainted[/i]?
                            By the time she's upheld her part of the deal, you'll both know eachother [i]inside out[/i].
                            You chuckle at your own joke.
                            The lady doesn't seem to find it all too funny.
                            But still, she relents, letting out a long-drawn, defeated sigh.
                        [/p]
                        [p]
                            "[color=cyan]In return, you will find my locket for me?[/color]"
                            Yes, you will.
                            You promise.
                            "[color=cyan]And this is the [b]only[/b] way I can persuade you?
                            You won't settle for a kiss, or a [i]hug[/i], perhaps?[/color]"
                            Nope.
                            Her body.
                            Any way you want it.
                            She looks away to the side, visibly debating whether or not she should give in to your demands.
                            Ultimately, she makes a choice.
                        [/p]
                        [p]
                            "[color=cyan]Y-you leave me with little choice.
                            If that is the price I must pay to regain my locket, then [b]fine[/b].
                            But not a word of this to [b]anyone[/b], understand?!
                            For [b]your[/b] sake as much as mine.[/color]"
                            You promise that your lips are sealed.
                            [b]If[/b] she plays along, that is.
                        [/p]
                        [p]
                            You reach forwards, and grab her hand.
                            Perhaps a little too impatient, you end up tugging her forwards a little.
                            The lady flinches.
                            She [b]wants[/b] to fight against your grasp,
                            but thinking of her locket keeps her pacified and docile.
                            She doesn't resist as you lead her into the abandoned hovel.
                        [/p]
                        [p]
                            The inside of the shack doesn't look [i]too[/i] bad.
                            While definitely decaying, there's signs of someone having lived here at one point or another.
                            You'd reckon it's been at least a few months since anyone's last stepped foot in here.
                            A pretty unhygienic mattress dominates most of the muddy dirt-floor.
                            You're surprised it hasn't been stolen yet.
                            Then again, you're not sure whether those stains on it are [i]food[/i]-, [i]cum[/i]- or [b]blood[/b]-stains.
                        [/p]
                        [p]
                            While you're pleased that there's at least [i]something[/i] to lay on,
                            the dragoness recoils at the sight of the filthy sack of straw.
                            "[color=cyan]We're not going to do it on [b]that[/b], are we?!
                            That's a kobold's bed!
                            It's all [b]dirty[/b] and [b]grimy[/b].[/color]"
                        [/p]
                        [p]
                            You reply that you [b]are[/b], in fact, a kobold, so it'll do [b]fine[/b].
                            Unless she'd rather fuck in the [b]dirt[/b] instead?
                            She doesn't dignify your rhetorical question with a response.
                            To egg her on, you push the lady forwards, towards the bed.
                            Will you be mean to her, or will you relent and show her some kindness?
                        [/p]`;
        } else {
            toReturn += `
                        [p]
                            While she was a little upset at first, the dragoness has been nothing but [b]nice[/b] to you.
                            Asking her for money would be downright [b]rude[/b].
                            No, no.
                            An aspiring knight like yourself needs no monetary compensation.
                            However, as you turn to face the lady, your eyes wander away from her expectant face, towards her shapely, if chubby, body.
                            You think you know what you want in return for your [i]services[/i].
                        [/p]
                        [p]
                            It doesn't take long for the woman to notice your ogling,
                            and while she straightens out her dress a little,
                            she doesn't quite seem to [i]mind[/i].
                            "[color=cyan]Like what you see?[/color]" she coyly asks.
                            Yes, you most definitely do.
                            She's [b]beautiful[/b].
                            Absolutely [b]stunning[/b].
                        [/p]
                        [p]
                            Your words flatter the lady.
                            Sensing an opportunity, you begin to work your magic.
                            You mention that she probably looks even [b]better[/b] underneath that pretty robe of hers.
                            She seems flustered, but not at all insulted.
                            "[color=cyan]No, no.
                            There are plenty more attractive dragonesses than I.[/color]" she retorts,
                            her down-to-earth response bringing down the mood a little.
                        [/p]
                        [p]
                            While she's probably right, you decide to humor her a little.
                            You mention that if there are indeed prettier ladies around, you have yet to meet them.
                            Her blush deepens.
                            "[color=cyan]You're just saying that.[/color]"
                            In fact, you bet she's the most gorgeous woman around!
                            Truly, the [b]princess[/b] of the kobold district!
                            "[color=cyan]Such a charmer.
                            And you, holding my hand and all, must be my [b]${male ? `prince` : `spouse`}[/b], then?[/color]"
                        [/p]
                        [p]
                            She's completely [b]swooned[/b].
                            Perfect.
                            Time to lure her in.
                            Sure, you're her ${male ? `prince` : `lover`}, and together you rule the entire neighbourhood!
                            You shoot the lady a wicked smile.
                            Does she know what else ${male ? `princes and princesses` : `princesses and their lovers`} do together?
                            "[color=cyan]Umm...they hug?[/color]"
                            Your grin grows more sultry.
                            Aaaand?
                            "[color=cyan]They kiss.[/color]"
                            You add a wink.
                            A lewd smirk matching your own grows on her face.
                            "[color=cyan]And they [b]fuck[/b].[/color]"
                        [/p]
                        [p]
                            Finally, she understands, but the [b]crudeness[/b] of her words leaves you speechless.
                            Despite your charismatic appearance, you are left completely flabbergasted.
                            Maybe you heard her wrong?
                            No, you can't have.
                            The passionate look on her face speaks volumes.
                            You think the dragoness wants to have sex with you as much as you want to do it with her!
                        [/p]
                        [p]
                            But why?
                            You're a [b]kobold[/b].
                            A reasonably good looking kobold that helped her when nobody else would,
                            and then overwhelmed her with [b]flattery[/b] and [b]kind words[/b].
                            Actually, you're starting to see why she might want the same thing you were after.
                            The lady extends her hand.
                            You eagerly take it, and the two of you enter the abandoned hovel in search of some [i]privacy[/i].
                        [/p]
                        [p]
                            The inside of the shack doesn't look [i]too[/i] bad.
                            While definitely decaying, there's signs of someone having lived here at one point or another.
                            You'd reckon it's been at least a few months since anyone's last stepped foot in here.
                            A pretty unhygienic mattress dominates most of the muddy dirt-floor.
                            You're surprised it hasn't been stolen yet.
                            Then again, you're not sure whether those stains on it are [i]food[/i]-, [i]cum[/i]- or [b]blood[/b]-stains.
                        [/p]
                        [p]
                            While you're pleased that there's at least [i]something[/i] to lay on,
                            the dragoness recoils at the sight of the filthy sack of straw.
                            "[color=cyan]Yuck.
                            I suppose it was dumb of me to expect an abandoned shanty in the middle of a dark,
                            kobold district alleyway to be [i]clean[/i].
                            It's all [b]dirty[/b] and [b]grimy[/b].
                            But oh well, I was planning on washing up once I got home anyway.
                            A [i]bit[/i] more dirt won't kill me.
                            This place will do fine.[/color]"
                        [/p]
                        [p]
                            You're, uh, glad she likes it?
                            "[color=cyan]It beats making love in the [b]dirt[/b],
                            or worse yet: in the alley, where any passing commoner could see us.[/color]"
                            Good point.
                            So, this [b]is[/b] happening.
                            With how [i]vulgar[/i] she was,
                            you're thinking the lady might be into some [i]kinky[/i] things.
                            Do you want to try being mean to her, or will you continue to be nice?
                        [/p]`;
        }

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === firstChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${firstId}" ${disabled} disabled>Mean</button>`;

        var tooltip = global.parser.parse(`Show this bitch who's boss. [todo]Unavailable[/todo]`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 190px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === secondChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${secondId}" ${disabled}>Nice</button>`;

        var tooltip = global.parser.parse(`Be kind and gentle.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 140px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You are:</div>`;
        choice += buildFirstChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(firstChoice);
            loadNextPart(firstNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(secondChoice);
            loadNextPart(secondNext);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        global.ui.imageBackground.hide();
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += firstNext.build();
        part += secondNext.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        firstNext.registerListeners();
        secondNext.registerListeners();

        if (subController.has()) {
            return;
        }

        registerFirstListener();
        registerSecondListener();
    };
}

var AfternoonThreeRubyBodyChoice = {
    MEAN: 1,
    NICE: 2
};
