/**
 * Ruby section of Varanar, Afternoon Three.
 * @param {AfternoonThreeRubyController} controller The Varanar, Afternoon Three controller.
 */
function AfternoonThreeRubyKissReturn(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = AfternoonThreeRubyKissChoice.RETURN;
    var reqController = ctrl.kiss;
    var changeController = ctrl.kissReturn;

    var nextSceneReady = ctrl.nextSceneReady;
    var nextSceneName = ctrl.nextSceneName;
    var nextFolderName = ctrl.nextFolderName;

    var continueId = arguments.callee.name + "ButtonOne";

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        global.kobold.history.shared.varanar.dayThree.afternoon.rubyLocket = true;
        var startBoy = global.kobold.history.scenes["Introduction"].gender === GenderEnum.MALE;
        var t1 = global.kobold.history.shared.varanar.dayThree.afternoon.rubyt1;
        var t2 = global.kobold.history.shared.varanar.dayThree.afternoon.rubyt2;
        var t3 = global.kobold.history.shared.varanar.dayThree.afternoon.rubyt3;
        var toReturn = ``;
        
        if (t1) {
            toReturn += `
                        [p]
                            You relish this moment, having dreamt of being kissed by a dragoness ever since you were a little ${startBoy ? `boy` : `girl`}.
                            Despite practically having [b]forced[/b] her into this, it still feels oh-so [b]right[/b].
                            Sadly, despite the overly long build-up, the kiss lasts for all but the blink of an eye.
                            You snap back to reality, as she pulls away quite crudely, her lips leaving yours.
                        [/p]
                        [p]
                            The woman spits on the ground in disgust, wiping her mouth with her dress.
                            "[color=cyan]Eugh!
                            Gross, gross, [b]gross[/b]!
                            Give me back my locket![/color]"
                            Well, it wasn't much, but she held up her side of the deal.
                            You present the pendant to her.
                            She roughly [b]snatches[/b] it from your palm,
                            turns around and [b]storms[/b] out of the alleyway, leaving you all alone,
                            still lightheaded from the little slice of heaven you just experienced.
                        [/p]
                        [p]
                            Wow.
                            That was [b]incredible[/b]!
                            You might have pushed her a little [i]too hard[/i], but the kiss was all worth it.
                            You wonder if knights get kisses like that all the time.
                            You hope they do.
                            Heck, you hope they get to pick and choose who they kiss.
                            If they do, you're going to become one, you're going to find the chubby dragoness,
                            and you're going to make her kiss you [b]over[/b] and [b]over[/b] and [b]over[/b] again until she [b]likes[/b] it, and then some.
                        [/p]
                        [p]
                            Through the various overhead obstructions and light-blocking fabrics,
                            you notice the sky is slowly turning dark, and the sun is starting to set.
                            The afternoon is turning into an early winter night.
                            It's time to leave the kobold district.
                            You exit the alleyway, and head for the mercantile quarter,
                            hoping to find somewhere warm to spend the night,
                            or at least another dragoness to kiss.
                        [/p]`;
        } else if (t2) {
            toReturn += `
                        [p]
                            It lasts for less than a second,
                            but it's a second you'll remember for the rest of your life.
                            The dragoness pulls back, her cherry-like [b]taste[/b] lingering on your lips.
                            As you open your eyes, you can see that she's blushing.
                            "[color=cyan]Don't tell [b]anyone[/b] about this.
                            Not a living soul.[/color]"
                        [/p]
                        [p]
                            You promise you won't.
                            "[color=cyan]Good.
                            Now if you'll excuse me, I have better places to be than [b]here[/b].[/color]"
                            That being said, the lady turns around and promptly takes her leave.
                            You are left alone in the alleyway, still lightheaded from the little slice of heaven you just experienced.
                        [/p]
                        [p]
                            Wow.
                            That was [b]incredible[/b]!
                            You may have lied a little, but you did the right thing, and your reward was the best thing ever!
                            You wonder if knights get kisses like that all the time.
                            You hope they do.
                            When you become one, you'll get kissed by [b]everyone[/b] you save!
                            Of course, you doubt everyone's as good as kissing as the chubby dragoness was.
                            But still, if you kiss enough people, surely you're bound to run into someone as tender as her.
                        [/p]
                        [p]
                            Through the various overhead obstructions and light-blocking fabrics,
                            you notice the sky is slowly turning dark, and the sun is starting to set.
                            The afternoon is turning into an early winter night.
                            It's time to leave the kobold district.
                            You exit the alleyway, and head for the mercantile quarter,
                            hoping to find somewhere warm to spend the night,
                            or maybe another kiss to earn.
                        [/p]`;
        } else {
            global.kobold.history.shared.varanar.dayThree.afternoon.rubyName = true;
            toReturn += `
                        [p]
                            Your lips are locked for several seconds.
                            The kiss isn't very deep, but it's downright [b]lovely[/b] nonetheless.
                            It feels so [b]right[/b].
                            Like something you didn't know was missing from your life until this very moment.
                            You melt like warm butter in her gentle grasp.
                            The subtle, distinctly cherry-flavored taste of her lips dominates your mind.
                            You must have died in that shack, and went to heaven.
                        [/p]
                        [p]
                            After what feels like an eternity of bliss, the dragoness finally pulls back from the kiss.
                            You hear her speak, something about owing you one, but you can't quite make it out.
                            You are absolutely [b]stunned[/b].
                            Luckily, you snap from your dazed state just in time to catch her name.
                            [b]Ruby[/b].
                        [/p]
                        [p]
                            You attempt to form a coherent response, but all you manage to utter is a few, happy-sounding grunts, groans and sighs.
                            She giggles ever-so-softly.
                            Then, the lady bids her goodbyes.
                            You manage a small waving motion, before she turns around and walks away.
                            You stare at her shapely frame, until it disappears around the corner.
                        [/p]
                        [p]
                            Wow.
                            That was [b]incredible[/b].
                            Do knights get rewarded like this all the time?
                            If so, you [b]really[/b] want to be one.
                            And by helping out a princess in need, you feel like you've taken a step on the right path.
                            If you can keep this up, you'll be a kobold knight in no time!
                            And then you'll get to kiss Ruby again.
                            Oh boy, you can't wait!
                        [/p]
                        [p]
                            Through the various overhead obstructions and light-blocking fabrics,
                            you notice the sky is slowly turning dark, and the sun is starting to set.
                            The afternoon is turning into an early winter night.
                            It's time to leave the kobold district.
                            You exit the alleyway, and head for the mercantile quarter,
                            hoping to find somewhere warm to spend the night,
                            or maybe another chance to earn a kiss.
                        [/p]`;
        }

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the continue button.
     */
    function buildChoice() {
        var disabled = ctrl.continued();
        var choice = `<div class="choicecontainer">`;
        choice += `<button class="button bigbutton continuebutton" id="${continueId}" ${disabled ? "disabled" : ""}>`;
        choice += `Continue &gt;&gt`;
        choice += `</button>`;
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next scene.
     * @param {string} sceneName Name of the scene to load.
     * @param {string} folder Folder of the scene to load.
     */
    function loadNextPart(sceneName, folder) {
        global.ui.fadeOutContent(function () {
            global.sceneEnd();
            global.sceneLoader.loadScene(sceneName, folder);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerContinueListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.continue();
            loadNextPart(nextSceneName, nextFolderName);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        if (!nextSceneReady) {
            part += `<span class="todo">There is no content beyond this point.</span>`;
        }
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        if (ctrl.continued()) {
            return;
        }

        if (nextSceneReady) {
            registerContinueListener();
        }
    };
}
