/**
 * Fleeing section of Varanar, Night Two.
 * @param {NightTwoController} controller The Night Two controller.
 */
function NightTwoAlleyRunFail(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var biteId = arguments.callee.name + "ButtonOne";
    var stayId = arguments.callee.name + "ButtonTwo";
    var eagerId = arguments.callee.name + "ButtonThree";

    var toBite = new NightTwoAlleyBite(ctrl);
    var toStay = new NightTwoAlleyStay(ctrl);
    var toEager = new NightTwoAlleyEager(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var agiFail = ctrl.misc.agility() < 6;
        var toReturn = `[p]
                            You envision your way up along the side of the wall on the far end of the alley.
                            First you'll run towards it, then you intend to [b]jump[/b], and using the momentum gained from your dash,
                            you'll kick yourself off of one of the walls, ending up high enough to latch on to the top of the brick wall.
                            From then, it's a matter of pulling yourself up, and after that you'll be in the clear.
                        [/p]
                        [p]
                            With your plan visualized, it's time to put it into motion.
                            You [b]sprint[/b] forwards, accelerating at a rapid pace.
                            Running past the last of the barrels, you [b]leap[/b] from the ground as high up as you can.
                            Mid-air, you press your right foot against the alley-wall, and expertly push yourself up even higher,
                            converting horizontal momentum into vertical lift.
                        [/p]`;

        if (agiFail) {
            toReturn += `[p]
                            Alas, you seem to have misjudged the actual height of the wall.
                            You reach for the top, yet come just a few inches short of being able to grab onto it.
                            Without anything to grip onto, your entire body smacks into the solid barrier, and you fall to the ground.
                            Slightly dazed, you slump down with your back against the wall, just in time to witness one of the humans entering the alleyway.
                        [/p]
                        ${global.ui.condFail(`Agility below 6`)}`;
        } else {
            toReturn += `[p]
                            Exactly as planned, you narrowly reach the height required to grab the top of the wall,
                            your claws digging in to the mortar in between the bricks ever so slightly.
                            Despite trying with all your might, however, you utterly [b]fail[/b] to pull your meagre bodyweight up onto the barrier.
                            You struggle in vain for nearly half a minute to try and lift yourself up higher, before your arms can carry your weight no longer.
                            You fall to the ground, landing painfully on your rear.
                            Slightly dazed, you slump down with your back against the wall, just in time to witness one of the humans entering the alleyway.
                        [/p]
                        ${global.ui.condFail(`Strength below 6`)}`;
        }

        toReturn += `   [p]
                            Paralyzed with a mixture of fear and stinging pain, you are frozen in place as the ruffian slowly approaches.
                            He clearly knows you're there, staring directly at your downed form, yet he isn't calling for his friends.
                            Perhaps he wants the pleasure of [i]beating you to death[/i] all for himself.
                            You [i]should[/i] ready yourself for combat,
                            yet your body and your mind both feel [b]far[/b] too exhausted and utterly [b]defeated[/b] to even [b]attempt[/b] to put up a fight.
                        [/p]
                        [p]
                            The scoundrel stops just a few feet in front of you.
                            Glaring down at you with angry, hate-filled eyes, he speaks.
                            "[color=dred]You're that lizard we're chasin'.[/color]"
                            His voice is bass, and some of his words come out slurred due to his heavy intoxication.
                            Still, not unfamiliar with being drunk yourself, you understand every word he's saying.
                            "[color=dred]My friends want to [b]kill[/b] you.
                            I think that'd be a [b]waste[/b].
                            You'll make a fine [b]kobold whore[/b] one day,
                            and Varanar could use more cheap pieces of [b]ass[/b].[/color]"
                        [/p]
                        [p]
                            A sadistic smile forms atop of the bulky hoodlum's face.
                            He moves one of his hands towards his groin, and casually begins to unbutton his pants.
                            "[color=dred]I came into this alley to take a leak,
                            and that's exactly what I'm gonna do.
                            You stay put like the lil' [b]slut[/b] you are,
                            and I won't have a reason to call my buddies over here, you got that?[/color]"
                            Without even bothering to wait for a response, the man promptly lowers his underwear,
                            the stench of unwashed human groin creeping into your nostrils as his [b]huge[/b],
                            heavily oversized flaccid member is made bare to you.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildBiteChoice() {
        var disabled = ctrl.alleyRunFail.has() ? "disabled" : "";
        var isSelected = ctrl.alleyRunFail.get() === NightTwoAlleyRunFailChoice.BITE;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${biteId}" ${disabled}>Bite</button>`;

        var tooltip = global.parser.parse(`What the hell does this guy think he's doing?! Bite his dick off. That'll show him.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 160px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildStayChoice() {
        var disabled = ctrl.alleyRunFail.has() ? "disabled" : "";
        var isSelected = ctrl.alleyRunFail.get() === NightTwoAlleyRunFailChoice.STAY;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${stayId}" ${disabled}>Stay still</button>`;

        var tooltip = global.parser.parse(`You don't want to get bludgeoned to death by a bunch of angry, drunken humans.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 160px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildEagerChoice() {
        var disabled = ctrl.alleyRunFail.has() ? "disabled" : "";
        var isSelected = ctrl.alleyRunFail.get() === NightTwoAlleyRunFailChoice.EAGER;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${eagerId}" ${disabled}>Open your mouth</button>`;

        var tooltip = global.parser.parse(`You thought this guy was going to [b]kill[/b] you. Now that you know he isn't, you might as well have some fun.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 160px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You: </div>`;
        choice += buildBiteChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildStayChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + biteId), $("#" + stayId), $("#" + eagerId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerBiteListener() {
        $("#" + biteId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.alleyRunFail.set(NightTwoAlleyRunFailChoice.BITE);
            loadNextPart(toBite);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerStayListener() {
        $("#" + stayId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.alleyRunFail.set(NightTwoAlleyRunFailChoice.STAY);
            loadNextPart(toStay);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerEagerListener() {
        $("#" + eagerId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.alleyRunFail.set(NightTwoAlleyRunFailChoice.EAGER);
            loadNextPart(toEager);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += ctrl.alleyRunFail.change();
        part += buildChoice();
        part += `</div>`;
        part += toBite.build();
        part += toStay.build();
        part += toEager.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        toBite.registerListeners();
        toStay.registerListeners();
        toEager.registerListeners();

        if (ctrl.alleyRunFail.has()) {
            return;
        }

        registerBiteListener();
        registerStayListener();
        registerEagerListener();
    };
}

var NightTwoAlleyRunFailChoice = {
    BITE: 1,
    STAY: 2,
    EAGER: 3
};

