

// SCENE FarmerMaid

// scenes\Enslavement\DayTwo\FarmerMaid\kid\drunk\satisfy\dad\FarmerMaidDrunkSatisfyStay.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidDrunkSatisfyStay(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = FarmerMaidDrunkSatisfyDadChoice.STAY;
    var reqController = ctrl.death;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var name = ctrl.misc.name();
        var toReturn = `[p]
                            Yes.
                            You accept.
                            You want to stay here, with Falco.
                            You want to raise your child together,
                            and you want to grow old with him.
                            You...you love him.
                            His eyes light up at that last part.
                        [/p]
                        [p]
                            "[color=yellow]I...I...[/color]" he can't find the words to express himself with.
                            How cute.
                            You press your muzzle against his beak, and give him a single, tender kiss.
                            He lets out a happy sigh, and takes your hand.
                            "[color=yellow]I'll work the farm, from now on.
                            Keep us both fed.
                            Maybe see if there's some carpentry tools in the shed,
                            so I can build [b]our[/b] baby a crib.[/color]"
                        [/p]
                        [p]
                            His words fill your heart with joy.
                            [b]Our[/b] baby.
                            You like the sound of that.
                            "[color=yellow]Let's get inside.
                            It's starting to get cold.
                            I bet it'll be far warmer in bed.[/color]"
                            Falco winks.
                            You gladly agree.
                        [/p]
                        [p]
                            Hand in hand, you walk back to the house.
                            Right before you enter the door,
                            the bird [b]lifts[/b] you off the ground.
                            Like a princess after her wedding,
                            he carries you inside, up the stairs, and into his bedroom.
                            The two of you make passionate love althroughout the night.
                        [/p]
                        [p]
                            Thus begins your life as the eagle's wife.
                            You live a meagre existence, without much luxury,
                            but you are happy, and so is he.
                            He makes sure there's always plenty of food to go around,
                            and he really does end up building that crib,
                            just in time for the birth of your baby.
                            A healthy boy.
                            Crossbreed, avian and kobold.
                            A feathery lizard.
                            [b]Your[/b] feathery lizard.
                        [/p]
                        [com]
                        [p]
                            You love and care for your child all day long,
                            while your unmarried husband works his ass off to keep you fed, clothed and out of harm's way.
                            At the end of the day, you warmly welcome him home,
                            
                        [/p]
                        [/com]
                        [p]
                            [c]
                                [b]
                                    Dinosaur end.
                                [/b]
                            [/c]
                        [/p]
                        [p]
                            [nl]
                            [small]
                                You have reached one of Kobold Adventure's irreversible endings.
                                Your actions have sealed the fate of ${name}.
                                This is where their storyline ends.
                                By saving the game, you can review your timeline using the aStory feature available via the menu.
                                If you wish to tempt fate once more, reload an earlier save, or start a new game and try again.
                                Remember: all things, both good and bad, must always come to an end.
                                The journey is as important as the destination is.
                                Is heaven worth going through hell for?
                            [/small]
                        [/p]`;

        return global.parser.parse(toReturn);
    }


    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {

    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\kid\drunk\satisfy\dad\FarmerMaidDrunkSatisfyStay.js

// scenes\Enslavement\DayTwo\FarmerMaid\kid\drunk\satisfy\dad\FarmerMaidDrunkSatisfyFree.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidDrunkSatisfyFree(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = FarmerMaidDrunkSatisfyDadChoice.LEAVE;
    var reqController = ctrl.death;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var name = ctrl.misc.name();
        var toReturn = `[p]
                            No.
                            You can't accept that invitation.
                            You [i]want[/i] to stay here, with Falco,
                            but you just can't.
                            He'd get in trouble if people found out he was [i]seeing[/i] a kobold.
                            Especially in a narrow-minded community such as this one.
                            The past year, you've been chained to this house like a dog on a leash.
                            You've been kept here like a bird in a cage.
                            It's time for you to fly.
                            You hope he understands.
                        [/p]
                        [p]
                            Falco gives you a small, teary-eyed nod.
                            Hanging his head in defeat, having lost his father, his mother and now his lover all in a single day,
                            he silently strolls towards the backdoor.
                            After casting one final glance at you,
                            he vanishes into the home that you were kept in for over a year.
                            That's the last you ever see of him.
                        [/p]
                        [p]
                            You head for Varanar.
                            With no money, no place to stay, a baby on the way and no clothing but your skimpy maid outfit,
                            you end up sleeping in the streets more than once.
                            You stop by Seki's place, but the old bird must have moved away or something.
                            His house is abandoned.
                            You try to find a legitimate job, but nobody wants to hire a kobold, let alone a pregnant one.
                        [/p]
                        [p]
                            Eventually, thanks to your maid costume, you manage to get a job at a sleazy inn, cleaning rooms.
                            You get harassed by many clients, but none go beyond touching you a little.
                            Still having nowhere to sleep, you spend your nights in various alleyways.
                            A few weeks later, at night, you give birth to your child.
                            A healthy kobold baby boy.
                            You press him close to you, to keep him warm throughout the cold night.
                        [/p]
                        [p]
                            In the morning, you return to your workplace to find it closed.
                            City guards raided the place, found a bunch of stolen weapons, drugs and other illicit properties in the basement.
                            Out of work, on your first day as a mother.
                            Off to a good start.
                        [/p]
                        [p]
                            You frantically look, but fail to find anywhere else to work.
                            While hiring a [i]pregnant[/i] kobold is taboo,
                            hiring a kobold with a day-old child is even less accepted.
                            You get chased out of several places for even [b]daring[/b] to ask if they could consider employing you.
                            After not getting anything to eat for over a week, you turn to begging.
                        [/p]
                        [p]
                            A year of living on the street goes by.
                            You beg for scraps, for coins and for people [i]not[/i] to beat you.
                            Sometimes you manage to scrounge up enough money to buy a bit of bread to feed you and your growing child.
                            Other times, you starve for days on end.
                            Despite the constant persecution you face,
                            your son seems to be growing up alright.
                            The two of you are kobolds.
                            Your species is used to this.
                            You'll get through it.
                            There's always a light at the end of the tunnel.
                        [/p]
                        [p]
                            One fateful evening, you walk into the wrong alleyway.
                            A human gang runs this part of town, and they're [b]not[/b] happy to see you.
                            Broadly built men block both exitways.
                            You put your child on the ground.
                            As the humans advance on you, you tell your little boy to [b]run[/b].
                            He barely gets away without being caught,
                            his tiny size allowing him to squeeze in between the legs of one of the thugs.
                            You are not so lucky.
                        [/p]
                        [p]
                            Your offspring watches from the edge of the alleyway,
                            as the lowlifes violently have their way with you,
                            brutally beating you senseless while violating every part of your body.
                            You are beaten, you are raped, you are choked, you are pissed on,
                            you are dragged through the mud, and finally, after every last man has tormented you in his own way,
                            the leader of the gang viciously snaps your neck, ending your miserable life.
                        [/p]
                        [p]
                            Your son, barely able to keep quiet while watching his mother get beaten to death,
                            bursts out into tears.
                            He mindlessly runs throughout the city until dawn.
                            Growing hungry, he does the only thing you taught him to do:
                            he begs.
                        [/p]
                        [p]
                            Years later, after a chance encounter with a kind-hearted avian,
                            the boy decides to leave the city, and live his life free of harassment,
                            in the surrounding woods.
                            There, he finds a shack, abandoned for many years.
                            His new home.
                        [/p]
                        [p]
                            [c]
                                [b]
                                    Full circle end.
                                [/b]
                            [/c]
                        [/p]
                        [p]
                            [nl]
                            [small]
                                You have reached one of Kobold Adventure's irreversible endings.
                                Your actions have sealed the fate of ${name}.
                                This is where their storyline ends.
                                By saving the game, you can review your timeline using the aStory feature available via the menu.
                                If you wish to tempt fate once more, reload an earlier save, or start a new game and try again.
                                Remember: all things, both good and bad, must always come to an end.
                                The journey is as important as the destination is.
                                Is heaven worth going through hell for?
                            [/small]
                        [/p]`;

        return global.parser.parse(toReturn);
    }


    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {

    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\kid\drunk\satisfy\dad\FarmerMaidDrunkSatisfyFree.js

// scenes\Enslavement\DayTwo\FarmerMaid\kid\drunk\satisfy\dad\FarmerMaidDrunkSatisfyDad.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidDrunkSatisfyDad(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.preDeath;
    var subController = ctrl.death;
    var changeController = false;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";

    var firstNext = new FarmerMaidDrunkSatisfyFree(ctrl);
    var secondNext = new FarmerMaidDrunkSatisfyStay(ctrl);

    var firstChoice = FarmerMaidDrunkSatisfyDadChoice.LEAVE;
    var secondChoice = FarmerMaidDrunkSatisfyDadChoice.STAY;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var name = ctrl.misc.name();
        var toReturn = `[p]
                            Romeo had an [i]unfortunate accident[/i] while tending to his field.
                            Somehow, he [i]stabbed himself[/i] with his rake, while watering the crops.
                            The circumstances are [b]suspicious[/b], to say the least,
                            but you are reminded these things tend to happen around here.
                            Farming near the hamlet, ironically, is about as dangerous as being a city guard in Varanar.
                            Whether this was a robbery gone wrong, a rival offing your master for personal gains,
                            or an [i]actual[/i] accident, you will never know.
                        [/p]
                        [p]
                            Falco takes the news rather well.
                            He never really saw eye-to-eye with the man of the house.
                            Juliet, however, is devastated.
                            Neither you nor her son able to console her,
                            the woman moves out of the house, and back in with her parents,
                            somewhere in Varanar.
                            That leaves you and him, all alone.
                        [/p]
                        [p]
                            Romeo is buried in the backyard by his closest farmer friends.
                            After the emotional burial, Falco confronts you.
                            He's clearly touched, but he's not letting it show.
                            Sincerely, the bird speaks:
                            "[color=yellow]Look, ${name}, I...[b]really[/b] like you.
                            But there's something you should know.[/color]"
                            You aren't sure what to expect.
                            His wording makes it sound [i]ominous[/i], but his tone seems [i]uplifting[/i].
                        [/p]
                        [p]
                            "[color=yellow]Your [i]slave contract[/i] only bound you to my father.
                            Technically, you are [b]free[/b] now.
                            I understand that this past year has been a [i]hectic[/i] one, for sure,
                            and if you want to leave, I won't stand in your way.[/color]"
                            You're [b]free[/b].
                            Really?!
                            "[color=yellow]But since you've...well, because I...since you're [b]pregnant[/b] and all,
                            I wouldn't mind you [i]staying[/i] here.
                            With me.[/color]"
                            Wait.
                            Is he inviting you to [b]live with him[/b]?
                            Oh goodness!
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === firstChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${firstId}" ${disabled}>Leave</button>`;

        var tooltip = global.parser.parse(`You can't stay here. You'd only cause trouble for him in the long run.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 180px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === secondChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${secondId}" ${disabled}>Stay</button>`;

        var tooltip = global.parser.parse(`Let's raise the baby together, as a family.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 180px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You:</div>`;
        choice += buildFirstChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(firstChoice);
            loadNextPart(firstNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(secondChoice);
            loadNextPart(secondNext);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += firstNext.build();
        part += secondNext.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        firstNext.registerListeners();
        secondNext.registerListeners();

        if (subController.has()) {
            return;
        }

        registerFirstListener();
        registerSecondListener();
    };
}

var FarmerMaidDrunkSatisfyDadChoice = {
    LEAVE: 1,
    STAY: 2
};

// END scenes\Enslavement\DayTwo\FarmerMaid\kid\drunk\satisfy\dad\FarmerMaidDrunkSatisfyDad.js

// scenes\Enslavement\DayTwo\FarmerMaid\kid\drunk\satisfy\FarmerMaidDrunkTrick.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidDrunkTrick(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = FarmerMaidDrunkChoice.TRICK;
    var reqController = ctrl.drunk;
    var subController = ctrl.postDrunk;
    var changeController = false;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = ctrl.fragments.satisfied;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            Fine.
                            He can do it inside of you.
                            But only this once, okay?
                        [/p]
                        [p]
                            As those words leave your muzzle, it's like a [b]spark[/b] ignites in Falco's eyes.
                            You grab his half-hard shaft, but instead of guiding it into your pregnant slit,
                            you press it against your folds, and wrap your warm, scaly thighs around it, giving the [i]illusion[/i] that he's inside of you.
                            Sneakily, you lean down and grab your bucket, holding it in front of you to make sure he doesn't make a mess of the floor.
                            The bird leans his weight on you, clutching you tightly, keeping you in place to make sure you don't get any [i]second thoughts[/i].
                            Then, with a satisfied sigh, he releases his bladder, his warm, dark, dehydrated,
                            drunk piss squirting from the foreskin covered tip of his member right into the bucket.
                        [/p]
                        [p]
                            The wasted eagle barely even questions the sounds of his piss hitting the wooden bucket.
                            Your [i]lover[/i] pees like a horse.
                            Maybe it's just because he's drunk, but still you're glad you didn't let him go inside of you.
                            Some twenty seconds of urination later,
                            Falco's bladder is completely emptied,
                            and your mop bucket is half-filled.
                            You release your grip on his shaft.
                            Your bird lover sneaks in a few quick kisses, before pulling up his pants once more.
                            He lets go of you and staggers towards the stairway,
                            then stumbles up the stairs and disappears into his room, probably to sleep off his inebriation.
                        [/p]
                        [p]
                            You head outside through the backdoor, and dump the smelly contents of your mop bucket in the backyard.
                            [i]Watering the plants[/i].
                            After a few moments, all that's left from your encounter with your hammered bird friend, is a steamy, muddy puddle.
                            You hope the avian won't ask you for this again.
                            Next time, you might not be able to trick him as easily.
                            But that's a problem for another time.
                            Getting some more fresh air, 
                            you head back into the house, and continue your maid duties.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\kid\drunk\satisfy\FarmerMaidDrunkTrick.js

// scenes\Enslavement\DayTwo\FarmerMaid\kid\drunk\satisfy\FarmerMaidDrunkSatisfy.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidDrunkSatisfy(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.postDrunk;
    var subController = ctrl.preDeath;
    var changeController = false;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new FarmerMaidDrunkSatisfyDad(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            After that day, the relationship between Falco and you takes a turn for the better.
                            Your intense bouts of lovemaking become more [b]passionate[/b], more [b]gentle[/b].
                            He kisses you on the lips, eats you out, prepares you with his fingers and even cuddles with you afterwards,
                            instead of just pumping his dick in and out of you until he cums, then leaving you to clean up the mess.
                        [/p]
                        [p]
                            Perhaps that [i]spark[/i] you saw in his eyes was one of [i]love[/i].
                            Or maybe he's finally coming to terms with becoming a [i]father[/i].
                            Either way, you're not complaining.
                            A bit of [b]tenderness[/b] is exactly what your hormonal body needed.
                            It's like he's starting to treat you like a lover instead of a [i]whore[/i].
                            And while you aren't ready to admit it yet, you are growing feelings for the eagle as well.
                        [/p]
                        [p]
                            As weeks go by, your belly bulges further and further.
                            The baby must be getting bigger.
                            Romeo and Juliet take notice.
                            Luckily, they're naive enough to believe the lie that you must have gotten pregnant [i]before[/i] becoming their slave,
                            and that it's a [b]slow-growing[/b] child gestating inside of you.
                            Or maybe they don't [i]want[/i] to face the fact that their son is one who lays with kobolds.
                        [/p]
                        [p]
                            Falco talks his parents into letting you stay in bed with him, at night.
                            Sure beats sleeping in the dog basket.
                            The bird and yourself often fool around before going to sleep,
                            although the rare few times that you're [b]not[/b] in the mood to fuck,
                            your feathery friend understands completely.
                            He no longer forces himself upon you.
                            He's grown to respect your boundaries,
                            and you, in turn, show him a bit more affection as well.
                        [/p]
                        [p]
                            The two of you grow closer and closer together, until one day,
                            a broadly built horse walks through the front door, carrying a dire missive.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\kid\drunk\satisfy\FarmerMaidDrunkSatisfy.js

// scenes\Enslavement\DayTwo\FarmerMaid\kid\drunk\satisfy\FarmerMaidDrunkPiss.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidDrunkPiss(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = FarmerMaidDrunkChoice.PISS;
    var reqController = ctrl.drunk;
    var subController = ctrl.postDrunk;
    var changeController = false;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = ctrl.fragments.satisfied;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            Fine.
                            He can do it inside of you.
                            But only this once, okay?
                        [/p]
                        [p]
                            As those words leave your muzzle, it's like a [b]spark[/b] ignites in Falco's eyes.
                            You grab his half-hard shaft, and slowly guide his foreskin-covered cockhead into your pregnant slit.
                            The bird leans his weight on you, clutching you tightly, holding you in place to make sure you don't get any [i]second thoughts[/i].
                            Then, with a satisfied sigh, he releases his bladder, his warm, dark, dehydrated, drunk piss flooding your insides.
                        [/p]
                        [p]
                            It feels [b]weird[/b] and [b]gross[/b], to have a man [b]pee[/b] inside of you.
                            It's like he's cumming a huge amount of watery jizz, defiling your innards by drenching them in his acrid bodily waste.
                            However, despite your mind [b]screeching[/b] that this is [b]wrong[/b] on every level,
                            you kind of don't really hate this all that much.
                            The [b]warmth[/b] and the feeling of being [b]filled[/b] are actually kind of [i]enticing[/i].
                            Maybe this is one of those things you can grow to [i]like[/i], over time.
                            Not that you hope he'll do this again or anything.
                        [/p]
                        [p]
                            A good twenty seconds of urination later, Falco pulls out of you, his bladder completely emptied.
                            Your folds quickly occlude, keeping the foul liquid sealed safely inside of you.
                            Your bird lover sneaks in a few quick kisses, before pulling up his pants once more.
                            He lets go of you and staggers towards the stairway,
                            then stumbles up the stairs and disappears into his room, probably to sleep off his inebriation.
                        [/p]
                        [p]
                            You are left standing in the middle of the living room,
                            your snatch filled with your lover's piss.
                            You feel unnaturally [b]full[/b], and with good reason.
                            Like the eagle, you won't be able to hold this in for long.
                            You waddle over to the backdoor, slip outside and squat down in the dirt.
                            Reaching down, you slightl;y part your slit with your fingers,
                            and immediately a [b]torrent[/b] of reeking, yellow liquid floods from your cunt.
                        [/p]
                        [p]
                            To any onlookers, it looks like you're just taking a leak.
                            But the pee isn't coming from your urethra.
                            It's kind of [i]liberating[/i], to feel your innards empty.
                            After a few moments, all that's left from your encounter with your drunken bird friend,
                            is a steamy, muddy puddle near the backyard.
                            Swirling a finger around inside to clean yourself out properly,
                            you head back into the house, and continue your maid duties.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\kid\drunk\satisfy\FarmerMaidDrunkPiss.js

// scenes\Enslavement\DayTwo\FarmerMaid\kid\drunk\decline\dad\FarmerMaidDrunkDeclineLick.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidDrunkDeclineLick(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = FarmerMaidDrunkDeclineDadChoice.LICK;
    var reqController = ctrl.death;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var name = ctrl.misc.name();
        var broom = ctrl.drunk.get() === FarmerMaidDrunkChoice.DECLINE;
        var toReturn = `[p]
                            You're [b]not[/b] going back there!
                            He has [b]no[/b] right to keep you.
                            You're [b]free[/b], and darnit, you've [b]earned[/b] your freedom!
                            Especially considering all the [b]horrible[/b] things he did to you.
                            You hope you'll [b]never[/b] have to see him [b]ever[/b] again!
                        [/p]
                        [p]
                            Tears flow liberally from your eyes.
                            Your words spent, you turn around and begin to walk away.
                            But Falco reaches out and coarsely [b]grabs[/b] one of your arms!
                            "[color=yellow]You're not going anywhere, [b]slave[/b]![/color]"
                            He begins to tug you back towards the house.
                        [/p]
                        [p]
                            Mustering all the strength and courage left in your battered body,
                            you [b]push[/b] the eagle away from you, tearing your arm from his grasp.
                            Fearing for your very life, you begin to run away, into the adjacent farmland,
                            as fast as your ${broom ? `aching loins` : `pregnant belly`} will allow.
                            The avian doesn't even bother to give chase.
                            Instead, he lets out a sharp whistle.
                            Instantly, his dog comes running out of the house.
                        [/p]
                        [p]
                            The bird points your way, and the canine bolts after you.
                            You give it your all.
                            You really do.
                            You try your hardest, pushing your body to its very limits,
                            but you simply can't outrun a feral dog.
                            Not while ${broom ? `internally hurt` : `pregnant`}.
                        [/p]
                        [p]
                            Realizing your fate is sealed,
                            you simply stop running.
                            You wouldn't have made it much further anyway.
                            Standing still, you turn around, facing Falco and his pet barreling towards you.
                            You look straight into the eagle's eyes,
                            as the canine [b]leaps[/b] at you, tearing open your throat with its powerful jaws and sharp fangs.
                        [/p]
                        [p]
                            You fall down backwards, into the mud.
                            You can't breathe.
                            Blood squirts from your neck.
                            Your arms are too weary and weak to quench the intense flow.
                            Darkness envelops the corners of your eyes.
                            On the exact same spot where Romeo met his end, so too do you face your demise.
                            But you die knowing you were free, if only for a moment.
                            And that is better than living the rest of your life as a slave.
                        [/p]
                        [p]
                            [c]
                                [b]
                                    Lion end.
                                [/b]
                            [/c]
                        [/p]
                        [p]
                            [nl]
                            [small]
                                You have reached one of Kobold Adventure's irreversible endings.
                                Your actions have sealed the fate of ${name}.
                                This is where their storyline ends.
                                By saving the game, you can review your timeline using the aStory feature available via the menu.
                                If you wish to tempt fate once more, reload an earlier save, or start a new game and try again.
                                Remember: all things, both good and bad, must always come to an end.
                                The journey is as important as the destination is.
                                Is heaven worth going through hell for?
                            [/small]
                        [/p]`;

        return global.parser.parse(toReturn);
    }


    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {

    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\kid\drunk\decline\dad\FarmerMaidDrunkDeclineLick.js

// scenes\Enslavement\DayTwo\FarmerMaid\kid\drunk\decline\dad\FarmerMaidDrunkDeclineDad.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidDrunkDeclineDad(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.preDeath;
    var subController = ctrl.death;
    var changeController = false;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";

    var firstNext = new FarmerMaidDrunkDeclineLick(ctrl);
    var secondNext = new FarmerMaidDrunkDeclineBite(ctrl);

    var firstChoice = FarmerMaidDrunkDeclineDadChoice.LICK;
    var secondChoice = FarmerMaidDrunkDeclineDadChoice.BITE;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var broom = ctrl.drunk.get() === FarmerMaidDrunkChoice.DECLINE;
        var toReturn = `[p]
                            One day,
                            a broadly built horse walks through the front door, carrying a dire missive.
                            Romeo had an [i]unfortunate accident[/i] while tending to his field.
                            Somehow, he [i]stabbed himself[/i] with his rake, while watering the crops.
                            The circumstances are [b]suspicious[/b], to say the least,
                            but you are reminded these things tend to happen around here.
                            Farming near the hamlet, ironically, is about as dangerous as being a city guard in Varanar.
                            Whether this was a robbery gone wrong, a rival offing your master for personal gains,
                            or an [i]actual[/i] accident, you will never know.
                        [/p]
                        [p]
                            Falco takes the news rather well.
                            He never really saw eye-to-eye with the man of the house.
                            Juliet, however, is devastated.
                            She quickly grows [b]bitter[/b] and [b]cold[/b].
                            On the day of her husband's funeral, she doesn't even bother to show.
                        [/p]
                        [p]
                            Romeo is buried in the backyard by his closest farmer friends.
                            After the emotional burial, Falco confronts you.
                            The bird informs you that your [i]slave contract[/i] technically only bound you to his father.
                            But, the eagle doesn't think you've put enough work in yet to be set free like that.
                            His father paid [b]a lot[/b] of gold for you.
                            He wants to [b]keep you[/b].
                            And he's not taking no for an answer.
                        [/p]
                        [p]
                            You argue with the bird, saying that he can't do this.
                            You're free.
                            He can't keep holding you!
                            But he can.
                            You're a kobold.
                            You have no rights.
                            His mind seems made up.
                            He's taking you back home with him, whether you like it or not.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === firstChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${firstId}" ${disabled}>Run</button>`;

        var tooltip = global.parser.parse(`You [b]must[/b] escape, no matter the cost.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 150px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === secondChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${secondId}" ${disabled}>Relent</button>`;

        var tooltip = global.parser.parse(`If you run, he might have his dog hunt you down. You don't want to die.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 180px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You:</div>`;
        choice += buildFirstChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(firstChoice);
            loadNextPart(firstNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(secondChoice);
            loadNextPart(secondNext);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += firstNext.build();
        part += secondNext.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        firstNext.registerListeners();
        secondNext.registerListeners();

        if (subController.has()) {
            return;
        }

        registerFirstListener();
        registerSecondListener();
    };
}

var FarmerMaidDrunkDeclineDadChoice = {
    LICK: 1,
    BITE: 2
};

// END scenes\Enslavement\DayTwo\FarmerMaid\kid\drunk\decline\dad\FarmerMaidDrunkDeclineDad.js

// scenes\Enslavement\DayTwo\FarmerMaid\kid\drunk\decline\dad\FarmerMaidDrunkDeclineBite.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidDrunkDeclineBite(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = FarmerMaidDrunkDeclineDadChoice.BITE;
    var reqController = ctrl.death;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var broom = ctrl.drunk.get() === FarmerMaidDrunkChoice.DECLINE;
        var name = ctrl.misc.name();
        var toReturn = `[p]
                            You consider running, but the moment the thought crosses your mind,
                            the bird whistles for his dog, who comes running out of the house to stand by his side.
                            It growls loudly at you, menacingly baring its teeth.
                            Fearing for your very life, you reluctantly walk back home with the sadistic avian,
                            back into a life of slavery and servitude.
                        [/p]
                        [p]
                            The daily grind continues.
                            Falco works the fields, providing food for Juliet and yourself.
                            You keep the house clean, your duties interrupted by frequent feral fucking.
                            You notice the human woman starting to spy on you whenever the canine ruts you.
                            Ever since her husband died, she no longer has a way to [i]sate[/i] her needs.
                            And you think that growing desire is slowly starting to drive her insane.
                        [/p]
                        [p]
                            Whenever you get close to the door, the dog begins to growl and bark.
                            The eagle probably trained it to [b]attack[/b] you, should you try to leave.
                            You keep trying to look for ways to [b]escape[/b], but even if you [i]could[/i] make it out the door,
                            there's little chance of you evading every single inhabitant of the entire hamlet.
                            And after you escape, where would you go?
                            ${broom ? `Nowhere.` : `A pregnant kobold on the run would be an easy target for just about anyone.`}
                        [/p]
                        [p]
                            The mother of the house begins to quite openly masturbate to your unwilling sessions with her son's pet.
                            One day, when the dog tackles you while cleaning the lady's room, she walks up in front of you,
                            drops her pants, and wordlessly sets her loins down atop your muzzle, grinding her needy cunt into your scales.
                            You can refuse her service, but what's the point?
                            It'll only make things worse for you.
                            Your tongue snakes out of your mouth, and while the canine wildly humps away,
                            you dutifully eat out your new [i]mistress[/i], hoping she'll at least let you stay in bed with her after this.
                            No such luck.
                        [/p]
                        ${broom ? `
                        [p]
                            The awkward threesomes continue for the better half of a week.
                            Then, Juliet figures out how to get the dog to fuck [b]her[/b] instead.
                            She gets pounded to orgasm after orgasm underneath a dog the same weight as her.
                            She [b]loves[/b] it.
                            It's like happiness returns to her life,
                            all the bitterness and coldness washing away amidst a torrent of watery canine spunk.
                        [/p]
                        [p]
                            Instead of you being allowed to sleep in her bed,
                            it is the dog that gets a place by Juliet's side at night.
                            You don't mind.
                            At least you get the basket back.
                            Much better than sleeping on the floor.
                            With the canine fucking the human all day long, it is no longer interested in you.
                            You live out the rest of your life in relative peace, as a servant.
                            You tidy the house, you clean up after your new [i]mistress[/i]' feral escapades,
                            and you fight over scraps with the dog that has usurped your rightful place in this house.
                        [/p]` : `
                        [p]
                            A month later, you go into labour.
                            In the middle of the kitchen, you give birth to a baby kobold boy.
                            But he's not moving.
                            He's not breathing.
                            Your child is stillborn.
                            Weeping openly, you press the carcass against your chest.
                            Your mind snaps.
                            Sadness turns to apathy.
                            You feel nothing from that day onwards.
                            No joy.
                            No sadness.
                            No love.
                            No hate.
                            Your mind is blank.
                            Your body functions autonomously.
                            You serve until you die of old age.
                            Nobody mourns for you.
                        [/p]`}
                        [p]
                            [c]
                                [b]
                                    Two bitches and a dog end.
                                [/b]
                            [/c]
                        [/p]
                        [p]
                            [nl]
                            [small]
                                You have reached one of Kobold Adventure's irreversible endings.
                                Your actions have sealed the fate of ${name}.
                                This is where their storyline ends.
                                By saving the game, you can review your timeline using the aStory feature available via the menu.
                                If you wish to tempt fate once more, reload an earlier save, or start a new game and try again.
                                Remember: all things, both good and bad, must always come to an end.
                                The journey is as important as the destination is.
                                Is heaven worth going through hell for?
                            [/small]
                        [/p]`;

        return global.parser.parse(toReturn);
    }


    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {

    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\kid\drunk\decline\dad\FarmerMaidDrunkDeclineBite.js

// scenes\Enslavement\DayTwo\FarmerMaid\kid\drunk\decline\FarmerMaidDrunkGetHard.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidDrunkGetHard(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = FarmerMaidDrunkChoice.HARD;
    var reqController = ctrl.drunk;
    var subController = ctrl.postDrunk;
    var changeController = false;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = ctrl.fragments.dog;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            Pee inside of you?
                            Heck no.
                            You're not going to let Falco do that!
                            You don't have the heart to outright [i]decline[/i] him, though.
                            Being drunk, he might [b]hurt you[/b].
                            But there [i]is[/i] another way.
                            He can't piss if his dick is hard.
                            His own fumbling hands might not be enough to arouse him,
                            but perhaps your touch will be.
                        [/p]
                        [p]
                            You reach behind you, tentatively gripping onto the eagle's half-erect shaft.
                            Acting like you're guiding him into your folds, you begin to rub the tip of his member up and down your slit.
                            At the same time, you slowly start to stroke him, pumping his length with your palm,
                            jerking him off [b]properly[/b] instead of fumbling about like he was doing.
                            The bird's inebriated body, while numbed from all the alcohol, doesn't take long to respond to your touch.
                            His cock rapidly hardens, growing fully erect in less than a minute.
                        [/p]
                        [p]
                            Growing tired of waiting, the avian pushes himself inside of you.
                            He tries, but fails to empty his full bladder, the tightness of your loins further enticing his shaft.
                            It takes longer than it took for you to get him hard,
                            for Falco to realize he's not able to pee inside of you like this.
                            After trying for several minutes,
                            the boy finally removes his member from your slit.
                            Then, he crudely pushes you away from him, putting far more strength into the brute shove than necessary!
                            You almost trip and fall,
                            but end up managing to maintain your balance by clambering to an almost-toppling cabinet.
                        [/p]
                        [p]
                            Turning to face him, you shoot your angry [i]lover[/i] an upset frown.
                            That was [b]completely[/b] uncalled for!
                            "[color=yellow]You [b]tricked[/b] me![/color]"
                            the eagle shouts in response.
                            He sounds [b]disappointed[/b] and [b]betrayed[/b].
                            You admit, you [i]did[/i] kind of trick him,
                            but what kind of request is asking to piss inside of you?!
                            That's [b]not[/b] something normal people do!
                            Even [b]if[/b] they're drunk!
                        [/p]
                        [p]
                            "[color=yellow]Sho I'm not normal, huh?!
                            You shound just like [b]Romeo[/b], you shtupid [b]bitch[/b]![/color]"
                            You seem to have accidentally struck a sore spot.
                            You cower in fear as the avian lifts his hand, like he's about to [b]hit[/b] you!
                            But right before he can act on his impulses, the bird regains some of his senses.
                            Deciding not to beat you, he instead storms out the front door from whence he came,
                            loudly [b]slamming[/b] the door behind him as he leaves the house once more.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\kid\drunk\decline\FarmerMaidDrunkGetHard.js

// scenes\Enslavement\DayTwo\FarmerMaid\kid\drunk\decline\FarmerMaidDrunkDeclineDog.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidDrunkDeclineDog(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.postDrunk;
    var subController = ctrl.preDeath;
    var changeController = false;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new FarmerMaidDrunkDeclineDad(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var broom = ctrl.drunk.get() === FarmerMaidDrunkChoice.DECLINE;
        var toReturn = ``;

        if (broom) {
            toReturn += `[p]
                            Things rapidly deteriorate from that day onwards.
                            You struggle to cope with the fact that you lost your child,
                            while your bulging belly deflates once more.
                            You can't believe Falco did that.
                            First he knocked you up,
                            and then he gave you an [b]abortion[/b] against your will.
                            You'll never forgive him for that.
                            You refuse to look at him, and he refuses to look at you.
                            Whatever you had going between the two of you is [b]over[/b].
                        [/p]
                        [p]
                            A few weeks later, the bird nags his parents into buying him a new feral dog.
                            A big, burly beast, almost as tall as you are.
                            You think your former lover is doing this just to spite you.
                            But you don't care, as long as it doesn't affect you.
                            If he keeps that mutt away from you, then he can fuck it up the tailhole for all you care.
                        [/p]
                        [p]
                            But being left alone isn't in the hand you were dealt.
                            The canine sleeps in your basket, leaving little room for you.
                            Unable to move it, and kind of [i]scared[/i] of how it constantly [b]growls[/b] at you,
                            you resort to sleeping on the cold, hard floor.
                            And that's only the [b]beginning[/b] of your descent into a new layer of hell.
                        [/p]
                        [p]
                            Falco trains the dog.
                            Teaches it to mount things.
                            Things like [b]you[/b].
                            One day, while you're sweeping the floor as usual,
                            the beast suddenly approaches from behind, rears up and plops its large front paws atop your shoulders,
                            throwing you off balance, [b]forcing[/b] you to the ground.
                            Before you manage to recover, it mounts you, keeping you pinned to the floor through sheer body-weight.
                        [/p]
                        [p]
                            You struggle, but the canine is far too big and heavy for you to shake off.
                            Your heart sinks to your knees as it begins to [b]hump[/b] your rear,
                            painfully prodding its fully erect, tapered member against your plump, scaly behind.
                            From the kitchen, in walks the eagle.
                            You [b]beg[/b] him to get his pet off of you!
                            But instead of helping, he kneels down near your backside, and grabs the feral's shaft.
                            "[color=yellow][b]Bitch[/b].[/color]" is the only word that escapes his beak,
                            as he guides his pet's dick into your still-aching folds, the dog instantly thrusting forwards,
                            ramming itself into your splintery cunt.
                        [/p]
                        [p]
                            You cry out in agony once more,
                            your still fresh internal wounds raked open yet again.
                            The beast doesn't seem to mind the chips of wood embedded into your innards.
                            As its master leaves you to your fate, it wildly begins to [b]hump[/b] away,
                            rapidly pounding your hurting insides with the bestial ferocity that only a feral could muster.
                        [/p]
                        [p]
                            Several minutes of agony later, it stretches your folds to their very limits,
                            as it [b]rams[/b] its thick knot inside of you,
                            hopping off of you and facing away as its hefty balls begin to churn out their contents into your aching hole.
                            Completely [b]broken[/b], you don't even bother to try to pull yourself free from the canine's knot,
                            instead idly bawling your eyes out while waiting for it to deflate.
                        [/p]
                        [p]
                            The dog comes to see you as its [b]property[/b].
                            A toy for it to fuck when it is needy.
                            Be that during the day, while you're trying to clean,
                            at night, while you're trying to sleep,
                            or even in the middle of a conversation with Juliet.
                            After it painfully [b]bites[/b] the back of your neck,
                            you learn not to struggle too much against the feral's actions.
                            It is in control, and not you.
                        [/p]`;
        } else {
            toReturn += `
                        [p]
                            Things rapidly deteriorate from that day onwards.
                            You refuse to look at Falco, and he refuses to look at you.
                            Whatever you had going between the two of you is [b]over[/b].
                            Until he apologizes for his actions, you don't want anything more to do with him.
                        [/p]
                        [p]
                            A few weeks later, the bird nags his parents into buying him a new feral dog.
                            A big, burly beast, almost as tall as you are.
                            You think your former lover is doing this just to spite you.
                            But you don't care, as long as it doesn't affect you.
                            If he keeps that mutt away from you, then he can fuck it up the tailhole for all you care.
                        [/p]
                        [p]
                            But being left alone isn't in the hand you were dealt.
                            The canine sleeps in your basket, leaving little room for you.
                            Unable to move it, and kind of [i]scared[/i] of how it constantly [b]growls[/b] at you,
                            you resort to sleeping on the cold, hard floor.
                            And that's only the [b]beginning[/b] of your descent into a new layer of hell.
                        [/p]
                        [p]
                            Falco trains the dog.
                            Teaches it to mount things.
                            Things like [b]you[/b].
                            One day, while you're sweeping the floor as usual,
                            the beast suddenly approaches from behind, rears up and plops its large front paws atop your shoulders,
                            throwing you off balance, [b]forcing[/b] you to the ground.
                            Before you manage to recover, it mounts you, keeping you pinned to the floor through sheer body-weight.
                        [/p]
                        [p]
                            You struggle, but the canine is far too big and heavy for you to shake off.
                            Your heart sinks to your knees as it begins to [b]hump[/b] your rear,
                            painfully prodding its fully erect, tapered member against your plump, scaly behind.
                            From the kitchen, in walks the eagle.
                            You [b]beg[/b] him to get his pet off of you!
                            But instead of helping, he kneels down near your backside, and grabs the feral's shaft.
                            "[color=yellow][b]Bitch[/b].[/color]" is the only word that escapes his beak,
                            as he guides his pet's dick into your folds, the dog instantly thrusting forwards,
                            ramming itself into your pregnant cunt.
                        [/p]
                        [p]
                            As its master leaves you to your fate, the beast wildly begins to [b]hump[/b] away,
                            rapidly pounding your insides with the bestial ferocity that only a feral could muster.
                            Several minutes of debasing degradation later, it stretches your folds to their very limits,
                            as it [b]rams[/b] its thick knot inside of you,
                            hopping off of you and facing away as its hefty balls begin to churn out their contents into your violated hole.
                            Completely [b]broken[/b], you don't even bother to try to pull yourself free from the canine's knot,
                            instead idly bawling your eyes out while waiting for it to deflate.
                        [/p]
                        [p]
                            The dog comes to see you as its [b]property[/b].
                            A toy for it to fuck when it is needy.
                            Be that during the day, while you're trying to clean,
                            at night, while you're trying to sleep,
                            or even in the middle of a conversation with Juliet.
                            After it painfully [b]bites[/b] the back of your neck,
                            you learn not to struggle too much against the feral's actions.
                            It is in control, and not you.
                        [/p]`;
        }

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\kid\drunk\decline\FarmerMaidDrunkDeclineDog.js

// scenes\Enslavement\DayTwo\FarmerMaid\kid\drunk\decline\FarmerMaidDrunkDecline.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidDrunkDecline(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = FarmerMaidDrunkChoice.DECLINE;
    var reqController = ctrl.drunk;
    var subController = ctrl.postDrunk;
    var changeController = false;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = ctrl.fragments.dog;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            Pee inside of you?
                            Heck no.
                            You're not going to let Falco do that!
                            Gathering all of your courage, you stand up for yourself, and [b]push[/b] him off of you!
                            You clearly tell the avian that he is [b]not[/b] going to [b]defile[/b] you like that.
                            This is [b]not[/b] proper behavior.
                            He's [b]drunk[b].
                            You're [b]pregnant[/b]!
                            And even if you weren't, you [b]still[/b] wouldn't allow him to [b]abuse[/b] your body like that!
                            You're [b]not[/b] a gosh-darn urinal!
                        [/p]
                        [p]
                            Your angry rant, spurred on by his apathetic stance to parenthood, seems to upset the bird.
                            And not in a good way.
                            He glares at you, with pure [b]hatred[/b] in his eyes.
                            Wordlessly advancing upon you once more,
                            the eagle brutishly [b]grabs[/b] the mop from your hands, wicked thoughts forming in his booze-addled mind.
                        [/p]
                        [p]
                            You [b]demand[/b] to know what he's doing, but there is no response.
                            Grabbing you by the arm, the boy forcibly bends you over a nearby dresser,
                            keeping you pinned down with surprising, alcohol-fueled strength.]
                            You tell him to [b]stop[/b] and [b]think[/b] about what he's doing!
                            There'll be no going back after this!
                            No more him and you!
                        [/p]
                        [p]
                            But it's too late.
                            His mind is made up.
                            "[color=yellow]You became a [b]bitch[/b] ever shinsh you got pregnant.[/color]"
                            The avian leans in close, and whispers into your ear.
                            "[color=yellow][small]Time to fix that.[/small][/color]"
                            Before you can utter any more protests, Falco yanks your tail upwards,
                            and with his other hand, he wildly [b]shoves[/b] the wooden handle of your mop into your cunt,
                            as far as it will go and then some.
                        [/p]
                        [p]
                            You [b]scream[/b] out in pain as the splintery wood [b]rakes[/b] open your insides,
                            the blunt tip of the broom pushing [b]far[/b] deeper than [b]anything[/b] is supposed to go.
                            Your cervix is [b]rammed[/b] open,
                            and the excruciating torment of having a coarse foreign object [b]invade[/b] your very womb is enough for your mind to black out,
                            your eyes rolling into the back of your head out of sheer [b]torment[/b].
                            Your body lifelessly crumples to the floor, completely limp.
                        [/p]
                        [hr]
                        [p]
                            You wake up some time later.
                            You are lying on the floor, blood oozing from your slit,
                            the broom on the ground next to you, the handle painted red.
                            You clutch your aching belly, fearing the blood spilling from your loins isn't just [i]yours[/i].
                            Falco is nowhere to be seen.
                            You think he might have [b]killed[/b] your child.
                        [/p]
                        [p]
                            Your mind barely able to process the horror that was inflicted upon you,
                            you rise to your shaky feet.
                            Your loins hurt [b]so much[/b] you can barely stand.
                            But your traumatized mind ignores the pain.
                            Completely distraught,
                            you pick up the mop,
                            and begin to clean up the spilled guts of your unborn baby,
                            blood still trickling down your inner thighs.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\kid\drunk\decline\FarmerMaidDrunkDecline.js

// scenes\Enslavement\DayTwo\FarmerMaid\kid\drunk\FarmerMaidDrunk.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidDrunk(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.daily;
    var subController = ctrl.drunk;
    var changeController = false;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";
    var thirdId = arguments.callee.name + "ButtonThree";
    var fourthId = arguments.callee.name + "ButtonFour";

    var firstNext = new FarmerMaidDrunkDecline(ctrl);
    var secondNext = new FarmerMaidDrunkGetHard(ctrl);
    var thirdNext = new FarmerMaidDrunkTrick(ctrl);
    var fourthNext = new FarmerMaidDrunkPiss(ctrl);

    var firstChoice = FarmerMaidDrunkChoice.DECLINE;
    var secondChoice = FarmerMaidDrunkChoice.HARD;
    var thirdChoice = FarmerMaidDrunkChoice.TRICK;
    var fourthChoice = FarmerMaidDrunkChoice.PISS;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        global.kobold.history.shared.varanar.dayThree.afternoon.parlorRan = true;
        var toReturn = `[p]
                            A few weeks after you've broken the news,
                            Falco goes out to have some [i]fun[/i] with his delinquent friends.
                            That never amounts to much good.
                            You recall the time he accidentally caused the well in the middle of the hamlet to collapse.
                            Juliet was [b]so[/b] mad at him!
                            You hope he won't cause any [i]destruction[/i] this time around.
                        [/p]
                        [p]
                            A few hours later, early in the afternoon,
                            while you're busy mopping the floor,
                            the front door suddenly and wildly swings open.
                            In stumbles your avian partner.
                            He sluggishly steps inside of the house, almost losing his balance when closing the door behind him.
                            "[color=yellow]Heeeyyyy there, pretty thing...[i]hic[/i]![/color]"
                            His speech is slurred and the hefty stench of [b]alcohol[/b] wafts from his beak.
                            You're pretty certain he's drunk.
                            [b]Very[/b] drunk.
                            [b]Hammered[/b].
                        [/p]
                        [p]
                            Still a little upset about his reaction to you telling him you're pregnant several weeks ago,
                            you give Falco the cold shoulder,
                            concentrating on the floor instead of validating his booze-fueled rambling.
                            As the drunken father of your child approaches you, he carelessly knocks over your mop bucket, water spilling everywhere!
                            As he caressingly grabs you from behind, you can no longer ignore him.
                            Agitated, you grumpily asks the bird what he wants?!
                            Can't he see you're trying to [b]clean[/b] here?!
                        [/p]
                        [p]
                            What he wants soon becomes clear, the eagle pressing his feathery body against your back,
                            erotically grinding his bulge against your barely dressed rear.
                            "[color=yellow]All I want is [b]you[/b].[/color]"
                            He places a peck on the back of your neck, and starts fiddling with his belt-buckle.
                            You sigh out loud, and reluctantly lift your tail.
                        [/p]
                        [p]
                            Falco whips out his member, and begins to rub it against your loins.
                            When you think he's about to insert himself, he instead starts to jerk off,
                            seemingly having trouble [i]getting it up[/i].
                            Whiskeydick.
                            Serves him right, getting drunk in the middle of the day.
                            He frantically tries to get hard, but half-mast is all he can manage.
                            He looks like he [b]really[/b] wants this.
                            You actually kind of [i]feel bad[/i] for him.
                        [/p]
                        [p]
                            After a minute of trying, the bird frustratedly relents, realizing he [b]won't[/b] be fucking you right now.
                            Then, a different base need strikes his mind.
                            "[color=yellow]I really have to...[i]hic[/i]...take a [b]leak[/b].[/color]"
                            What?
                            If he needs to pee, then why the heck is he still here?!
                            Go outside, dumb eagle.
                            "[color=yellow]Come on, let me do it [b]inside[/b] of you.[/color]"
                            What?
                            No!
                            The door's right there!
                            "[color=yellow]I won't [b]make[/b] it there...[i]hic[/]!
                            If I have to pish on the floor, mom'll get [b]mad[/b] at me.
                            And it'll be [b]your[/b] fault![/color]"
                        [/p]
                        [p]
                            He's getting quite [i]upset[/i] about this.
                            You think he may be one of those [i]angry[/i] drunks.
                            Perhaps denying the avian wouldn't be the best of ideas.
                            You really don't want him to do [i]that[/i] inside of you, though.
                            It's [i]dirty[/i].
                        [/p]`;
        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === firstChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice dangeraura ${selected}" id="${firstId}" ${disabled}>Decline</button>`;

        var tooltip = global.parser.parse(`Push him away. Tell him to go do his business outside. 
                                            [warn]You should probably [b]take a different approach[/b],
                                            unless you are ready to get [b]seriously hurt[/b].[/warn]`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 190px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === secondChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${secondId}" ${disabled}>Get him hard</button>`;

        var tooltip = global.parser.parse(`He can't pee if he's erect. Let's see if you can do a better job than he can.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 180px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildThirdChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === thirdChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${thirdId}" ${disabled}>Trick him</button>`;

        var tooltip = global.parser.parse(`Squeeze his length with your thighs to make it seem like he's inside of you.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 190px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFourthChoice() {
        var disabled = subController.has()? "disabled" : "";
        var isSelected = subController.get() === fourthChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${fourthId}" ${disabled}>Allow it</button>`;

        var tooltip = global.parser.parse(`Guide him in.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 110px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You:</div>`;
        choice += `<div class="choicerow" style="margin-bottom: 10px;">`;
        choice += buildFirstChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `</div>`;
        choice += `<div class="choicerow">`;
        choice += buildThirdChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildFourthChoice();
        choice += `</div>`;
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId), $("#" + thirdId), $("#" + fourthId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(firstChoice);
            loadNextPart(firstNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(secondChoice);
            loadNextPart(secondNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerThirdListener() {
        $("#" + thirdId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(thirdChoice);
            loadNextPart(thirdNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerFourthListener() {
        $("#" + fourthId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(fourthChoice);
            loadNextPart(fourthNext);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += firstNext.build();
        part += secondNext.build();
        part += thirdNext.build();
        part += fourthNext.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        firstNext.registerListeners();
        secondNext.registerListeners();
        thirdNext.registerListeners();
        fourthNext.registerListeners();

        if (subController.has()) {
            return;
        }

        registerFirstListener();
        registerSecondListener();
        registerThirdListener();
        registerFourthListener();
    };
}

var FarmerMaidDrunkChoice = {
    DECLINE: 1,
    HARD: 2,
    TRICK: 3,
    PISS: 4
};

// END scenes\Enslavement\DayTwo\FarmerMaid\kid\drunk\FarmerMaidDrunk.js

// scenes\Enslavement\DayTwo\FarmerMaid\kid\toofar\tell\FarmerMaidTooFarTell.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidTooFarTell(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = FarmerMaidTooFarChoice.TELL;
    var reqController = ctrl.toofar;
    var subController = ctrl.toofarTell;
    var changeController = false;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";

    var firstNext = new FarmerMaidTooFarFight(ctrl);
    var secondNext = new FarmerMaidTooFarServe(ctrl);

    var firstChoice = FarmerMaidTooFarTellChoice.FIGHT;
    var secondChoice = FarmerMaidTooFarTellChoice.SERVE;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            You have to go get Romeo, before Juliet gets beaten to death.
                            He's the only one who can put a stop to this.
                            You [b]bolt[/b] out the backdoor,
                            and sprint into the neighbouring farmland, which the human is tilling.
                            He notices your speedy approach, responding quite calmly.
                            "[color=red]Kobold?
                            What are you doing out of the house?
                            Not trying to [b]run away[/b] now, are you?[/color]"
                        [/p]
                        [p]
                            Out of breath, you quickly explain that there's [i]something[/i] bad happening at home.
                            The man asks you what it is, but you have no idea how to explain that his son is beating his wife to death,
                            so you just tell him to [b]come along[/b] and see for himself.
                            He wouldn't believe you if you told the truth, anyway.
                            "[color=red]What is it, my birthday or something?
                            You better not be playing any tricks on me, slave.[/color]"
                            You assure him that you're dead-serious,
                            and the two of you set off back towards the house.
                        [/p]
                        [p]
                            The both of you enter through the still-open back door,
                            the foreboding sounds coming from the kitchen stressing the severity of the situation.
                            As the sight of Falco beating the [b]shit[/b] out of his own mother comes into view,
                            the man of the house freezes in place.
                            His face turns from shock to pure [b]rage[/b].
                            "[color=red]What the [b]hell[/b] is going on here?![/color]"
                        [/p]
                        [p]
                            The bird hadn't even noticed the two of you walking in.
                            He turns around, startled to death by the sound of his father's voice.
                            But he, too, turns to [b]rage[/b].
                            Acting on impulse, the avian grabs a sharp kitchen knife from the counter,
                            and before [b]anyone[/b] can figure out what is happening,
                            Falco [b]stabs[/b] his father in the gut.
                        [/p]
                        [p]
                            The man falls to his knees,
                            coughingly spitting blood into the murderous eagle's face,
                            speckling his white and brown feathers with bright red dots.
                            Juliet is too dazed from the brutal beating she received to figure out what is going on.
                            And you are too absolutely [b]terrified[/b] by the blade-wielding bird to intervene.
                        [/p]
                        [p]
                            As if stabbing him once wasn't enough, Falco retracts the knife, and presses it to the kneeling human's throat.
                            Staring right into his eyes, the avian slices open his father's neck,
                            half-beheading the farmer before pushing him out of the way, down to the ground.
                            Romeo audibly fails to breathe, his lungs rapidly filling with blood.
                            He feebly clutches his haemorrhaged throat, but it is too late.
                            He bleeds out on the floor, slain by his own bastard child.
                        [/p]
                        [p]
                            The old man dealt with,
                            the eagle turns to face you.
                            "[color=yellow][b]You[/b].
                            You lead him here.[/color]"
                            He advances upon you, menacingly wielding the bloodied kitchen knife.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === firstChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${firstId}" ${disabled}>Fight</button>`;

        var tooltip = global.parser.parse(`A fight to the death. You always knew it would come to this.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 180px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === secondChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${secondId}" ${disabled}>Beg</button>`;

        var tooltip = global.parser.parse(`Submit to the avian. You are, and always will be his slave.
                                            He just killed a full-grown human twice your size and three times your weight. What chance do you stand? None.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 180px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You:</div>`;
        choice += buildFirstChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(firstChoice);
            loadNextPart(firstNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(secondChoice);
            loadNextPart(secondNext);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += firstNext.build();
        part += secondNext.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        firstNext.registerListeners();
        secondNext.registerListeners();

        if (subController.has()) {
            return;
        }

        registerFirstListener();
        registerSecondListener();
    };
}

var FarmerMaidTooFarTellChoice = {
    FIGHT: 1,
    SERVE: 2
};

// END scenes\Enslavement\DayTwo\FarmerMaid\kid\toofar\tell\FarmerMaidTooFarTell.js

// scenes\Enslavement\DayTwo\FarmerMaid\kid\toofar\tell\FarmerMaidTooFarServe.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidTooFarServe(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = FarmerMaidTooFarTellChoice.SERVE;
    var reqController = ctrl.toofarTell;
    var changeController = ctrl.toofarServe;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var name = ctrl.misc.name();
        var virgin = ctrl.misc.cuntVirgin();
        var toReturn = `[p]
                            You crumple to your knees,
                            begging and pleading Falco to spare your life.
                            You never meant any harm!
                            All you wanted to do was [b]serve[/b]!
                            You only brought his father here so the bird could take him out!
                            Everything that happened here went according to plan.
                            Now [b]he[/b] is the boss of the family, and not that [b]filthy[/b] human!
                        [/p]
                        [p]
                            The avian comes to a halt before you, considering your lying words.
                            You tremble in terror as he presses the kitchen knife against your throat, fearing he'll off you like he did his own father.
                            But he doesn't, visibly pondering his next course of action, your very life being decided upon.
                            After a few tense seconds, he moves his free hand to his groin, and begins to stroke his humanoid cock to half-mast.
                            Rubbing the foreskin-covered tip against your snout, the bird speaks:
                            "[color=yellow]You wanted to serve?
                            [b]Prove it[/b].[/color]"
                        [/p]
                        [p]
                            The sharp, metal blade still resting against your scales, you have no choice but to comply.
                            You obediently open your muzzle, and take his member into your mouth.
                            Tears flow liberally from your eyes, as you begin to give Falco an unskilled,
                            half-hearted blowjob, bobbing up and down his hardening shaft at a slow, steady pace,
                            careful not to cut yourself on the kitchen knife near your neck.
                        [/p]
                        [p]
                            Not a minute after you've started,
                            the boy grips the back of your head with his free hand,
                            interrupting your feeble attempt at pleasuring him, holding you in place.
                            "[color=yellow]I'll teach you how to suck dick the same way I taught my mom.[/color]"
                            The words have barely even left his beak, before the bird rolls his hips forwards,
                            ramming his length down your throat.
                            Without even giving you a moment to collect yourself,
                            he wildly begins to [b]hump[/b] away, thoroughly fucking your face,
                            his hefty, furred balls slapping against the underside of your muzzle every time he bottoms out.
                        [/p]
                        [p]
                            Barely able to breathe in between the rapid, rabid thrusts,
                            your throat involuntarily convulsing around the invading girth,
                            you find yourself [b]wishing[/b] you still had your teeth,
                            so you could [b]bite down[/b] and [b]chop off[/b] the insolent avian's length.
                            Luckily, as quickly as the facefuck had begun, so too does it end abruptly.
                            Falco pulls back, removing his cock from your mouth,
                            several thick strings of saliva connecting your muzzle to his shaft still.
                            You cough, gag and sputter, before taking a few deep, gasping breaths.
                        [/p]
                        [p]
                            But he's not finished yet.
                            "[color=yellow]You [b]suck[/b] at that.[/color]"
                            comes his upset, ironic commentary.
                            Again, you are left with little room to recover,
                            as the eagle crudely [b]kicks[/b] you backwards, onto the floor.
                            He crawls ontop of you, and while you're still trying to catch your breath,
                            he places his weapon at the hem of your maid outfit, slicing upwards, cutting the fabric in half,
                            removing your only piece of clothing by slicing it in two.
                        [/p]
                        [p]
                            Your legs are spread, and the boy presses his spit-lubed cockhead against your unprepared${virgin ? `, virginal` : ``} slit.
                            In between gasps for air, you [b]beg[/b] him not to do this, but it's too late.
                            With a single, violent thrust, he [b]rams[/b] himself inside of you,
                            hilting himself to the very base of his member.
                            ${virgin ? `A small trickle of blood signifies the loss of your virginity.` : ``}
                            You try to [b]scream[/b], but no words leave your well-fucked muzzle.
                            Lost for words, and out of breath, you silently lay atop the cold and dirty kitchen floor,
                            while Falco has his way with you.
                        [/p]
                        [hl]
                        [p]
                            And thus begins your life as the young bird's sex slave.
                            Day-in, day-out, he spends fucking his mother and you.
                            He violates your every hole, makes you eat his seed from Juliet's freshly fucked cunt,
                            forces you to lick his ass, his taloned feet, his armpits and various parts of his body,
                            and you serve as his urinal whenever he needs to take a leak.
                            If you object, you get [b]beaten[/b] to within an inch of your life.
                            You quickly learn just to give him what he wants.
                            It's easier that way, for everyone involved.
                        [/p]
                        [p]
                            The woman of the house seems to have completely [b]snapped[/b] ever since she watched her husband die,
                            or perhaps it was the vicious beating right before that, which broke her mind.
                            She is now a complete simpleton, barely able to do anything without your assistance.
                            You help eat, you let her squeeze your hand when Falco fucks her,
                            and your often find yourself taking her place, to spare her and her unborn child from the worst of the abuse.
                            Not that the bird cares.
                            As long as she can part her legs,
                            she could be comatose for all he cares.
                        [/p]
                        [p]
                            With no money coming in, and no new food being grown or bought,
                            the contents of late Romeo's storage closet are all you have to eat.
                            You, as usual, get nothing but [b]scraps[/b].
                            The avian dines like a king, seemingly not concerned with what'll happen once the food runs out.
                            His mother eats whatever you can get past her lips.
                            You wish she'd eat more,
                            but frankly speaking, there simply isn't enough to go around.
                            You're doing the best you can, rationing supplies to make sure you won't starve come next winter,
                            but things are looking grim.
                        [/p]
                        [p]
                            The three of you sleep in one bed, although nobody in this forsaken household gets all that much rest,
                            the eagle's libido keeping you awake throughout most nights.
                            Eventually, due to lack of sleep and severe physical and psychological trauma,
                            one day starts to blend into one another.
                            You quickly lose track of time.
                            Before you know it, Juliet's baby is born.
                            A heavily deformed, fully human boy.
                            He looks kind of like [i]Romeo[/i].
                        [/p]
                        [p]
                            [c]
                                [b]
                                    Half-harem end.
                                [/b]
                            [/c]
                        [/p]
                        [p]
                            [nl]
                            [small]
                                You have reached one of Kobold Adventure's irreversible endings.
                                Your actions have sealed the fate of ${name}.
                                This is where their storyline ends.
                                By saving the game, you can review your timeline using the aStory feature available via the menu.
                                If you wish to tempt fate once more, reload an earlier save, or start a new game and try again.
                                Remember: all things, both good and bad, must always come to an end.
                                The journey is as important as the destination is.
                                Is heaven worth going through hell for?
                            [/small]
                        [/p]`;

        return global.parser.parse(toReturn);
    }


    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {

    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\kid\toofar\tell\FarmerMaidTooFarServe.js

// scenes\Enslavement\DayTwo\FarmerMaid\kid\toofar\tell\FarmerMaidTooFarFight.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidTooFarFight(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = FarmerMaidTooFarTellChoice.FIGHT;
    var reqController = ctrl.toofarTell;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var name = ctrl.misc.name();
        var toReturn = `[p]
                            Your natural fight or flight responses kicking in, you drop into a combat stance.
                            If the bird wants a tussle, he can bring it on.
                            You bet he's never been in a scrap his entire life.
                            Advantage: kobold.
                            Besides, you've already made it this far, through torture and an entire year's worth of serving these filthy humans.
                            Not to mention the hardships you went through [b]before[/b] your enslavement.
                            You're not going to let your tale end at the hand of some stupid, young eagle!
                        [/p]
                        [p]
                            Falco makes his move, an overhead swing with his knife.
                            You swiftly dodge to the side, but before you manage to counter-attack comes another swipe,
                            this time more of a stab!
                            You dodge backwards, grabbing a conveniently placed stool off the ground and hurling it towards the avian.
                            The wooden piece of furniture hits him in the shoulder, forcing him back a little.
                            With an angry squawk, he kicks the tiny chair away.
                            It seems that all you've managed to do is piss him off even more.
                        [/p]
                        [p]
                            The two of you circle one another, the boy threateningly waving his knife around.
                            He's wielding it like an [b]amateur[/b],
                            but even an untrained fighter can do some serious damage with a sharp blade against an unarmed opponent.
                            He lashes out again, charging towards you, intent on stabbing your gut the way he did his father.
                            But unlike the farmer, you [i]aren't[/i] too flabbergasted to react.
                        [/p]
                        [p]
                            You skillfully push Falco's arm to the side, making his knife harmlessly soar right past you!
                            His defences down, you find the perfect opportunity to strike.
                            You instinctively swing your hand at the eagle's throat,
                            but it is only when your fingers [i]tap[/i] against his feathery neck instead of sinking into his skin,
                            that you remember that you [b]have[/b] no more claws to rake his flesh with!
                        [/p]
                        [p]
                            For a moment, the two of you awkwardly stare at eachother.
                            Then, the bird regains his composure, and [b]sinks[/b] his blade into your chest,
                            stabbing your very heart through a gap in between your ribs.
                        [/p]
                        [p]
                            You stare into his hate-filled eyes, your face uncontrollably drooping.
                            You try to speak, but no words leave your mouth.
                            Your legs grow weak.
                            Your sight goes black.
                            As Falco retracts the knife from your chest,
                            you fall forwards to the ground.
                            The rapidly expanding puddle of your blood mixes with Romeo's.
                        [/p]
                        [p]
                            During your last few moments of consciousness, you think back to when you were little.
                            Playing on the streets of Varanar, with other kobold children.
                            Begging for scraps.
                            How overly ecstatic you got when someone flipped a single coin your way.
                            That is what you want to dream of.
                            But all too soon your thoughts are enveloped by a deep, dark, all-consuming void,
                            as your dying mind can no longer sustain the illusion of peacefulness.
                            Together with you, so too die your memories.
                        [/p]
                        [p]
                            [c]
                                [b]
                                    Reverse vixen end.
                                [/b]
                            [/c]
                        [/p]
                        [p]
                            [nl]
                            [small]
                                You have reached one of Kobold Adventure's irreversible endings.
                                Your actions have sealed the fate of ${name}.
                                This is where their storyline ends.
                                By saving the game, you can review your timeline using the aStory feature available via the menu.
                                If you wish to tempt fate once more, reload an earlier save, or start a new game and try again.
                                Remember: all things, both good and bad, must always come to an end.
                                The journey is as important as the destination is.
                                Is heaven worth going through hell for?
                            [/small]
                        [/p]`;

        return global.parser.parse(toReturn);
    }


    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {

    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\kid\toofar\tell\FarmerMaidTooFarFight.js

// scenes\Enslavement\DayTwo\FarmerMaid\kid\toofar\FarmerMaidTooFarRun.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidTooFarRun(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = FarmerMaidTooFarChoice.RUN;
    var reqController = ctrl.toofar;
    var changeController = ctrl.toofarRun;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var name = ctrl.misc.name();
        var dick = ctrl.misc.dick();
        var virgin = ctrl.misc.analVirgin();
        var toReturn = `[p]
                            No matter how much it pains you to see the human get beaten by her son, this is not your fight.
                            In fact, however cruel this may sound, Juliet's intensive abuse is an [i]opportunity[/i] for you.
                            A chance, to finally escape this hell-hole, like you should have done [b]months[/b] ago.
                            But you weren't ready back then, neither physically nor mentally.
                            Your wounds still ached, and your mind was filled with fear.
                            But now you're more afraid of what will happen if you [b]do[/b] stay.
                        [/p]
                        [p]
                            Bidding a last, silent farewell to the lady of the house and her murderous son,
                            you sneak through the living room, towards the front door.
                            You silently open it, and exit the building, leaving behind your life of slavery.
                            The single street running through the hamlet is empty, devoid of all life.
                            Farmers must be working their fields.
                            This place seems to have grown bigger since your capture,
                            with a few new buildings around that you don't recall from the time of your auction.
                        [/p]
                        [p]
                            You creep towards Seki's workshop,
                            hoping the old bird will provide you sanctuary,
                            that he'll take you under his wing, quite literally.
                            But alas, the workshop seems [i]abandoned[/i].
                            The door is closed,
                            the windows are boarded up,
                            and gazing in through the cracks in between the planks,
                            you can see that his formerly pristine store has been completely [b]pilfered[/b],
                            once full racks now empty and barren, covered in dust.
                            You figure your only friend must have [i]moved away[/i] or something.
                        [/p]
                        [p]
                            Despite the lack of onlookers, your warily make your way to the edge of the hamlet.
                            You briefly consider escaping via the road to Varanar, but that'd be risky.
                            You could easily come across a farmer heading back from the city.
                            After a bit of consideration, and some sneaky snooping,
                            you decide to cross an old, muddy field, that looks like it hasn't been worked on for [b]years[/b], instead.
                            If you can make it to the other side, you can escape into a small patch of woodland, where you can hide until nightfall.
                        [/p]
                        [p]
                            Keeping low, you begin to make your way across the dilapidated farmland.
                            Traversing it is tough, and you cringe as you feel wet mud ooze into the holes where your toe-claws used to be,
                            but your conviction to escape is stronger than some icky soil.
                            You manage to make it about halfway through the field, before spotting some movement on the other side.
                        [/p]
                        [p]
                            Outside of the very patch of woodland you meant to hide in,
                            walks one of the big and burly horses you saw over a year ago,
                            first at the auction, and then again when your teeth and claws were removed.
                            Your heart sinks to your knees.
                            You freeze in place as his eyes fall upon you.
                        [/p]
                        [p]
                            You turn around, and begin to run back towards the hamlet,
                            hoping to be able to conceal yourself somewhere in the village.
                            Your lack of foot-claws hampers your movements,
                            your toes unable to dig into the dirt to propel yourself forwards.
                            The horse's hooves, meanwhile, prove to be the [b]perfect[/b] tools for crossing the watery field.
                            Combined with being nearly twice your size, the big man quickly catches up to you.
                        [/p]
                        [p]
                            Nearing the edge of the mire, the distance between the two of you has been reduced to nary but a few feet.
                            Then, a misfortunately placed rock spells your doom.
                            You trip, falling face-first into the mud.
                            You are too weary, in both body and soul, to get up once more.
                        [/p]
                        [p]
                            The horse catches up to you.
                            Without a word, he coarsely grabs you by your tail, and hoists you over his shoulder.
                            You don't bother to resist, the man strong enough to break you in half if he wanted to.
                            He carries you back into town, but to your surprise, he walks right past Romeo's house.
                            Instead, he carries you into another building, on the other end of the hamlet.
                        [/p]
                        [p]
                            Entering the hovel, the equine is met by his lookalike.
                            The one you figure must be his brother or twin or something.
                            With you still on his arm, the burly man carrying you embraces his [i]peer[/i].
                            The two press their muzzles together, and sloppily kiss one another for the better half of a minute,
                            while you are stuck in between their sweaty, muscular bodies.
                            You guess they're lovers, or maybe they just have a [i]very special[/i] familial bond.
                            Incest must run rampant around these parts.
                        [/p]
                        [p]
                            When the kiss finally breaks, the one holding you speaks.
                            "[color=purple]Brought you home a present, love.[/color]"
                            He's referring to [b]you[/b].
                            "[color=purple]Romeo didn't want to share, but now we've got'er all to ourselves.[/color]"
                            You don't like the sound of that.
                            "[color=purple]Seventeen coins wasn't enough for a [b]disposable fucktoy[/b],
                            but this time I plucked'em off of the old Butterscotch farm, for free.[/color]"
                        [/p]
                        [p]
                            [i]Disposable[/i]?
                            [b]Fucktoy[/b]?!
                            You begin to squirm around atop the horse's shoulder,
                            trying to wriggle your weary body off of him.
                            It's no use.
                            He's barely even [b]trying[/b] to hold you in place,
                            and still his grip may as well be a steel vice.
                            You aren't getting out of this.
                            You're [i]fucked[/i], in every sense of the word.
                        [/p]
                        [p]
                            The equine carries you to their bedroom.
                            He tosses you onto the bed,
                            and holds you in place while his [i]boyfriend[/i] ties your limbs spread-eagle to the bedposts.
                            After a bit of fooling around and shedding clothes,
                            they climb atop the bed themselves, the wood creaking loudly,
                            only [b]barely[/b] able to withstand their weight.
                        [/p]
                        [p]
                            The men are [b]massive[/b], in more than one way.
                            Their thick, foot-long, fully erect horse cocks ominously loom over your body,
                            a single droplet of heady precum dripping onto your chest.
                            One of them gets on his knees near your head, the other crawls ontop of you,
                            pressing the flared tip of his member against your tight, unlubed tailhole.
                        [/p]
                        [p]
                            They aren't [b]serious[/b] about this, right?
                            This is all some kind of [b]sick[/b] and [b]twisted[/b] joke.
                            There's no way that thing can fit inside of you!
                            You saw them kiss earlier!
                            You're a girl${dick ? ` now` : ``}!
                            Gay people don't fuck women!
                        [/p]
                        [p]
                            "[color=purple]Bisexual.[/color]"
                            the one on top of you responds.
                            Before you can think of any more protests to utter,
                            he rolls his hips back slightly, and then [b]plunges[/b] forwards,
                            [b]ramming[/b] his massive member inside of your rear,
                            [b]painfully[/b] stretching your ${virgin ? `virginal` : ``} tailhole to far beyond its limits,
                            a clear outline of his shaft showing through your distended belly.
                        [/p]
                        [p]
                            You [b]scream[/b] out in [b]agony[/b],
                            your insides feeling like they're about to [b]burst[/b],
                            if they haven't already been torn apart.
                            The horse straddling your face shoves his cock in your teeth-lacking muzzle to shut you up,
                            the flared tip pressing deep down into your throat, your neck bulging every bit as much as your lower body is.
                        [/p]
                        [p]
                            Having inserted themselves, the equines come to a temporary halt,
                            savoring the superb tightness of your ass and your throat.
                            You can't breathe.
                            The pain is excruciating.
                            You let out a weak gurgle around the girthy length plugging your muzzle,
                            uncomfortably forcing your jaws open as far as they can go.
                            Your lungs are [b]burning[/b], your mind [b]shrieking[/b] for air.
                        [/p]
                        [p]
                            In unison, they begin to thrust,
                            rocking your stretched frame back and forth ever so slightly,
                            the flared heads of their dicks visibly travelling up and down along your body.
                            To them, you are nothing but a sextoy.
                            And they don't intend to stop using you until you [b]break[/b].
                            Even [i]if[/i] they let you breathe, the internal damage has already been done.
                            The only choice they have is whether they want to kill you quickly, or let you die slowly.
                        [/p]
                        [p]
                            The former is what they choose.
                            The last thing you see before you pass out due to lack of air,
                            is the two horses lovingly kissing, their mouths meeting halfway above your body.
                            Consciousness abandons you, never to return.
                            They continue to fuck your lifeless body throughout the day,
                            using the cover of darkness to dump your cum-leaking corpse in the very same patch of woodland you thought would be your salvation.
                        [/p]
                        [p]
                            [c]
                                [b]
                                    Double horse end. Neigh neigh.
                                [/b]
                            [/c]
                        [/p]
                        [p]
                            [nl]
                            [small]
                                You have reached one of Kobold Adventure's irreversible endings.
                                Your actions have sealed the fate of ${name}.
                                This is where their storyline ends.
                                By saving the game, you can review your timeline using the aStory feature available via the menu.
                                If you wish to tempt fate once more, reload an earlier save, or start a new game and try again.
                                Remember: all things, both good and bad, must always come to an end.
                                The journey is as important as the destination is.
                                Is heaven worth going through hell for?
                            [/small]
                        [/p]`;

        return global.parser.parse(toReturn);
    }


    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {

    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\kid\toofar\FarmerMaidTooFarRun.js

// scenes\Enslavement\DayTwo\FarmerMaid\kid\toofar\FarmerMaidTooFarConfront.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidTooFarConfront(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = FarmerMaidTooFarChoice.CONFRONT;
    var reqController = ctrl.toofar;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var name = ctrl.misc.name();
        var toReturn = `[p]
                            Juliet might be [b]dead[/b] by the time you return here with Romeo in tow.
                            You've been ignoring the events playing out in front of you for over a year now.
                            But you can't sit by idly and watch her get beaten to death.
                            You have to act.
                            You have to [b]intervene[/b].
                            Maybe, a stern talking-to might save the day.
                            After all, he stopped harassing you when you told him to go away.
                        [/p]
                        [p]
                            You approach Falco from the side, and expertly catch one of his fists before it manages to impact with his mother's nose.
                            The bird is startled, only barely managing to refrain from punching [b]you[/b] out of fright.
                            "[color=yellow]Slave?
                            Let go of my hand.
                            What the [b]hell[/b] do you want?
                            Can't you see I'm in the middle of something?![/color]"
                        [/p]
                        [p]
                            While intimidated by his lack of restraint, you muster all of the courage you can,
                            and tell the kid that he [b]shouldn't[/b] beat his own mother.
                            She gave birth to him, and for all either of you know, she could very well be pregnant with his child!
                            You said nothing for all these months that he fucked around throughout the entire house,
                            and you kept quiet when sex turned to abuse,
                            but you can't watch him beat her like this.
                        [/p]
                        [p]
                            He needs to get a grip on himself.
                            He's starting to [i]lose it[/i].
                            What happened to the boy that was [i]anxious[/i] to touch you,
                            and immediately stopped when you told him to?
                            The eagle that [b]made love[/b] to his mother instead of beating her senseless?
                            Why is he so [b]angry[/b] and [b]upset[/b] all the time?
                            What changed since you arrived that caused him to grow so [b]violent[/b]?
                        [/p]
                        [p]
                            No answer.
                            The bird stares at you, his hateful expression seemingly faltering.
                            He looks to be growing [i]emotional[/i].
                            You think you're slowly starting to get to him.
                            You continue working on him.
                        [/p]
                        [p]
                            Things can't go on like this.
                            Look at Juliet.
                            Her eyes are so swollen, she can barely [b]see[/b]!
                            How is she supposed to witness her son growing up like this?
                            And her nose.
                            The avian broke her nose.
                            How is she supposed to [b]smell[/b] his [i]lustful loins[/i] through all of that blood?
                            Had he even considered that?
                        [/p]
                        [p]
                            He hadn't.
                            He was just working out his [b]frustration[/b] through violence.
                            And you understand.
                            Life sucks sometimes, and we all want to punch things every now and again.
                            But killing Juliet isn't going to make him any happier.
                            Surely, even through his blind rage, he can see that, right?
                        [/p]
                        [p]
                            You think you're really getting through to him.
                            One more push, and then you're certain he'll relent and give up his violent ways in favor of a healthy relationship with his mother.
                            As far as fucking daily can be considered healthy, that is.
                            Oh well, one problem at a time.
                        [/p]
                        [p]
                            You step in between the avian and his mother.
                            You've known him for over a year now.
                            And while you aren't the [i]best[/i] of friends,
                            you never once told his father about what he was doing to Juliet.
                            You don't really [i]want[/i] to ask for something in return, but he's left you with no choice.
                            You want him to stop hitting the woman of the house.
                            He can keep fucking her as far as you're concerned,
                            but he needs to stop the violent stuff.
                        [/p]
                        [p]
                            If he's really [b]that[/b] frustrated,
                            if he truly [b]must[/b] punch something to feel good about himself, well then.
                            You're right here.
                            He can hit [b]you[/b], if he has to.
                        [/p]
                        [p]
                            Falco's beak trembles.
                            He looks like he's about to [b]cry[/b].
                            But then, interrupting your [i]emotional moment[/i],
                            comes the bird's fist, barreling towards your gut.
                        [/p]
                        [p]
                            The eagle crudely [b]socks[/b] you in the gut,
                            before knocking you to the ground with a swift punch to your temple.
                            You scream out in pain, fearfully curling up into a ball on the floor.
                            "[color=yellow]Fine, you stupid lizard.
                            Guess I'll have to beat [b]you[/b] up instead, from now on.[/color]"
                            N-no!
                            That's not what you meant!
                            The avian crudely spits on your downed frame,
                            and delivers a kick to your back.
                            You don't think he's interested in hearing what you were [i]trying[/i] to accomplish here.
                        [/p]
                        [p]
                            While the injured Juliet crawls out of the room,
                            her son begins to [b]wallop[/b] on you, unleashing a [b]barrage[/b] of kicks and punches and scratches and scrapes.
                            Halfway through the brutal beatdown, an exceptionally hard [b]stomp[/b] to your forehead knocks you unconscious.
                            When you awaken, your entire body hurts.
                            You have bruises [b]everywhere[/b].
                            You can barely [b]stand[/b], let alone [b]walk[/b].
                            You limp over towards your basket, and fall asleep.
                            Your new life, as Falco's stress relief, has begun.
                        [/p]
                        [p]
                            [c]
                                [b]
                                    Punching bag end.
                                [/b]
                            [/c]
                        [/p]
                        [p]
                            [nl]
                            [small]
                                You have reached one of Kobold Adventure's irreversible endings.
                                Your actions have sealed the fate of ${name}.
                                This is where their storyline ends.
                                By saving the game, you can review your timeline using the aStory feature available via the menu.
                                If you wish to tempt fate once more, reload an earlier save, or start a new game and try again.
                                Remember: all things, both good and bad, must always come to an end.
                                The journey is as important as the destination is.
                                Is heaven worth going through hell for?
                            [/small]
                        [/p]`;

        return global.parser.parse(toReturn);
    }


    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {

    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\kid\toofar\FarmerMaidTooFarConfront.js

// scenes\Enslavement\DayTwo\FarmerMaid\kid\toofar\FarmerMaidTooFar.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidTooFar(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.daily;
    var subController = ctrl.toofar;
    var changeController = false;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";
    var thirdId = arguments.callee.name + "ButtonThree";

    var firstNext = new FarmerMaidTooFarRun(ctrl);
    var secondNext = new FarmerMaidTooFarTell(ctrl);
    var thirdNext = new FarmerMaidTooFarConfront(ctrl);

    var firstChoice = FarmerMaidTooFarChoice.RUN;
    var secondChoice = FarmerMaidTooFarChoice.TELL;
    var thirdChoice = FarmerMaidTooFarChoice.CONFRONT;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            After the day that marks the end of your first year of servitude,
                            the relationship between Falco and Juliet rapidly deteriorates into outright physical abuse.
                            One fateful afternoon, you walk in on the bird repeatedly burying his knuckles into the human's side while pounding her from behind.
                            She [b]begs[/b] for him to stop, but he mercilessly continues to batter her kidneys,
                            his blows intensifying the closer he gets to reaching his end, his climax marked by his mother's screams of pain.
                        [/p]
                        [p]
                            The eagle seems to have taken a liking to punching the woman while fucking her.
                            An extra outlet for all of his built-up frustration and years of bottled emotions, you reckon.
                            But you're no psychiatrist.
                            You must have walked in on them during the first time Falco turned to violence,
                            or maybe he simply doesn't care enough to muffle her bawling anymore.
                            Either way, loud pained grunts and agonized shouts become a daily affair.
                            While they never really bothered to hide themselves from you,
                            now all you have to do is follow the screams to find them fucking.
                        [/p]
                        [p]
                            At first, the avian only hits Juliet during sex,
                            the human writing it off as a [i]heat of the moment[/i] thing.
                            You can tell that she [b]hates[/b] it, and desperately wants to tell him to cut it out,
                            but she's become too intimidated of her own son to stand up to him.
                            It's only a few scratches and bruises.
                            Nothing she can't take.
                            What kind of woman [i]wouldn't[/i] let her child punch her while raping her?
                            R-right?
                        [/p]
                        [p]
                            Falco usually focusses on abusing her body, but as days go by, his mother's face grows less and less off-limits.
                            It starts with a few rougher-than-usual backhand slaps, but quickly escalates to full-on face-punches.
                            Juliet often leaves their sadistic get-togethers with a bloodied nose,
                            and her eyesockets are almost permanently battered black and blue.
                            You wonder how her husband hasn't noticed yet.
                            Maybe he figures, somewhat correctly, that she's being beaten by her secret lover.
                            That she's getting her comeuppance for cheating on him.
                        [/p]
                        [p]
                            Half a month of violence later, you find the avian using the woman's bloated tits as punching bags,
                            pinning her to the wall while beating her lactating udders until they grow [b]purple[/b],
                            squeezing her neck shut to choke out any resistance.
                            The strangling's a rather recent development,
                            but you've never seen him do it outside of missionary-position fucking.
                        [/p]
                        [p]
                            He isn't even hurting her because it excites him.
                            Not anymore, at least.
                            Now he's just doing it to prove a point.
                            You have no idea [i]what[/i] that point may be,
                            but it's the only explanation you can come up with for why he's acting this way.
                        [/p]
                        [p] 
                            The day after that, the boy repeats the process,
                            only this time he [b]bashes[/b] his mother's pregnant belly instead of her aching breasts.
                            Juliet's pleas for [b]mercy[/b] are like daggers through your heart,
                            especially when she gurgles out for him to think of the baby.
                            From where you're standing, it looks like he's specifically [b]trying[/b] to get rid of the child.
                            You want to intervene, but you fear what might happen to [b]you[/b] should you do so.
                            Either way, the cruel treatment is quickly getting out of hand.
                            Things can't go on like this.
                        [/p]
                        [p]
                            The third day in a row of hate-filled clobbering, his mom's face is Falco's target.
                            He [b]pummels[/b] her visage, beating both of her eyes fully shut.
                            You watch in horror from the kitchen doorway as he proceeds to beat her from side to side,
                            throwing hooks and haymakers at her cheeks.
                            One of her teeth gets knocked out of her mouth, and then with a sickening [i]snap[/i],
                            the woman's nose bends out of place, the bone broken.
                        [/p]
                        [p]
                            Falco keeps hitting her, over and over and over again.
                            You fear he might not stop until she's [b]dead[/b].
                            You don't want Juliet to die.
                            Your conscience would never let you live it down.
                            It's not only her fault that things have gotten this bad, but [b]yours[/b] as well.
                            You should have intervened, or told Romeo about this entire ordeal [b]months[/b] ago.
                            You need to step in [b]now[/b], or else it'll be too late.
                        [/p]
                        [p]
                            On the other hand, with Falco occupied with his mother,
                            and the man of the house not around,
                            you [i]could[/i] try to make a run for it.
                            Your injuries [i]have[/i] healed nicely.
                            And Romeo'll be too heartbroken when he sees his wife's sorry state
                            -- if she'll even be alive by the time he gets home -- to come after you.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === firstChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${firstId}" ${disabled}>Run away</button>`;

        var tooltip = global.parser.parse(`Use the lack of attention to slip away from the house, and escape your duties.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 160px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === secondChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${secondId}" ${disabled}>Tell dad</button>`;

        var tooltip = global.parser.parse(`Inform the father of the family of his son's [i]wild[/i] behavior.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 160px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildThirdChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === thirdChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${thirdId}" ${disabled}>Confront him</button>`;

        var tooltip = global.parser.parse(`Get in between the kid and his mother.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 160px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You:</div>`;
        choice += buildFirstChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildThirdChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId), $("#" + thirdId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(firstChoice);
            loadNextPart(firstNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(secondChoice);
            loadNextPart(secondNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerThirdListener() {
        $("#" + thirdId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(thirdChoice);
            loadNextPart(thirdNext);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += firstNext.build();
        part += secondNext.build();
        part += thirdNext.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        firstNext.registerListeners();
        secondNext.registerListeners();
        thirdNext.registerListeners();

        if (subController.has()) {
            return;
        }

        registerFirstListener();
        registerSecondListener();
        registerThirdListener();
    };
}

var FarmerMaidTooFarChoice = {
    RUN: 1,
    TELL: 2,
    CONFRONT: 3
};

// END scenes\Enslavement\DayTwo\FarmerMaid\kid\toofar\FarmerMaidTooFar.js

// scenes\Enslavement\DayTwo\FarmerMaid\kid\girlfriend\jealous\FarmerMaidGirlfriendKill.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidGirlfriendKill(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = FarmerMaidGirlfriendJealousChoice.KILL;
    var reqController = ctrl.jealous;
    var changeController = ctrl.girlfriendKill;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var virgin = ctrl.misc.cuntVirgin();
        var name = ctrl.misc.name();
        var toReturn = `[p]
                            There's only one logical conclusion to this situation.
                            You have to [b]get rid[/b] of Falco's girlfriend.
                            And you have to do it [b]fast[/b].
                            If you wait too long, she might get the bird to kick you out of the house.
                            And that would [b]ruin[/b] your chances with him.
                            You have to act [b]now[/b].
                            You'll make your move tonight.
                        [/p]
                        [p]
                            Grabbing a knife from the kitchen,
                            you creep up the staircase.
                            You gaze into their room, as you've done dozens of times before.
                            The bitch is riding his dick.
                            She thinks he's [b]hers[/b].
                            But she's wrong.
                            Falco is [b]yours[/b].
                            He has been ever since the very first day he laid his hands upon you.
                            And once she's gone, you'll finally be able to [b]claim[/b] him.
                        [/p]
                        [p]
                            You open the door to their bedroom.
                            They don't even hear you enter, their loud moans and the creaking of the bed dampening your footsteps.
                            You sneak towards the foot-rest of the bed,
                            and crawl atop the soft mattress, coming up in-between Falco's legs, behind his girlfriend's back, your knife at the ready.
                        [/p]
                        [p]
                            Mustering all of your [b]love[/b] for the avian,
                            and all of your [b]hate[/b] for the human,
                            you swing your knife at her head, [b]stabbing[/b] the back of her skull,
                            sinking your blade into her airheaded brain.
                            Her body instantly goes limp.
                            A perfect strike.
                            Falco doesn't even realize what's going on.
                            "[color=yellow]Hey baby, why'd you stop?[/color]"
                            [i]Baby[/i].
                            He'll be calling you that in a minute.
                            You get excited just thinking about it.
                        [/p]
                        [p]
                            You retract the knife from the woman's head,
                            and mustering all of your strength, you [b]push[/b] her lifeless body off of your lover-to-be.
                            Falco panics as his girlfriend tumbles off the bed,
                            doubly so as he sees you sitting on the bed with a bloodied blade in your hand.
                            He freezes up in fear.
                            How [b]cute[/b]!
                        [/p]
                        [p]
                            You act fast, straddling his chest, pressing your knife against his throat.
                            He's not going anywhere.
                            Licking your lips, you raise your perky rear and [b]plunge[/b] yourself down onto his length.
                            ${virgin ? `A small trickle of blood signifies the loss of your virginity.` : ``}
                            Like the crazy kobold you are, you begin to expertly ride his dick,
                            milking orgasm after orgasm from your forcefully kept [b]boyfriend[/b].
                            Finally, you are united.
                            For the first time in your life, you feel whole.
                            Made complete, by making love to your unwilling [b]husband[/b].
                        [/p]
                        [p]
                            [c]
                                [b]
                                    Yandere end.
                                [/b]
                            [/c]
                        [/p]
                        [p]
                            [nl]
                            [small]
                                You have reached one of Kobold Adventure's irreversible endings.
                                Your actions have sealed the fate of ${name}.
                                This is where their storyline ends.
                                By saving the game, you can review your timeline using the aStory feature available via the menu.
                                If you wish to tempt fate once more, reload an earlier save, or start a new game and try again.
                                Remember: all things, both good and bad, must always come to an end.
                                The journey is as important as the destination is.
                                Is heaven worth going through hell for?
                            [/small]
                        [/p]`;

        return global.parser.parse(toReturn);
    }


    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {

    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\kid\girlfriend\jealous\FarmerMaidGirlfriendKill.js

// scenes\Enslavement\DayTwo\FarmerMaid\kid\girlfriend\jealous\FarmerMaidGirlfriendJealous.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidGirlfriendJealous(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = FarmerMaidGirlfriendChoice.JEALOUS;
    var reqController = ctrl.girlfriend;
    var subController = ctrl.jealous;
    var changeController = false;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";

    var firstNext = new FarmerMaidGirlfriendFrame(ctrl);
    var secondNext = new FarmerMaidGirlfriendKill(ctrl);

    var firstChoice = FarmerMaidGirlfriendJealousChoice.FRAME;
    var secondChoice = FarmerMaidGirlfriendJealousChoice.KILL;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            Falco's girlfriend is a [b]bitch[/b].
                            Whenever she's home, she [b]constantly[/b] bosses you around.
                            She makes you fetch her drinks, she forces you to clean and file down her nails,
                            she gets you to feed her grapes so she doesn't have to tire her arms out,
                            and she even uses your back as a [b]footrest[/b] more than once.
                            If you don't comply to her wishes, she denies you your daily morsel of food.
                        [/p]
                        [p]
                            She acts like she's the [b]queen[/b] of the humans, or something.
                            But all she rules is this hovel, her boyfriend, and sadly enough, [b]you[/b].
                            Since he's started working the farm, Falco's attitude has improved a lot.
                            He's slowly starting to [b]respect[/b] you, and all of the work that you do.
                            It feels nice, to have someone [b]congratulate[/b] you,
                            and telling you that you did a [b]good job[/b].
                            You're slowly starting to grow closer to your new master.
                        [/p]
                        [p]
                            The new woman of the house, however, continues to act like a complete [b]cunt[/b].
                            She has you re-do your sweeping because you [i]missed a spot[/i],
                            she viciously criticizes you even if you abide by her wishes,
                            and she even talks bad to Falco about you,
                            sometimes going as far as telling [b]lies[/b] to make you seem worse.
                        [/p]
                        [p]
                            The worst part of all of this, is that at the end of the day,
                            it's [b]her[/b] that gets to sleep in bed with the bird, and not you.
                            You're not even allowed to use his parents' now-empty room,
                            thanks to her objections.
                            It's not fair.
                            She does [b]nothing[/b] for him, and he loves her to [b]death[/b].
                            You work your ass off, and some rare thanks are all you get in return.
                        [/p]
                        [p]
                            You find yourself creeping around their room at night,
                            spying on them [b]fucking[/b] through the cracks in the wooden door.
                            One night, he pounds her brains out in missionary position,
                            the next day she rides him like the lusty [b]whore[/b] that she is,
                            a week later he fucks the bitch doggy-style.
                            Every time, they both end their intense lovemaking bouts completely euophoric.
                            You do all the work around here.
                            That should be [b]you[/b] the bird is making happy, and not [b]her[/b].
                        [/p]
                        [p]
                            While your unrequited attraction to Falco grows with every passing day,
                            so too does your [b]detest[/b] for his girlfriend.
                            During meals, you affectionately sit on the ground next to him,
                            occasionally nuzzling against or hugging his feathery leg.
                            He laughingly dismisses your behavior, treating you like a [i]dog[/i] begging for scraps.
                            Meanwhile, you cast hateful glares at the human, and hiss at her whenever she looks at you the wrong way.
                            All outside of your bird-crush's view, of course.
                        [/p]
                        [p]
                            A few months after Romeo and Juliet have left,
                            the human girl starts to leave the house during the day.
                            You don't know what she heads off to do, and you don't really [i]care[/i].
                            You're glad that you finally get a few short periods to yourself.
                            Not only because you wanted the privacy, but also because this allows you to start [b]planning[/b] and [b]scheming[/b].
                            You have to do something about her.
                            But what?
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === firstChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${firstId}" ${disabled}>Frame her</button>`;

        var tooltip = global.parser.parse(`Make it seem like she's sleeping around. Once there's trouble in paradise, you can make your move.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 180px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === secondChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${secondId}" ${disabled}>Kill her</button>`;

        var tooltip = global.parser.parse(`You don't think the bird's a necrophile. He'll be all yours once she's out of the picture.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 180px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You:</div>`;
        choice += buildFirstChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(firstChoice);
            loadNextPart(firstNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(secondChoice);
            loadNextPart(secondNext);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += firstNext.build();
        part += secondNext.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        firstNext.registerListeners();
        secondNext.registerListeners();

        if (subController.has()) {
            return;
        }

        registerFirstListener();
        registerSecondListener();
    };
}

var FarmerMaidGirlfriendJealousChoice = {
    FRAME: 1,
    KILL: 2
};

// END scenes\Enslavement\DayTwo\FarmerMaid\kid\girlfriend\jealous\FarmerMaidGirlfriendJealous.js

// scenes\Enslavement\DayTwo\FarmerMaid\kid\girlfriend\frame\FarmerMaidGirlfriendUsurp.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidGirlfriendUsurp(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = FarmerMaidGirlfriendFrameChoice.USURP;
    var reqController = ctrl.frame;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var name = ctrl.misc.name();
        var toReturn = `[p]
                            Now is the perfect moment to swoop in, and claim what is yours.
                            You take a seat next to Falco, and comfortingly pat his back.
                            You rest your shoulder on his head, and plant a few harmless kisses on his feathery cheek.
                            No response.
                            That means you're clear to continue.
                        [/p]
                        [p]
                            You place your free hand on his thigh.
                            He looks at you, with doubt in his eyes.
                            You tell him it's okay.
                            You move your hand to his belt buckle, and deftly undo it.
                            His girlfriend's a cheating whore.
                            You reach into his pants, grab on to his flaccid length,
                            and lustfully stroke it.
                            It rapidly hardens in your grasp.
                        [/p]
                        [p]
                            But who needs a stupid human like her anyway?
                            You pull down his pants, revealing his erect member, a bauble of precum already formed at the foreskin-covered tip.
                            Surely, not [b]him[/b].
                            You change positions, stradling his lap, hugging him tenderly while his shaft presses against your needy slit.
                            Especially not considering...
                            You plant several kisses on his beak.
                            He finally begins to reciprocate, his hands roaming over your body, squeezing your breasts and groping your butt.
                            ...that he still has [b]you[/b].
                        [/p]
                        [p]
                            Those words said, you lift your body up, before lowering yourself onto his member,
                            impaling your cunt with his rock-hard girth, letting out a loving moan as you take every inch of him to the very base of his cock.
                            His breath audibly grows heavier.
                            The doubt in his eyes is replaced by [b]lust[/b].
                            The avian takes control.
                            He grabs your butt, and lifts you up slightly,
                            before starting to [b]thrust[/b] upwards,
                            returning your kisses as he begins to fuck you properly.
                        [/p]
                        [p]
                            Several hours of sweaty bird sex later, you find yourself idly riding Falco's length,
                            large amounts of his spunk spilling from your cunt already.
                            Still not enough.
                            You want more.
                            You want [b]all[/b] of it.
                            You're not stopping until his balls are completely [b]dry[/b],
                            and his body is so [b]dehydrated[/b] it can't possibly produce any tears to weep for the [b]slut[/b] he's leaving behind.
                        [/p]
                        [p]
                            Speak of the devil,
                            in the distance, you hear the front door open.
                            The eagle's [b]ex[/b]-girlfriend walks up the stairs,
                            and freezes in the doorway, her mouth falling agape as she sees the two of you together.
                            You shoot her a wicked grin, and stick out your tongue to mock her,
                            letting out a loud moan to let her know how much [b]fun[/b] you're having.
                            Falco is [b]yours[/b] now.
                        [/p]
                        [p]
                            [c]
                                [b]
                                    Eagle end.
                                [/b]
                            [/c]
                        [/p]
                        [p]
                            [nl]
                            [small]
                                You have reached one of Kobold Adventure's irreversible endings.
                                Your actions have sealed the fate of ${name}.
                                This is where their storyline ends.
                                By saving the game, you can review your timeline using the aStory feature available via the menu.
                                If you wish to tempt fate once more, reload an earlier save, or start a new game and try again.
                                Remember: all things, both good and bad, must always come to an end.
                                The journey is as important as the destination is.
                                Is heaven worth going through hell for?
                            [/small]
                        [/p]`;

        return global.parser.parse(toReturn);
    }


    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {

    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\kid\girlfriend\frame\FarmerMaidGirlfriendUsurp.js

// scenes\Enslavement\DayTwo\FarmerMaid\kid\girlfriend\frame\FarmerMaidGirlfriendFrame.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidGirlfriendFrame(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = FarmerMaidGirlfriendJealousChoice.FRAME;
    var reqController = ctrl.jealous;
    var subController = ctrl.frame;
    var changeController = false;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";

    var firstNext = new FarmerMaidGirlfriendUsurp(ctrl);
    var secondNext = new FarmerMaidGirlfriendCapture(ctrl);

    var firstChoice = FarmerMaidGirlfriendFrameChoice.USURP;
    var secondChoice = FarmerMaidGirlfriendFrameChoice.CAPTURE;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            You need to get rid of Falco's girlfriend somehow.
                            With the way she's been acting lately,
                            you wouldn't be surprised if she started [b]nagging[/b] her boyfriend to [b]kick you out[/b].
                            And that would [b]ruin[/b] your chances with him.
                            You can't have that.
                            You need to frame her, somehow.
                            But, besides being a [b]lazy whore[/b], she doesn't really do anything [i]wrong[/i].
                            Hmph.
                        [/p]
                        [p]
                            The next time the woman leaves the house, you sneak out after her.
                            Making sure you aren't seen by anyone, you trail her as she makes her way to the other side of the hamlet.
                            This place sure has gotten big since the start of your enslavement.
                            You follow her all the way to a single-story home, on the very edge of town.
                            She knocks on the door, and a few moments later, a big and burly,
                            scantily-clad, brown-furred canine stud invites her in.
                        [/p]
                        [p]
                            The sounds of intense, raw [b]breeding[/b] echo from the building.
                            The human moans like the rabid [b]slut[/b] that she is,
                            while her doggy lover knot-fucks the ever-loving shit out of her.
                            Heh.
                            You always called her a [b]bitch[/b].
                            She's a [i]clever[/i] bitch, though.
                            By doing this [b]here[/b], and not at home,
                            she doesn't really leave any [i]evidence[/i] behind.
                            You doubt Falco would take your word over hers,
                            and he's too busy working the farm to join you in [i]playing detective[/i].
                        [/p]
                        [p]
                            Looks like you're going to have to [i]cheat[/i] a little yourself.
                            All is fair in love and war, right?
                            Through an open window and a bedroom door carelessly left ajar,
                            you witness their carnal [b]mating[/b].
                            You wait until the canine's finished pumping load after load of spunk into his human fucktoy.
                            Once they're all tuckered out,
                            she redresses, but he stays naked as he escorts her back to the front door.
                            There's your chance.
                        [/p]
                        [p]
                            You sneak in through the open window, bolt to the bedroom,
                            [b]snatch[/b] his loincloth from the bed, and vanish before anyone even knew you were there.
                            Phase one, completed.
                            You head back home, arriving before your [i]mistress[/i] does, and pretend to be working.
                            You hide the stolen loincloth in a dresser.
                            She's completely oblivious that you are aware of her secret.
                            Just as planned.
                        [/p]
                        [p]
                            The next day, she goes to fuck her secret lover again.
                            This time, you don't follow.
                            You head up to the bedroom that Romeo and Juliet used to sleep in,
                            ruffle the sheets of their long-unused bed, and toss the male garment ontop.
                            At noon, Falco comes home to have a snack.
                            You tell him that his girlfriend brought some guy you didn't know back here.
                            They went up to his parents' old room, and while you don't want to make any accusations,
                            you [i]think[/i] they had sex there.
                            Afterwards, the two walked out the door once more, holding hands.
                        [/p]
                        [p]
                            Romeo is shook.
                            He tells you that you better not be lying.
                            You assure him that you're not.
                            You didn't really [i]want[/i] to tell him,
                            but you'd rather break his heart than have him live as a [b]cuckold[/b] for the rest of his life.
                        [/p]
                        [p]
                            Still, he doesn't believe you.
                            You lead him up the stairs, and into the bedroom.
                            The evidence you planted is still there.
                            His beady bird eyes go wide.
                            He takes a seat on the edge of the bed, unable to process his entire life tumbling down.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === firstChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${firstId}" ${disabled}>Usurp her</button>`;

        var tooltip = global.parser.parse(`Boot her out. Take her place. Become the girlfriend.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 200px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === secondChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${secondId}" ${disabled}>Capture her</button>`;

        var tooltip = global.parser.parse(`Keep her around. Make her clean for you.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 180px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You:</div>`;
        choice += buildFirstChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(firstChoice);
            loadNextPart(firstNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(secondChoice);
            loadNextPart(secondNext);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += firstNext.build();
        part += secondNext.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        firstNext.registerListeners();
        secondNext.registerListeners();

        if (subController.has()) {
            return;
        }

        registerFirstListener();
        registerSecondListener();
    };
}

var FarmerMaidGirlfriendFrameChoice = {
    USURP: 1,
    CAPTURE: 2
};

// END scenes\Enslavement\DayTwo\FarmerMaid\kid\girlfriend\frame\FarmerMaidGirlfriendFrame.js

// scenes\Enslavement\DayTwo\FarmerMaid\kid\girlfriend\frame\FarmerMaidGirlfriendCapture.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidGirlfriendCapture(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = FarmerMaidGirlfriendFrameChoice.CAPTURE;
    var reqController = ctrl.frame;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var name = ctrl.misc.name();
        var toReturn = `[p]
                            Now is the perfect moment to swoop in, and claim what is yours.
                            You take a seat next to Falco, and comfortingly pat his back.
                            You say that, while you're his slave and all,
                            and your opinion is [i]worthless[/i], you [i]may[/i] have a way of getting back at her.
                            He perks up, and faces you, his interest clearly piqued.
                            The two of you form a devious plan.
                        [/p]
                        [p]
                            Hours later, the bird's [b]ex[/b]-girlfriend comes home.
                            Hiding behind the door, he pops out and [b]snags[/b] the bitch by pulling a small burlap sack over her head.
                            She struggles fiercely, but she's physically [b]no match[/b] for the farmwork-toned eagle.
                            You help to hold her, but not a lot.
                            Once she's calmed down, the two of you escort her to the [i]workshop[/i].
                        [/p]
                        [p]
                            Romeo's friends, the same ones that helped de-fang [b]you[/b],
                            are already waiting for you there.
                            They were more than eager to help, after hearing how the girl had broken their wealthy comrade's son's heart.
                            They keep her in place, her pants tugged down to her knees, her bare rear exposed.
                            You, having come up with this idea, get to do the honors.
                            You retrieve one of the blazing hot irons from the nearby kiln,
                            the same one that was used to mark you.
                            Mercilessly, you press the scorching metal against her smooth-skinned ass, burning the slave-insignia into her flesh.
                        [/p]
                        [p]
                            The lady passes out.
                            When she wakes up, she finds herself in the dog basket that you called your bed for the longest of times.
                            The tables have turned.
                            [i]She[/i] is [b]your[/b] maid now.
                            And if she [b]dares[/b] to leave this house,
                            then the other farmers'll get her,
                            and do [b]horrible[/b] things to her.
                            If Falco doesn't catch her first.
                        [/p]
                        [p]
                            You'd give her your maid outfit, but you don't think it'd fit her, so she'll just have to walk around [b]naked[/b] instead.
                            You've already sold her clothes to buy yourself some extra-nice massage oil, which she can use to rub your feet tomorrow.
                            If she wants to eat, that is.
                            Anyway, Falco already went to bed.
                            It's about time you go join him.
                            After all, you're the kind of girlfriend he [b]deserves[/b].
                            With a cackling laugh, you turn around and walk away,
                            heading up the stairs to spend the first night together with your new [b]lover[/b].
                            Maybe when you're finished fucking, the slave can clean you using her mouth.
                        [/p]
                        [p]
                            [c]
                                [b]
                                    Anti-maid end.
                                [/b]
                            [/c]
                        [/p]
                        [p]
                            [nl]
                            [small]
                                You have reached one of Kobold Adventure's irreversible endings.
                                Your actions have sealed the fate of ${name}.
                                This is where their storyline ends.
                                By saving the game, you can review your timeline using the aStory feature available via the menu.
                                If you wish to tempt fate once more, reload an earlier save, or start a new game and try again.
                                Remember: all things, both good and bad, must always come to an end.
                                The journey is as important as the destination is.
                                Is heaven worth going through hell for?
                            [/small]
                        [/p]`;

        return global.parser.parse(toReturn);
    }


    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {

    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\kid\girlfriend\frame\FarmerMaidGirlfriendCapture.js

// scenes\Enslavement\DayTwo\FarmerMaid\kid\girlfriend\FarmerMaidGirlfriendAccept.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidGirlfriendAccept(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = FarmerMaidGirlfriendChoice.ACCEPT;
    var reqController = ctrl.girlfriend;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var name = ctrl.misc.name();
        var toReturn = `[p]
                            This is how you imagined being a maid would be,
                            at the start of your enslavement.
                            No abuse, no molestation, just you, a broom, a duster, a mop and a house to tidy.
                            While his girlfriend can be a bit [i]bossy[/i] at times,
                            you learn that if you just give her what she wants,
                            she becomes a lot easier to deal with.
                            She isn't around a lot anyway.
                            Always out running [i]errands[/i] during the day.
                        [/p]
                        [p]
                            A few months later, the inevitable happens.
                            Falco's girlfriend has gotten pregnant.
                            The news that he's going to become a parent seems to improve the avian's demeanor, by a lot.
                            You get the feeling he starts to [b]respect[/b] you for the things you do around the house,
                            instead of taking you for granted.
                            After being coddled for his entire life, he's finally starting to mature.
                            Perhaps it's all the farm work turning him into a [b]man[/b].
                            Or maybe it really [i]is[/i] his impending fatherhood.
                        [/p]
                        [p]
                            You get a bit more scraps thrown your way, which you are grateful for.
                            Other than that, you keep working, and so does he.
                            His girlfriend continues to be mostly [i]absent[/i].
                            Even late into her pregnancy, she still goes to wander around the hamlet on a daily basis.
                            You wonder what she's doing all the time.
                            She sure as heck isn't going grocery shopping like Juliet used to.
                            Perhaps she's visiting her own family, or something?
                        [/p]
                        [p]
                            You keep wondering what the human gets up to during the day for several months more.
                            Then, during the birth of their child,
                            it finally becomes clear to you.
                            A healthy baby girl.
                            But instead of a beak, talons, feathers or other avian features,
                            Falco's daughter has a thin coat of brown fur.
                        [/p]
                        [p]
                            [c]
                                [b]
                                    Maid end.
                                [/b]
                            [/c]
                        [/p]
                        [p]
                            [nl]
                            [small]
                                You have reached one of Kobold Adventure's irreversible endings.
                                Your actions have sealed the fate of ${name}.
                                This is where their storyline ends.
                                By saving the game, you can review your timeline using the aStory feature available via the menu.
                                If you wish to tempt fate once more, reload an earlier save, or start a new game and try again.
                                Remember: all things, both good and bad, must always come to an end.
                                The journey is as important as the destination is.
                                Is heaven worth going through hell for?
                            [/small]
                        [/p]`;

        return global.parser.parse(toReturn);
    }


    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {

    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\kid\girlfriend\FarmerMaidGirlfriendAccept.js

// scenes\Enslavement\DayTwo\FarmerMaid\kid\girlfriend\FarmerMaidGirlfriend.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidGirlfriend(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.daily;
    var subController = ctrl.girlfriend;
    var changeController = false;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";

    var firstNext = new FarmerMaidGirlfriendJealous(ctrl);
    var secondNext = new FarmerMaidGirlfriendAccept(ctrl);

    var firstChoice = FarmerMaidGirlfriendChoice.JEALOUS;
    var secondChoice = FarmerMaidGirlfriendChoice.ACCEPT;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var frigid = ctrl.maid.get() === FarmerMaidMaidChoice.RESIST;
        var eager = ctrl.maid.get() === FarmerMaidMaidChoice.ABIDE;
        var hand = ctrl.parents.get() === ctrl.parentsChoice.HANDJOB;
        var toReturn = `[p]
                            For more than a year,
                            life continues as usual.
                            You clean, Romeo works, Juliet shops, and Romeo fucks his bride-to-be day-in, day-out.
                            It's a miracle she hasn't gotten pregnant yet,
                            but that's none of your concern.
                        [/p]
                        [p]
                            In Spring of your second year as the family's maid,
                            the farmer makes a sudden announcement.
                            He is [b]retiring[/b].
                            Harvest has been [b]so[/b] good these past couple of seasons,
                            that he's earned enough money to buy him and his wife a fancy house in the city,
                            where he can live the rest of his life in peace and luxury, especially compared to this [i]dump[/i].
                        [/p]
                        [p]
                            The eagle is excited, thinking his girlfriend and him could tag along, but alas, that was not in his father's plans.
                            The older human thinks it's time for his son to live on his own.
                            He grants Falco sole ownership over the farm, the house, and over [b]you[/b].
                            Despite protests from both you and the the coddled avian,
                            Romeo's mind is made up.
                            The next week, Julia and him move out of the house, leaving you all alone with the bird and his lover.
                        [/p]
                        [p]
                            Luckily, not much changes for you.
                            Falco spends most days on the field, growing crops for his girl and him to eat.
                            You get scraps of food, in return for keeping the house clean.
                            For the rest, he doesn't really bother you.
                            When he's not working, he's too busy fucking his human partner to pay you much mind.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === firstChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${firstId}" ${disabled}>Grow jealous</button>`;

        var tooltip = global.parser.parse(`Why should that bitch get to hog the bird all to herself?`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 195px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === secondChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${secondId}" ${disabled} style="width:180px;">Accept your place</button>`;

        var tooltip = global.parser.parse(`Being a maid without getting harassed all the time has its perks.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 165px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice" style="width:180px;">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You:</div>`;
        choice += buildFirstChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(firstChoice);
            loadNextPart(firstNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(secondChoice);
            loadNextPart(secondNext);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += firstNext.build();
        part += secondNext.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        firstNext.registerListeners();
        secondNext.registerListeners();

        if (subController.has()) {
            return;
        }

        registerFirstListener();
        registerSecondListener();
    };
}

var FarmerMaidGirlfriendChoice = {
    JEALOUS: 1,
    ACCEPT: 2
};

// END scenes\Enslavement\DayTwo\FarmerMaid\kid\girlfriend\FarmerMaidGirlfriend.js

// scenes\Enslavement\DayTwo\FarmerMaid\parents\amorous\FarmerMaidAmorousThigh.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidAmorousThigh(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = ctrl.parentsChoice.NOPEN;
    var reqController = ctrl.parents;
    var subController = ctrl.postParents;
    var changeController = false;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = ctrl.fragments.amorousDaily;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            Listen, you can't just let him fuck you.
                            The bird's face sours, but you interrupt him before he manages to start pouting.
                            But there [i]is[/i] something pretty good that you can show him.
                            Something the two of you haven't tried yet.
                        [/p]
                        [p]
                            You approach the boy,
                            and grab on to his solid, quivering cock.
                            "[color=yellow]Not [i]another[/i] handjob. That's [b]boring[/b]![/color]"
                            You tell him to calm down, and to keep his voice down before his parents hear you.
                            You're not going to give him a handjob.
                            You promise.
                        [/p]
                        [p]
                            Slowly shuffling forwards,
                            you rest the boy's member against the entire length of your slit,
                            the top half slightly parting your folds.
                            Then, once properly positioned, you [b]squeeze[/b] down on his shaft with your thighs,
                            enveloping his meat with your soft scales and warm flesh, forming an intercrural hole for him to fuck.
                        [/p]
                        [p]
                            And fuck it, he does.
                            Without even waiting for your directions, the avian follows his instincts,
                            grabbing your ass to keep you in place, while rapidly rolling his hips back and forth,
                            outright [b]humping[/b] your thighs,
                            the head of his cock pleasurably travelling up and down your slit,
                            [b]massaging[/b] your folds.
                        [/p]
                        [p]
                            Never having felt this type of pleasure before, it doesn't take long for Falco to reach his end.
                            He doesn't simply squirt his load atop your scales like you hope he would, however.
                            Instead, he [b]shoves[/b] you away from him, forcing you to sit down on a nearby chair to catch your balance.
                            He approaches, and spreads your legs, ominously pressing the foreskin-covered tip of his length against your cunt.
                        [/p]
                        [p]
                            You [b]plead[/b] for him [b]not[/b] to fuck you,
                            but luckily that doesn't seem to be his plan.
                            Instead,
                            he jerks himself off, while rubbing his cockhead up and down your slit, relishing in the warmth.
                            Phew.
                            You almost thought he was about to [b]rape[/b] you.
                            But as long as he doesn't cum inside, it's all good.
                        [/p]
                        [p]
                            Too bad for you, the bird is too lost in pleasure to follow your directions.
                            Instead of blowing his load on your abdomen,
                            he pushes the tip of his member inside of you, right as he reaches his end.
                            Before you can even protest, you can already feel the first squirt of fertile spunk flooding your insides.
                            You [b]beg[/b] him to pull out, you even [b]struggle[/b] a little,
                            but he deftly keeps you in place while the contents of his hefty balls empty inside of you.
                        [/p]
                        [p]
                            Once finished, he casually pulls out of you, tugs up his pants, and leaves the room,
                            going about his daily business while leaving you with a cum-leaking cunt and the terrifying thought that he might have impregnated you.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\parents\amorous\FarmerMaidAmorousThigh.js

// scenes\Enslavement\DayTwo\FarmerMaid\parents\amorous\FarmerMaidAmorousFuck.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidAmorousFuck(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = ctrl.parentsChoice.FUCK;
    var reqController = ctrl.parents;
    var subController = ctrl.postParents;
    var changeController = ctrl.amorousFuck;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = ctrl.fragments.amorousDaily;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var virgin = ctrl.misc.cuntVirgin();
        var toReturn = `[p]
                            Okay, fine.
                            But only this once, alright?
                            And he [b]has[/b] to cum outside.
                            You getting pregnant would be a [b]very[/b] bad thing to happen,
                            for the [b]both[/b] of you.
                        [/p]
                        [p]
                            You lean against a wall, and casually lift your tail,
                            exposing your loins and your savory backside to the aroused bird boy.
                            He eagerly approaches you from behind, and presses the foreskin-covered tip of his member against your slit,
                            rubbing it up and down, parting your folds ever so slightly while slathering around copious amounts of precum,
                            slickening your passage to ease his insertion.
                        [/p]
                        [p]
                            "[color=yellow]I knew from the very first moment I saw you at that auction.[/color]"
                            The avian speaks, whilst teasing you with his length.
                            You playfully ask [i]what[/i] he knew.
                            "[color=yellow]That you were a [b]slut[/b] lusting for [b]big bird cock[/b].[/color]"
                            Without giving you the chance to even process his words,
                            the eagle [b]rams[/b] himself forwards,
                            drawing a loud moan from your lips as he spears your folds wide open,
                            hilting himself inside of you.
                            ${virgin ? `A small trickle of blood signifies the loss of your virginity.` : ``}
                        [/p]
                        [p]
                            He covers your muzzle with one of his feathery hands,
                            preventing you from alerting his parents with your cries of pleasure.
                            His other hand finds its way atop your thigh,
                            keeping you steady while he starts to [b]thrust[/b],
                            every powerful roll of his hips sending spikes of [b]pleasure[/b] down your spine.
                            For a teenager, he sure does know how to [b]fuck[/b].
                            Must be a natural talent that runs in his blood.
                            Maybe that's how his [i]real[/i] father seduced Juliet.
                        [/p]
                        [p]
                            As Falco's humping intensifies,
                            you get pushed close and closer to the wall,
                            your arms and legs both growing weak from pleasure.
                            His grunts echo throughout the dining room.
                            He's almost as loud as his [i]human[/i] dad, upstairs.
                            The whorish sounds of his mother trump all, however.
                            She's [b]screaming[/b] in ecstacy loud enough for the entire hamlet to hear!
                        [/p]
                        [p]
                            You can't tell whether or not the eagle is fantasizing about his mother,
                            but either way, his end soon approaches.
                            You can feel his member starting to quiver inside of you.
                            The rational part of your brain [b]begs[/b] for you to ask him to pull out,
                            but it's too late.
                            You can already feel the first squirt of his fertile spunk flooding your insides.
                            The bird keeps himself hilted, while the contents of his hefty balls empty inside of you.
                        [/p]
                        [p]
                            Once finished, he casually pulls out of you, tugs up his pants and leaves the room,
                            going about his daily business while leaving you with a cum-leaking cunt and the terrifying thought that he might have impregnated you.
                        [/p]`;

        if (virgin) {
            toReturn += `[p][c][b]You are no longer a virgin.[/b][/c][/p]`;
        }

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\parents\amorous\FarmerMaidAmorousFuck.js

// scenes\Enslavement\DayTwo\FarmerMaid\parents\amorous\FarmerMaidAmorousDaily.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidAmorousDaily(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.postParents;
    var subController = ctrl.daily;
    var changeController = ctrl.amorousDaily;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new FarmerMaidDrunk(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var thigh = ctrl.parents.get() === ctrl.parentsChoice.NOPEN;
        var virgin = ctrl.misc.cuntVirgin();
        var toReturn = ``;

        if (thigh) {
            toReturn += `
                        [p]
                            From that day onwards,
                            Falco starts thighfucking you on a regular basis.
                            Every single time, despite your protests,
                            he ends up jerking off against your cunt, pushing his member inside of you, and blowing his load there.
                            Over the course of several weeks,
                            thighsex gradually turns into the bird jerking off while inserting his tip into your cunt.
                        [/p]
                        [p]
                            It isn't long until he starts putting more and more of himself inside of you.
                            No longer able to rub himself with his entire shaft lodged up your slit,
                            he begins to move back and forth.
                            ${virgin ? `A small trickle of blood signifies the loss of your virginity.` : ``}
                            You complain, but he doesn't listen.
                            And every single time, he fills you up with his potent seed.
                            After a dozen orso times of outright having sex,
                            you simply stop objecting.
                        [/p]
                        [p]
                            Falco takes the lack of complaints as a sign that you want this every bit as much as he does.
                            He starts to fuck you [b]properly[/b], humping the shit out of you while his hands toy with your body.
                            At first, you are [b]not[/b] into it in the slightest,
                            but as the avian grows more and more skilled in the art of making love,
                            your body begins to submit to him.
                            Your own urges grow more intense with every passing day.
                            You slowly grow to [b]like[/b] having sex with him.
                            And not long after that, you begin to [b]crave[/b] his daily dicking.
                        [/p]`;
        } else {
            toReturn += `
                        [p]
                            From that day onwards,
                            Falco starts fucking you on a regular basis.
                            Every single time, despite your protests,
                            he ends up blowing his load inside of you.
                            After a dozen orso times of him cumming inside of you,
                            you simply stop objecting.
                        [/p]
                        [p]
                            Falco takes the lack of complaints as a sign that you want this every bit as much as he does.
                            His mind emboldened, he starts to fuck you [b]properly[/b], humping the shit out of you while his hands toy with your body.
                            At first, you are still kind of hesitant of letting him [i]impregnate[/i] you,
                            but as the avian grows more and more skilled in the art of making love,
                            your body begins to submit to him.
                            Your own urges grow more intense with every passing day.
                            You slowly grow to [b]like[/b] the idea of being [i]bred[/i] by him.
                            And not long after that, you begin to [b]crave[/b] his daily dicking.
                        [/p]`;
        }

        toReturn += `   [p]
                            By the end of the eighth month of your stay,
                            the eagle and you wantonly fuck all over the house whenever you please.
                            In the kitchen, in the den, in his room, on his parents' bed.
                            He even takes you out to the shack out back once or twice,
                            to showcase his father's collection of farming equipment while he pounds you bent-over a workbench.
                        [/p]
                        [p]
                            One night, failing to get any sleep, you rise from your dog-basket.
                            Your loins are [b]burning hot[/b] and [b]dripping wet[/b].
                            Come to think of it, you hadn't had any [i]fun[/i] with Falco that day.
                            He went out to explore the area with his friends,
                            and by the time he got back, he was so tuckered out that he slinked away to bed and fell asleep.
                            A wicked idea crosses your mind.
                            It's time to be a naughty girl.
                        [/p]
                        [p]
                            You rise to your feet, and silently slip up the stairs.
                            Opening the door to the bird's room, you step inside.
                            You crawl under the blankets covering him, and dutifully begin to caress, lick and suck his flaccid member, until he's nice and hard.
                            Then, you awaken the bird by tugging his warm cover off of him, exposing his naked body to the cold midnight air.
                            Before he even realizes what's going on, you lower your needy cunt onto his length,
                            and begin to ride him like a vixen in heat.
                        [/p]
                        [p]
                            Needing to stay quiet to avoid his parents waking up adds an extra layer of excitement to sex.
                            The creaking of his bed resonates throughout the room, louder than your combined, stifled moans and grunts.
                            You fuck until dawn, milking the spunk from his cock several times.
                            Right before his parents wake up, you sneak back into your basket downstairs, and pretend to be asleep.
                        [/p]
                        [p]
                            During the tenth month, you start feeling a little [i]off[/i].
                            You kind of think you might be [i]pregnant[/i].
                            But you don't let it show.
                            The two of you keep seeing eachother like normal.
                            One day, he returns your midnight surprise,
                            making his way to your basket to wake you up for some starlight-lit doggy style sex.
                            Sure as heck beats sleeping.
                        [/p]
                        [p]
                            Whenever your avian [i]lover[/i] sleeps in, you head up to his room to service his ever-present morning wood.
                            A great way to wake up, he agrees.
                            Although you can't do it [i]every[/i] day, lest his parents start to realize what's going on between the two of you.
                            Luckily, they seem oddly absent-minded, as of late.
                            You think the romance in [b]their[/b] life is flaring up as well.
                            More than once, Juliet goes to [i]visit[/i] her husband while he's working the farmland.
                            It's pretty obvious that Romeo is planting his seeds in more than one way.
                        [/p]
                        [p]
                            Come the eleventh month, things between Falco and you start getting a little bit more [i]kinky[/i].
                            He fucks your feet, cums in your armpits, makes you eat his sweaty,
                            feathery ass and sometimes even demands you lick his foot-talons.
                            You oblige to his every demand, doing everything to keep the father of your gestating baby a happy man.
                            You haven't told him yet, but it's slowly starting to show.
                            Your maid outfit can conceal your pregnancy still, but your slightly chubby belly is a dead giveaway when naked.
                        [/p]
                        [p]
                            Near the final month of the first year of your stay,
                            the eagle starts fucking your [b]ass[/b] instead of your cunt.
                            It hurts, at first.
                            It hurts [b]a lot[/b], in fact.
                            But for him, you tolerate the pain.
                            It's a far tighter fit than your fucked-loose twat,
                            or so he comments.
                            And indeed, he cums rather quickly, filling your bowels with his warm, heady spunk,
                            before pulling out of your sensitive, slightly gaping tailhole and leaving you to clean yourself up.
                        [/p]
                        [p]
                            Approaching the end of the first year, you finally break the news to him.
                            You're pregnant.
                            And you're pretty sure the child is his.
                            No response.
                            Thinking he might not have heard you, you repeat your statement.
                            "[color=yellow]I heard you fine the first time.[/color]"
                            Well, what's he going to do about this?!
                            "[color=yellow]I need time to think.
                            For now, let's just keep doing it up your ass for a while.[/color]"
                        [/p]
                        [p]
                            He completely misses the point.
                            You sigh in exasperation.
                            The two of you end up angrily buttfucking for the remainder of the day.
                        [/p]`;

        if (thigh && virgin) {
            toReturn += `[p][c][b]You are no longer a virgin.[/b][/c][/p]`;
        }

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\parents\amorous\FarmerMaidAmorousDaily.js

// scenes\Enslavement\DayTwo\FarmerMaid\parents\amorous\FarmerMaidAmorous.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidAmorous(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.preParents;
    var subController = ctrl.parents;
    var changeController = false;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";
    var thirdId = arguments.callee.name + "ButtonThree";

    var firstNext = ctrl.fragments.blowjob;
    var secondNext = new FarmerMaidAmorousThigh(ctrl);
    var thirdNext = new FarmerMaidAmorousFuck(ctrl);

    var firstChoice = ctrl.parentsChoice.BLOWJOB;
    var secondChoice = ctrl.parentsChoice.NOPEN;
    var thirdChoice = ctrl.parentsChoice.FUCK;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            Near the end of the week,
                            right after breakfast,
                            the man of the house gives his wife a sultry wink.
                            She knows well enough what that means.
                            Like Falco and you retreat to his room to have fun,
                            so too do his parents go to [i]their[/i] bedroom.
                        [/p]
                        [p]
                            But while you try to keep your voices down during your [i]fun[/i],
                            Romeo and Juliet don't seem to care who hears them.
                            The woman's pleasured screams echo throughout the entire house,
                            and the rhythmic squeaking of wood can be heard all the way at the dinner table.
                        [/p]
                        [p]
                            Your avian friend is intrigued by his mother's overly loud excitement.
                            He says that he wants to do what they're doing.
                            Right here, and right now.
                            You voice your worries that you might be [i]caught[/i],
                            but he simply unbuckles his pants, and pulls out his fully erect member,
                            before wisely retorting that with his parents upstairs,
                            nobody's around to [i]catch[/i] you.
                            And it's not like they'd hear you over their own [i]sounds[/i].
                        [/p]
                        [p]
                            It looks like the bird has made up his mind.
                            He [b]really[/b] wants this.
                            Do you relent, and let him fuck you?
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === firstChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${firstId}" ${disabled}>A blowjob</button>`;

        var tooltip = global.parser.parse(`It's not what he wants, but surely he'll be satisfied with your mouth, right?`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 160px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === secondChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${secondId}" ${disabled}>Thighsex</button>`;

        var tooltip = global.parser.parse(`He can rub it against your slit, but putting it in is one step too far.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 160px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildThirdChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === thirdChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${thirdId}" ${disabled}>Actual sex</button>`;

        var tooltip = global.parser.parse(`It'd be cruel to deny the boy, with all the noise coming from upstairs.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 160px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You give him:</div>`;
        choice += buildFirstChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildThirdChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId), $("#" + thirdId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(firstChoice);
            loadNextPart(firstNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(secondChoice);
            loadNextPart(secondNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerThirdListener() {
        $("#" + thirdId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(thirdChoice);
            loadNextPart(thirdNext);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += firstNext.build();
        part += secondNext.build();
        part += thirdNext.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        firstNext.registerListeners();
        secondNext.registerListeners();
        thirdNext.registerListeners();

        if (subController.has()) {
            return;
        }

        registerFirstListener();
        registerSecondListener();
        registerThirdListener();
    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\parents\amorous\FarmerMaidAmorous.js

// scenes\Enslavement\DayTwo\FarmerMaid\parents\amorous\FarmerMaidPreAmorous.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidPreAmorous(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.postMaid;
    var subController = ctrl.preParents;
    var changeController = false;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new FarmerMaidAmorous(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            The next day, right after Romeo and Juliet have left the house,
                            their son approaches you once more.
                            He doesn't speak, but what he wants couldn't be any more clear.
                            You've got something even [b]better[/b] for him, though.
                            You lift your skimpy maid-dress, and spread your legs ever so slightly,
                            giving the avian a close-up look at your feminine slit.
                        [/p]
                        [p]
                            He seems completely [b]enthralled[/b].
                            Without even asking, he reaches out and immediately begins to touch, rub and prod your sensitive folds.
                            Right as you were about to tell him to [b]finger[/b] you,
                            you hear the backdoor opening.
                            Damnit, can't you get [b]any[/b] privacy in this house?!
                            The boy scrambles upstairs, and you swiftly return to cleaning.
                            Romeo had forgotten his rake, which you spent most of last night cleaning.
                            Dumb farmer, interrupting your fun.
                        [/p]
                        [p]
                            Most of the later half of your first month of enslavement goes in a similar fashion.
                            Every day, Falco and you try something new, and almost every time you get interrupted.
                            Be it a neighbour knocking at the door,
                            his mother calling him,
                            or Romeo checking up on you during the day,
                            there's [b]always[/b] someone around to ruin the [i]fun[/i].
                        [/p]
                        [p]
                            The two of you are left flustered, panting and disappointed almost a dozen times over.
                            But the sheer [b]excitement[/b] of what you are doing keeps you going.
                            Likewise, a mixture of curiosity and arousal make him keep coming back for more.
                            Despite adversity, your escapades continue.
                        [/p]
                        [p]
                            The few sparse times you [b]don't[/b] get forced apart,
                            you manage to have a [b]great[/b] time together.
                            You let him touch every part of your body,
                            you let him experiment and figure out how many feathery fingers he can fit inside of your cunt,
                            and you even steal what you believe to be his very first [b]kiss[/b].
                        [/p]
                        [p]
                            Entering the second month of your servitude, the two of you devise a plan.
                            A way to fool around without constant interruptions.
                            He'll keep his own room clean, so when it comes time for [b]you[/b] to sweep it,
                            the two of you can have some fun together instead.
                            And nobody will be the wiser.
                            If anything, his parents will praise him for being so [b]dilligent[/b],
                            and for helping you with your tasks.
                            If they even care enough to notice, that is.
                        [/p]
                        [p]
                            Apart from a few minor interruptions,
                            the scheme seems to work exceptionally well!
                            Finally, you get to spend some [b]quality time[/b] together.
                            Over the course of the week, he fingerfucks all three of your holes,
                            the two of you sloppily make out atop his bed while he fondles your chest,
                            and you even let him eat you out once or twice.
                        [/p]
                        [p]
                            A spark of [b]passion[/b] growing between the two of you,
                            things rapidly grow more intense.
                            During the sixth week of your stay,
                            you encourage Falco to start [b]masturbating[/b] while the two of you are together.
                            Before, he'd always politely waited until you had left, to jerk off to the memory of your naked body,
                            and your taste lingering on his tongue.
                            But now, with your blessing, he is free to rub his dick in your presence.
                            And he gladly does so, eagerly tugging his shaft while exploring your body.
                        [/p]
                        [p]
                            Falco's uncut humanoid member is quite a bit [i]bigger[/i] than what you had expected.
                            Perhaps he's older than you imagined him to be.
                            Must be that bird thing Seki told you about.
                            As the eagle visibly gets close to cumming,
                            you move your hand to the tip of his member,
                            cupping his glans as he reaches his end,
                            letting him squirt his hefty load all over your scaly palm.
                            Can't let it get on the bed, or it'll stain.
                            Shooting the avian a sly look,
                            you lap his semen off your scales with a single stroke of your tongue,
                            and lewdly swallow it down.
                        [/p]
                        [p]
                            Your [i]lesson[/i] on not staining his bedsheets -- or your maid outfit, for that matter -- leaves a lasting impression.
                            From that day onwards, the bird finishes on you whenever he can.
                            Your ass, your face, your back and your chest all get coated in heady, pearly white spunk.
                            You even lend him a hand a few times, stroking his length for him, so he can use [b]both[/b] of his hands to toy with your body.
                            The best of this all is how [b]oblivious[/b] Romeo and Juliet are.
                            As far as they are concerned, their son a good boy that helps you clean his room on a daily basis.
                            Idiots.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\parents\amorous\FarmerMaidPreAmorous.js

// scenes\Enslavement\DayTwo\FarmerMaid\parents\abusive\FarmerMaidAbusiveWatch.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidAbusiveWatch(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = ctrl.parentsChoice.WATCH;
    var reqController = ctrl.parents;
    var subController = ctrl.postParents;
    var changeController = false;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = ctrl.fragments.abusiveDaily;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            How cruel of Falco to hop on his mother mere [b]moments[/b] after she was struck down.
                            This is not [i]your[/i] fight.
                            [b]She[/b] needs to push him off of her, to resist his advances like you did.
                            It's not up to you to settle her affairs for her.
                            You're a maid.
                            A [b]slave[/b].
                            It's not your duty to interfere.
                            But you [b]do[/b] intend to stay and watch.
                            You know, to make sure he doesn't [i]hurt[/i] her.
                        [/p]
                        [p]
                            The bird reaches into his pants, producing his rock-hard humanoid length.
                            Hovering the uncut tip in front of Juliet's face, he slowly begins to stroke it,
                            rubbing the foreskin back and forth along his glans with every motion of his feathery hand.
                            "[color=yellow]You [b]love[/b] big bird cock, don't you, you [b]whore[/b]?![/color]"
                            That's no way to talk to his mother, but you're a spectator, not a [i]commentator[/i].
                            "[color=yellow]Else you wouldn't have fucked my [b]real[/b] dad behind Romeo's back.[/color]"
                            Oof.
                            He's got a point there.
                        [/p]
                        [p]
                            Noticing the human isn't in a very talkative mood,
                            the eagle lowers his member in between her breasts,
                            using both of his hands to press her boobs together,
                            enveloping his shaft with their warmth.
                            Then, he begins to thrust, outright [b]fucking[/b] his mother's tits,
                            humping away at her chest while constantly belittling her.
                            "[color=yellow]Dumb little hen.
                            I should [b]rip[/b] your pants next time.
                            Let's see you weasel your way out of that.[/color]"
                        [/p]
                        [p]
                            He roughly slaps her,
                            spits in her face,
                            rubs his balls clean on her head and constantly fiddles with her groin.
                            He finishes once on her chest, but rapidly jerks himself to full mast once more,
                            continuing to abuse Juliet for the better half of an hour.
                            Only then, while taking a small [i]break[/i] from the constant groping and humping,
                            does Falco even [b]realize[/b] that you are still in the room.
                            He glares angrily at you.
                            "[color=yellow]Get out of here, [b]slave[/b], unless you want some of my dick, too.[/color]"
                        [/p]
                        [p]
                            Returning his angry look, you let out a dignified huff before leaving the room,
                            resigning the human to the fate she herself chose.
                            Her son continues to abuse her for nearly an hour more,
                            before finally emerging from the dining room,
                            leaving her lying on the floor in a puddle of his spunk.
                            But that's none of your business.
                            You're here to clean, and clean you do.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\parents\abusive\FarmerMaidAbusiveWatch.js

// scenes\Enslavement\DayTwo\FarmerMaid\parents\abusive\FarmerMaidAbusiveLeave.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidAbusiveLeave(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = ctrl.parentsChoice.LEAVE;
    var reqController = ctrl.parents;
    var subController = ctrl.postParents;
    var changeController = false;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = ctrl.fragments.abusiveDaily;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            How cruel of Falco to hop on his mother mere [b]moments[/b] after she was struck down.
                            This is not [i]your[/i] fight.
                            [b]She[/b] needs to push him off of her, to resist his advances like you did.
                            It's not up to you to settle her affairs for her.
                            You're a maid.
                            A [b]slave[/b].
                            It's not your duty to interfere.
                            But you can't stay and watch, either.
                        [/p]
                        [p]
                            You leave the room, closing the door behind you.
                            Ignoring the outright [b]rape[/b] happening in the house, you start your daily cleaning routine.
                            Over an hour later, the bird emerges from the dining room.
                            You still haven't wiped the dishes, a perfect excuse for you to head in there and see how Juliet is doing.
                        [/p]
                        [p]
                            She's lying on the floor, in the exact same spot she was as when you left her.
                            Her tits are coated in several layers of spunk, a thick trail of which leads all the way up her neck to her chin.
                            Falco must have used her body multiple times in a row.
                            Her face is covered in a few different fluids.
                            Cum, tears, is that [i]spit[/i]?
                            Poor woman.
                        [/p]
                        [p]
                            But you can't quite find it in your heart to feel truly compassionate for her.
                            She brought this upon herself.
                            All she had to do was say [b]no[/b].
                            If she'd told her son off the very first time he made a move,
                            then [b]none[/b] of this would have happened.
                            It's all her own fault!
                        [/p]
                        [p]
                            Disregarding the abused housewife,
                            you deftly go about your business.
                            You sweep dust off of the table,
                            you collect the plates,
                            brush off the crumbs and snag Falco's half-eaten sandwich for yourself,
                            and put them back in the cabinet where they belong.
                            Then, you leave the room once more,
                            without so much as asking Juliet whether or not she's okay.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\parents\abusive\FarmerMaidAbusiveLeave.js

// scenes\Enslavement\DayTwo\FarmerMaid\parents\abusive\FarmerMaidAbusiveDaily.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidAbusiveDaily(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.postParents;
    var subController = ctrl.daily;
    var changeController = false;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new FarmerMaidTooFar(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            For the remainder of the month,
                            you frequently stumble upon Falco enjoying his reluctant mother's body,
                            be it jerking off to her naked frame, fucking her tits,
                            fingering her cunt,
                            or even sloppily kissing her while forcing her to stroke him.
                            Often times, Juliet can be found wandering around the house covered in her son's spunk,
                            no longer bothering to clean herself during the day.
                            Instead, she douses herself with a bucket of water fetched from the well, once per evening, 
                            to wipe off any traces of the entire day's worth of bird jizz.
                        [/p]
                        [p]
                            Her tactic seems somewhat effective.
                            Romeo no longer complains about her [i]sleeping around[/i].
                            Whether that means he simply no longer [i]cares[/i],
                            or if he simply can't notice the smell of semen lingering about his wife,
                            you don't know.
                            He isn't around very often anyway.
                            Always absent.
                            Always working.
                        [/p]
                        [p]
                            The bird's lust gradually intensifies.
                            For a few months, he explores every part of Juliet's frame with his cock,
                            indulging in various sick and twisted kinks.
                            You catch him rubbing against and fucking her armpits,
                            forcing her to wrap her bare feet around his length,
                            cumming into her panties,
                            making her lick his feathery behind,
                            and commanding her to lap his spunk off the floor.
                        [/p]
                        [p]
                            Near the half-year mark,
                            things escalate even further.
                            Falco discovers the pleasure of a warm, wet mouth.
                            At first, he only makes his mother lick him,
                            but this soon transitions into regular blowjobs.
                            Come the seventh month of your stay,
                            the eagle outright [b]facefucking[/b] his mom becomes an everyday occurrence.
                        [/p]
                        [p]
                            Her cunt is the next hole he defiles.
                            The first time the feathery bastard musters up the courage to outright [b]fuck[/b] the woman that gave birth to him, 
                            she loudly [b]begs[/b] him to stop.
                            But she doesn't back.
                            She doesn't struggle.
                            And he doesn't listen, carelessly [b]ramming[/b] his member into Juliet,
                            pounding her like a man possessed, driven wild by [b]pleasure[/b] and [b]lust[/b].
                        [/p]
                        [p]
                            The next time you find them together,
                            the woman [b]begs[/b] her son to put on a specialized tool she'd brought from Varanar, especially for him.
                            A thin membrane carved from some kind of animal organ.
                            A [i]condom[/i], she calls it.
                            The boy reluctantly agrees.
                            After they're done, he makes her clean the insides of it with her mouth.
                        [/p]
                        [p]
                            From what you can gather from your eavesdropping, it apparently [i]wasn't[/i] as good as doing it [b]naturally[/b].
                            Still, she asks him to put it on every single time.
                            Since that shoddy first experience, he almost never listens, fucking her raw dozens of times,
                            shooting his fertile, crossbreed-capable sperm deep inside of her.
                            After more than a month of trying, the woman relents, ceasing her efforts to stave off pregnancy.
                            She stops offering her son condoms, instead reluctantly letting him do as he pleases.
                        [/p]
                        [p]
                            Around your tenth month at the farmer's home,
                            Falco claims the final unused part of his mother's body.
                            Her tender, virginal ass.
                            The first time he pushes into her, she [b]screams[/b] loud enough for the entire hamlet to hear.
                            It's a miracle none of the neighbours come to see if someone's in need of help.
                            At least she can't get pregnant if he puts it in her butt.
                            Although the few times you witnessed them going at it,
                            he pulls out just before reaching his end, finishing in her cunt instead.
                            Like he [b]wants[/b] her to have his child.
                        [/p]
                        [p]
                            Near the end of the eleventh month, the inevitable happens.
                            Juliet is pregnant.
                            The fears the baby is Falco's, and not Romeo's.
                            They both decide to keep it a secret.                            
                        [/p]
                        [p]
                            Instead of letting up on her,
                            the bird seems to get more [b]aggressive[/b] and [b]wild[/b] now that his mom has been inseminated by his seed.
                            He spanks her, pulls her hair, slaps her around and forces her to [b]choke[/b] on his cock.
                            When they're not busy [b]fucking[/b], he makes her [b]worship[/b] him around the house.
                            She serves him food, gets made to massage, clean and even [b]lick[/b] his foot-talons,
                            and come the twelfth month, her idly suckling his feathery balls while he relaxes in the couch,
                            the both of them fully nude most of the time, has become the new norm of things.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\parents\abusive\FarmerMaidAbusiveDaily.js

// scenes\Enslavement\DayTwo\FarmerMaid\parents\abusive\FarmerMaidAbusive.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidAbusive(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.preParents;
    var subController = ctrl.parents;
    var changeController = false;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";
    var thirdId = arguments.callee.name + "ButtonThree";

    var firstNext = new FarmerMaidAbusiveLeave(ctrl);
    var secondNext = new FarmerMaidAbusiveWatch(ctrl);
    var thirdNext = ctrl.fragments.handjob;

    var firstChoice = ctrl.parentsChoice.LEAVE;
    var secondChoice = ctrl.parentsChoice.WATCH;
    var thirdChoice = ctrl.parentsChoice.HANDJOB;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            About two and a half months into your forced servitude, you are awoken by loud arguing coming from the dining room.
                            Sleepily getting up to see what the trouble is all about, you find the farmer having a heated discussion with his wife,
                            while Falco sits and watches from across the table, a smug smirk plastered across his face as he slowly eats his breakfast-sandwich.
                            It seems you've arrived quite late,
                            the [i]argument[/i] rapidly escalating.
                            Curiosity getting the best of you, you listen in.
                        [/p]
                        [p]
                            "[color=ppink]I'm not seeing anyone, I swear![/color]"
                            pleads Juliet.
                            Her husband is having none of that, however.
                            "[color=red]I may be a simple farmer, but I'm not [b]stupid[/b]!
                            I [b]know[/b] what those stains on the back of your pants are from!
                            Now [b]tell me[/b] who it is, so I can [b]stab[/b] my rake through his heart![/color]"
                        [/p]
                        [p]
                            Oh dear.
                            It sounds like he's found a few hints of what his wife and son have been up to in his absence,
                            although he can't quite pin down the culprit yet.
                            You [i]sort of[/i] want to come clean, but you fear the man might misplace his rage, and turn on [b]you[/b] instead.
                            Plus, if the woman doesn't back you up, it'd be your word against Falco's.
                            And that's not an argument you think you'd win.
                        [/p]
                        [p]
                            "[color=ppink]It's [b]butter[/b]-stains![/color]"
                            His rage boiling over, the farmer harshly [b]slaps[/b] his wife, hard enough to [b]knock[/b] her to the floor.
                            She bursts out into tears, lying on her back while her husband looms over her.
                            Well, now you know where the eagle got his manners from.
                            "[color=red]I'll catch you one of these days,
                            and when I do, I'll kill you and your lover [b]both[/b]![/color]"
                            That said, he storms out of the back door, loudly [b]slamming[/b] it shut behind him.
                        [/p]
                        [p]
                            Juliet remains on the ground, crying her eyeballs out.
                            She clearly doesn't know [b]what[/b] to do anymore.
                            Her son rises from his seat, leaving his half-eaten breakfast on the plate.
                            He casually approaches the downed housewife.
                            For a moment, you think he might [i]help her up[/i], but he doesn't.
                            Instead, he steps over the woman, and then kneels down over her,
                            pinning the woman down by sitting ontop of her.
                        [/p]
                        [p]
                            Wasting no time and no words,
                            Falco yanks down his mother's top,
                            exposing her bountiful bosom.
                            Then, he begins to fiddle with his belt.
                            You've seen them mess around enough to know where this is going.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === firstChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${firstId}" ${disabled}>Leave</button>`;

        var tooltip = global.parser.parse(`Still not your business. Leave the room and pretend this never happened.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 160px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === secondChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${secondId}" ${disabled}>Watch</button>`;

        var tooltip = global.parser.parse(`Stay while the boy has his way with his mother.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 165px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildThirdChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === thirdChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${thirdId}" ${disabled}>Jerk him off</button>`;

        var tooltip = global.parser.parse(`Offer a handjob to sate the kid instead. He wanted you initially, right?`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 160px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You:</div>`;
        choice += buildFirstChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildThirdChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId), $("#" + thirdId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(firstChoice);
            loadNextPart(firstNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(secondChoice);
            loadNextPart(secondNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerThirdListener() {
        $("#" + thirdId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(thirdChoice);
            loadNextPart(thirdNext);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += firstNext.build();
        part += secondNext.build();
        part += thirdNext.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        firstNext.registerListeners();
        secondNext.registerListeners();
        thirdNext.registerListeners();

        if (subController.has()) {
            return;
        }

        registerFirstListener();
        registerSecondListener();
        registerThirdListener();
    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\parents\abusive\FarmerMaidAbusive.js

// scenes\Enslavement\DayTwo\FarmerMaid\parents\abusive\FarmerMaidPreAbusive.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidPreAbusive(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.postMaid;
    var subController = ctrl.preParents;
    var changeController = false;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new FarmerMaidAbusive(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            Over the course of the later half of your first month,
                            you continue to stumble upon Falco and Juliet,
                            the bird's [i]hormonal outbursts[/i] growing more severe as time progresses.
                        [/p]
                        [p]
                            A few days after you first encountered them,
                            you find the avian and his mother in the dining room.
                            He's rubbing her bare tits from behind, to his heart's content,
                            while she's trying to eat her meagre lunch, hoping that by [b]ignoring[/b] him, he'll get bored and go away.
                            Bad idea.
                            While you don't stick around to watch, they stay inside of that room for an entire hour,
                            until finally the eagle emerges, a thoroughly sated look on his face.
                        [/p]
                        [p]
                            A week after, while you're busy cleaning the living room,
                            Falco walks in and takes a seat right next to his mother on the couch.
                            He repeatedly places his feathery hand upon her thigh, but she slaps it away time after time again.
                            He doesn't relent, however.
                            After a dozen tries, Juliet reluctantly ceases her efforts to stop him, a defeated sigh denoting her unwillingness.
                            Her son eagerly presses his palm in between her legs,
                            and begins to [b]rub[/b] her loins through her pants right in front of you.
                            Disgusted, you leave the room.
                        [/p]
                        [p]
                            You sleep with a troubled conscience, but at least you're glad [b]you[/b] aren't the one being molested.
                            Things get even worse at the start of your second month.
                            You catch the two on Romeo's bed,
                            the avian ontop of the human,
                            pinning her to the mattress while eagerly kissing her,
                            not an easy feat considering his beak.
                            Oh well, at least that's one room less for you to clean today.
                        [/p]
                        [p]
                            You rarely see the man of the house.
                            He often leaves to work his field long before you get up, and he comes home late, after everyone's already gone to sleep.
                            He must not get a lot of sleep.
                            No wonder his son is running rampant, without a stern father figure around in his life.
                        [/p]
                        [p]
                            Another week later, you find them in the kitchen, where it all began.
                            Juliet is leaning against the counter,
                            her tits bared and her pants pulled down to her knees, her hairy cunt fully exposed.
                            She embarrassedly stares off the the side,
                            while her son leers at her half-naked frame,
                            wildly jerking his uncut, humanoid member.
                            Huh, so he has a [b]human[/b] dick?
                            That's not what you [i]pictured[/i] him with.
                            Must be because he's a crossbreed or something.
                            As the bird shoots you a lewd, suggestive wink,
                            you walk away, fearing he might go after you next.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\parents\abusive\FarmerMaidPreAbusive.js

// scenes\Enslavement\DayTwo\FarmerMaid\parents\absent\FarmerMaidAbsentHandjob.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidAbsentHandjob(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = ctrl.parentsChoice.HANDJOB;
    var reqController = ctrl.parents;
    var subController = ctrl.postParents;
    var changeController = false;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = ctrl.fragments.absentDaily;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var neutral = ctrl.maid.get() === FarmerMaidMaidChoice.ABIDE;
        var toReturn = ``;

        if (neutral) {
            toReturn += `
                        [p]
                            While the bird is quite intimidating,
                            your stinging buttcheeks reminding you of how hard he can [i]smack[/i] things,
                            you [b]still[/b] don't want to suck him off.
                            You're [b]not[/b] going to.
                            But maybe, if it'll keep things [i]amicable[/i] between the two of you,
                            perhaps you could see to maybe [i]using your hands[/i]?
                            As a token of your good will.
                        [/p]
                        [p]
                            The avian menacingly lifts his hand, as though he's going to [b]hit[/b] you,
                            but decides [i]not[/i] to hurt you any more, [i]for now[/i].
                            Still, the gesture leaves you trembling in fear.
                            He lets out an angry snarl, slapping his dick against your snout a few times over while he considers his options.
                            Finally, he speaks:
                            "[color=yellow]Dumb slave can't do anything right.
                            [b]Fine[/b].
                            Use your stupid hands, then.[/color]"
                        [/p]
                        [p]
                            You tentatively reach out and take hold of Falco's humanoid shaft.
                            It feels [b]thick[/b] and [b]warm[/b] inside of your palm.
                            Reluctance clearly visible on your face,
                            you look away to the side,
                            and slowly begin to move your hand back and forth,
                            dutifully stroking the eagle's length.
                        [/p]
                        [p]
                            While upset at first,
                            the boy's attitude rapidly changes,
                            as the pleasure of being jerked off by someone else clouds his mind.
                            He lets out a satisfied, rumbling groan, and his body relaxes ever so slightly,
                            although he still angrily stares down at you with nothing but [b]contempt[/b] in his eyes.
                            Hoping to get him off before he changes his mind still,
                            you decide to double your efforts,
                            strengthening your grip on his length,
                            and upping your pace, giving him a [b]proper[/b] handjob.
                        [/p]
                        [p]
                            You don't think he's ever had anyone touch him [i]down here[/i] before.
                            You're his first, and you don't know how to feel about that.
                            At least it makes it so he doesn't last long.
                            Less than a minute since you were forced to your knees,
                            you can already feel his shaft starting to quiver and tremble in your grasp.
                            He's getting close.
                            Just a little bit more.
                        [/p]
                        [p]
                            One last time, you increase your pace, your hand frantically sliding up and down his length,
                            your tight grip practically [b]squeezing[/b] the cum out of his balls,
                            [b]milking[/b] the avian dry.
                            With a loud grunt, he rolls his hips forwards,
                            [b]bucking[/b] against your palm as he reaches his end.
                            You try to get out of the way,
                            but Falco fiercely holds your head in place,
                            as squirt after squirt of hefty avian jizz covers your face,
                            painting your green scales white.
                        [/p]
                        [p]
                            As his intense orgasm comes to a dribbling end, Falco lets go of your head, wordlessly pulls up his pants, buckles his belt,
                            and walks out of the room, leaving you sitting on your knees with a face full of cum and a sore, spanked behind.
                        [/p]`;
        } else {
            toReturn += `
                        [p]
                            You can't let this happen.
                            You need to intervene, for Juliet's sake.
                            Even if that means debasing yourself.
                            You'll do it for [b]her[/b].
                            To save her from Falco's clutches.
                            At least for now.
                        [/p]
                        [p]
                            As the bird whips out his dick from his pants, you step forwards, and coarsely [b]shove[/b] him off of the human.
                            Before he even has a chance to complain, you drop to your knees, and grab his hardening shaft.
                            Looking away in disgust, you begin to stroke up and down,
                            dutifully jerking off the eagle to prevent him from abusing his mother further.
                        [/p]
                        [p]
                            While initially surprised, the avian quickly gets into the swing of things.
                            "[color=yellow]Finally came around, huh?
                            I [b]knew[/b] you were as much of a [b]slut[/b] for bird cock as my mom is.[/color]"
                            While his words tear into your pride and self-esteem, you try your hardest to ignore them.
                            "[color=yellow]Man, I sure am lucky, having two [b]rabid whores[/b] fighting for my dick.[/color]"
                            While her son is busy degrading you,
                            Juliet rises to her feet and covers her chest.
                            With tears still in her eyes, she grateful nods at you, before making herself scarce.
                        [/p]
                        [p]
                            Not wanting to endure Falco's verbal abuse for much longer, you double your efforts,
                            strengthening your grip on his length,
                            and upping your pace, giving him a [b]proper[/b] handjob.
                            His cruel words slowly fade in favor of heated groans and moans.
                            It'd be kind of [i]cute[/i], to watch him transition from a domineering motherfucker to a squawking hatchling,
                            were it not for his constant berating, and his [b]wicked[/b] behavior.
                            If he weren't such a little [b]prick[/b] to his mother,
                            you might even have even [i]enjoyed[/i] this.
                            As it stands, you hate every last second of it.
                        [/p]
                        [p]
                            Luckily, the boy doesn't manage to last very long.
                            Less than a minute since you dropped to your knees,
                            you can already feel his shaft starting to quiver and tremble in your grasp.
                            He's getting close.
                            Just a little bit more.
                        [/p]
                        [p]
                            One last time, you increase your pace, your hand frantically sliding up and down his length,
                            your tight, anger-fueled grip practically [b]squeezing[/b] the cum out of his balls,
                            [b]milking[/b] the avian dry.
                            With a loud grunt, he rolls his hips forwards,
                            [b]bucking[/b] against your palm as he reaches his end.
                            Rope after rope of hefty avian jizz squirts from the foreskin-covered tip of his member,
                            painting the green scales of your hand white.
                        [/p]
                        [p]
                            As his intense orgasm comes to a dribbling end, you let go of Falco's shaft.
                            He wordlessly rises to his feet, pulls up his pants, buckles his belt,
                            and walks out of the room, leaving you sitting on your knees with a palm full of cum, and a floor that needs cleaning.
                        [/p]`;
        }

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\parents\absent\FarmerMaidAbsentHandjob.js

// scenes\Enslavement\DayTwo\FarmerMaid\parents\absent\FarmerMaidAbsentDaily.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidAbsentDaily(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.postParents;
    var subController = ctrl.daily;
    var changeController = false;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new FarmerMaidGirlfriend(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var frigid = ctrl.maid.get() === FarmerMaidMaidChoice.RESIST;
        var eager = ctrl.maid.get() === FarmerMaidMaidChoice.ABIDE;
        var hand = ctrl.parents.get() === ctrl.parentsChoice.HANDJOB;
        var toReturn = `[p]
                            After that day, you feared that the eagle's demands would only grow [i]worse[/i].
                            Since he'd had a taste of what being [i]properly[/i] pleasured felt like,
                            you figure he'd be coming back for more before long.
                            You're fully prepared for him to ask you to use your ${hand ? `hand` : `mouth`} again,
                            but such a request never comes.
                        [/p]
                        [p]
                            In fact, ever since you ${hand ? `jerked` : `sucked`} him off,
                            Falco seemingly grows less and less interested in abusing ${frigid ? `his mother and you both` : `you`}.
                            Molestation becomes less frequent, he no longer leers at you while you work,
                            and entire days pass by without ${frigid ? `his mother receiving` : ``} any attention fron him at all.
                            Did you ${hand ? `tug` : `suck`} the libido out of him?
                            ${!eager ? `You can only hope you have.` : `You hope not.`}
                        [/p]
                        [p]
                            Life [i]without[/i] having to deal with the boy's daily harassing is quite nice.
                            You peacefully go about your duties cleaning the house,
                            without constantly ${frigid ? `stumbling upon Juliet in peril` : `being fondled`}.
                            You get some good sleep,
                            you no longer need to clean jizz off the floor${frigid ? `` : `, or off yourself,`}
                            and Romeo's bountiful harvest puts a little more food onto your plate.
                            He's pleased with your performance as of late.
                            You take pride in how [i]pristine[/i] you keep the house.
                            Everyone is happy.
                        [/p]
                        [p]
                            Falco no longer spends most of his time around the house.
                            He's often absent, and he doesn't tell anyone where he's going.
                            You wonder what's going on,
                            but at the same time you don't really [i]care[/i].
                            You're better off without him.
                            The entire family is.
                        [/p]
                        [p]
                            About a month after the ${hand ? `handjob` : `blowjob`},
                            the reason for the avian's frequent absence is revealed.
                            During the afternoon, he comes home together with a young human girl,
                            who you reckon to be no older than nineteen.
                            She looks kind of like Juliet.
                            The two make out in the living room for a while,
                            before heading upstairs and loudly [b]fucking[/b] in the boy's room.
                            No wonder he isn't interested in ${frigid ? `you or his mother` : `you`} anymore.
                            He found someone who [b]willingly[/b] spreads his legs for him.
                        [/p]
                        [p]
                            Over the course of the next few months,
                            the relationship between the eagle and his [i]girlfriend[/i] deepens.
                            At first, they only [i]fool around[/i] while Romeo and his wife are out of the house.
                            Once the news of their romance reaches the avian's parents,
                            the bird and his broad no longer bother to hide their intimacy.
                            The young woman eats dinner with the family,
                            they openly kiss in front of the older couple,
                            and Falco is quite [i]blatant[/i] when suggesting they should retire to his room for the night.
                        [/p]
                        [p]
                            Still, you have no reason to complain.
                            Besides a few extra stains on the feathery teen's bedsheets,
                            the interspecies love affair has no effect on you.
                            If anything, you feel better knowing that everything worked out fine in the end.
                            For you, ${frigid ? `for his mother,` : ``} and for the avian.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\parents\absent\FarmerMaidAbsentDaily.js

// scenes\Enslavement\DayTwo\FarmerMaid\parents\absent\FarmerMaidAbsentBlowjob.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidAbsentBlowjob(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = ctrl.parentsChoice.BLOWJOB;
    var reqController = ctrl.parents;
    var subController = ctrl.postParents;
    var changeController = ctrl.absentBlowjob;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = ctrl.fragments.absentDaily;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var neutral = ctrl.maid.get() === FarmerMaidMaidChoice.ABIDE;
        var toReturn = ``;

        if (neutral) {
            toReturn += `
                        [p]
                            You really don't want to do this, but the bird leaves you with little choice.
                            Plus he's kind of [i]intimidating[/i], your stinging buttcheeks reminding you of how hard he can [i]smack[/i] things.
                            Wiping your tears, you make it [b]very[/b] clear that this is [b]not[/b] going to become a daily thing.
                            You'll please him this [b]once[/b], but if he tries to blackmail you again,
                            then you'll be the one telling his parents of all the things he's been up to in their absence.
                        [/p]
                        [p]
                            "[color=yellow]Shut up and get to sucking, dumb kobold.[/color]" comes Falco's reply.
                            He crudely tugs your head forwards, rubbing his shaft against your cheek,
                            spreading a dollop of precum across your scales.
                            You let out an exasperated groan, followed by a reluctant sigh.
                            Positioning your muzzle in front of the foreskin-covered tip of the eagle's humanoid member,
                            you part your lips, and take it into your mouth.
                        [/p]
                        [p]
                            The boy clearly isn't much for [i]personal hygiene[/i],
                            but luckily his prepuce keeps most of the [i]filth[/i] away from your tongue,
                            leaving only the salty taste of [b]cock[/b], with an undeniably [b]masculine[/b] hint to it.
                            Not wanting to go any deeper on Falco's length,
                            you grip his shaft with one of your hands.
                            Whilst suckling on the tip of his member,
                            you begin jerk him off, pleasing the bird to the best of your abilities,
                            in the hopes of finishing him off as soon as possible.
                        [/p]
                        [p]
                            The avian looks like he's in [b]heaven[/b].
                            While you've frequently witnessed him masturbating while groping you,
                            you don't think he's [i]ever[/i] had anyone else touch [i]him[/i] before.
                            Various pleasured grunts and insulting,
                            outright [b]degrading[/b] comments escape his beak.
                            "[color=yellow]Yeah, just like that.
                            Use your tongue more, dumb whore.
                            I bet you're getting wet like you do when I finger you.[/color]"
                        [/p]
                        [p]
                            You ignore his words, instead concentrating on the task at hand.
                            Upping your efforts one final time, jerking him off at a high pace while rolling your tongue around the tip of his member,
                            Falco's comments slowly fade in favor of more heated groans.
                            It's kind of [i]cute[/i], to watch him go from a domineering blackmailer to a squawking hatchling,
                            becoming less coherent the closer he gets to his orgasm.
                            Then again, this [i]is[/i] his first time, or so you assume.
                        [/p]
                        [p]
                            The moment you can feel the eagle's length start to quiver within your grasp,
                            you immediately pull off of his cock, and start jerking him wildly,
                            using the spit dribbling down from the tip as lubrication.
                            The bird leans back slightly, and with a loud, orgasmic moan, he reaches his end,
                            coating your face with rope after rope of thick avian jizz, painting your green scales white.
                        [/p]
                        [p]
                            As his hefty orgasm comes to a dribbling end, Falco wordlessly pulls up his pants, buckles his belt,
                            and walks out of the room, leaving you sitting on your knees with a face full of cum and a sore, spanked behind.
                        [/p]`;
        } else {
            toReturn += `
                        [p]
                            You aren't about to let the bird have sex with you.
                            That's one step further than you're willing to go.
                            You [i]will[/i], however, do something for him that the two of you have never done before.
                            "[color=yellow]It's not [i]butt stuff[/i], is it?[/color]"
                            No, no.
                            Wait and see.
                            You assure him that he won't be disappointed.
                        [/p]
                        [p]
                            Falco sceptically watches as you drop to your knees in front of him.
                            Doubt drains from his mind, however, as you nuzzle your muzzle against his length,
                            rubbing his cock with your face.
                            After a bit of [i]teasing[/i],
                            you position yourself in front of the foreskin-covered tip of the eagle's humanoid member.
                            Then, you part your lips, and take his shaft into your mouth,
                            enveloping it with the warm wetness of the insides of your maw.
                        [/p]
                        [p]
                            The boy is clearly enjoying this.
                            He lets out a loud, orgasmic moan, as though he's never been more satisfied in the entirety of his life thus far.
                            And you're just getting started.
                            You dutifully begin to bob up and down his length,
                            whilst swirling your tongue around his girth,
                            sucking him off to the best of your abilities.
                        [/p]
                        [p]
                            The avian looks like he's in [b]heaven[/b].
                            While you've frequently jerked him off these past few weeks,
                            you don't think he's [i]ever[/i] had a blowjob before.
                            Various pleasured grunts escape his beak,
                            sometimes loud enough to match the ones coming from upstairs.
                        [/p]
                        [p]
                            Instead of telling him to keep it down, you decide to concentrate on getting him off,
                            to finish this as soon as possible, preferably [i]before[/i] you get caught.
                            You up your efforts one final time, moving your head up and down as fast as you can.
                            The eagle is getting close.
                            His member begins to quiver and tremble inside of your maw.
                            You cup his hefty, swinging balls, massaging them gently, as if to encourage him to blow his load.
                        [/p]
                        [p]
                            With his tongue lolling out of his beak, and one final loud groan,
                            Falco finally reaches his end.
                            You keep the foreskin-covered tip of his cock in your mouth,
                            tenderly suckling on it while he squirts rope after rope of thick avian jizz along the length of your tongue.
                            You greedily gulp down every single drop of the bird's load, and once you've sucked him dry,
                            you pull off of his member, and open your muzzle to showcase that you were a [i]good girl[/i] and [b]swallowed[/b].
                        [/p]
                        [p]
                            The eagle seems completely [i]out of it[/i].
                            Like you've [i]overstimulated[/i] him, or something.
                            After recovering for almost an entire minute,
                            he wordlessly pulls up his pants, buckles his belt,
                            and walks out of the room, leaving you sitting on your knees with a belly full of cum.
                        [/p]`;
        }

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\parents\absent\FarmerMaidAbsentBlowjob.js

// scenes\Enslavement\DayTwo\FarmerMaid\parents\absent\FarmerMaidAbsent.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidAbsent(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.preParents;
    var subController = ctrl.parents;
    var changeController = false;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";

    var firstNext = ctrl.fragments.handjob;
    var secondNext = ctrl.fragments.blowjob;

    var firstChoice = ctrl.parentsChoice.HANDJOB;
    var secondChoice = ctrl.parentsChoice.BLOWJOB;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            Near the end of the sixth week, the routine is broken.
                            Falco storms into the dining room, clearly upset about something.
                            Romeo and Juliet are nowhere to be found, as usual.
                            That leaves only [b]you[/b] to vent his frustration on.
                            And he [b]isn't[/b] looking to talk.
                        [/p]
                        [p]
                            The eagle forcibly [b]bends[/b] you over one of the dining table chairs.
                            He lifts your tail, and brings the flat of his palm to bear upon your sensitive butt,
                            harshly [b]spanking[/b] your ass with all of his might.
                            He crudely [b]smacks[/b] your reddening rear again and again and again.
                            You cry out in pain, and [b]beg[/b] for him to stop, every blow stinging more than the last.
                            But he isn't listening.
                            He's intent on discharging every last bit of his hormonal annoyance and anger,
                            even if that means [b]paddling[/b] your behind until you can barely even [b]walk[/b] anymore.
                        [/p]
                        [p]
                            While not as bad as the torture you went through at the start of your enslavement,
                            the following ten minutes still [b]hellish[/b] beyond belief.
                            Your sore hindquarters get struck over and over,
                            your begging pleas and agonized shouts echoing throughout the empty house.
                            The spot around your brandmark hurts the most, your scales still sore from the slave insignia burned into them.
                        [/p]
                        [p]
                            Only after your tears have long run out, does the torment come to an end.
                            But Falco isn't done with you yet.
                            He yanks you off the chair, and onto your knees.
                            Unbuckling and dropping his pants, he presents you his rock-hard member, the tip all but rubbing in your face.
                            "[color=yellow][b]Suck it, slave.[/b][/color]" he states, giving his length a few much-needed strokes.
                            "[color=yellow]Or I'll [b]tear[/b] your outfit and go tell my dad you tried to escape.[/color]"
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === firstChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${firstId}" ${disabled}>A handjob</button>`;

        var tooltip = global.parser.parse(`You don't have a choice. Use your hands to pleasure the bird. Hope that'll sate him.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 200px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === secondChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${secondId}" ${disabled}>A blowjob</button>`;

        var tooltip = global.parser.parse(`Suck the avian off to please him.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 225px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You give him:</div>`;
        choice += buildFirstChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(firstChoice);
            loadNextPart(firstNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(secondChoice);
            loadNextPart(secondNext);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += firstNext.build();
        part += secondNext.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        firstNext.registerListeners();
        secondNext.registerListeners();

        if (subController.has()) {
            return;
        }

        registerFirstListener();
        registerSecondListener();
    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\parents\absent\FarmerMaidAbsent.js

// scenes\Enslavement\DayTwo\FarmerMaid\parents\absent\FarmerMaidPreAbsent.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidPreAbsent(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.postMaid;
    var subController = ctrl.preParents;
    var changeController = false;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new FarmerMaidAbsent(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var virgin = ctrl.misc.cuntVirgin();
        var toReturn = `[p]
                            You sleep with troubled dreams that night,
                            the memory of being molested repeating itself over and over in your mind,
                            manifesting itself as horrible nightmares.
                            You wake up late in the morning, feeling more sleepy than when you went to bed.
                            Time for the daily routine to pick up once more.
                        [/p]
                        [p]
                            You go about your day, doing your duties as a maid.
                            You clean the den, you wipe the tableware after breakfast, you tidy rooms,
                            and you end with sweeping the floor in the kitchen.
                            You take a small break, gazing out the window, admiring the outside world.
                            You get lost in your own thoughts, wearily daydreaming, half falling-asleep.
                            So distraught are you, that you don't even notice Falco sneaking up behind you.
                        [/p]
                        [p]
                            You [b]yelp[/b] in surprise as the avian suddenly [b]grabs[/b] your bare bottom,
                            rubbing and squeezing your naked ass to his heart's content, kneading your scales and cupping your buttcheeks.
                            Before you even properly realize what's going on, the boy has already left.
                            You hear him climbing the stairs, and locking himself in his room once again.
                            Hoping this won't be a repeating occurrence, you head to bed.
                        [/p]
                        [p]
                            More nightmares.
                            You drift awake multiple times during the night.
                            Come time to wake up, it feels like you barely slept at all.
                            And again, throughout the day, Romeo's son sneaks up behind you to cop a feel of your supple kobold body.
                            This time, he tugs down your maid outfit, baring your tits before crudely [b]squeezing[/b] your nipples.
                            You're too tired to resist.
                            Lousy little pervert.
                        [/p]
                        [p]
                            Every single day of the remaining half of the first month of your stay,
                            Falco cops a feel of your body.
                            There is no rhyme or reason to his actions.
                            Sometimes he grabs your tits in the morning,
                            on a few occassions he molests you right after lunch,
                            other times he gropes your butt right before you head to bed.
                            Once or twice, when a day seemingly goes by without molestation,
                            he even finds his way to your basket during the night, to touch you while you sleep.
                        [/p]
                        [p]
                            Even the fondling itself is inconsistent.
                            Often, he restricts himself to only a few light squeezes or pinches,
                            but there are encounters where you find yourself pressed against a cabinet for the better half of an hour,
                            while he runs his grubby little hands all over your scales, from the bottom of your behind to the back of your neck.
                            There are only two things you can count on when dealing with the bird.
                            The first is that not a day goes by without his unwanted attention.
                            The second is that once he's done with you,
                            he rushes upstairs and locks himself in his room.
                        [/p]
                        [p]
                            All of this changes around the start of the second month.
                            The avian grows more bold.
                            Your [i]sessions[/i] together grow longer.
                            His hands find their way in between your thighs on more than one occassion,
                            teasingly at first,
                            but all too soon he starts outright [b]rubbing[/b] your slit.
                            You continue not paying him any attention,
                            simply letting him [i]experiment[/i] with your body to avoid having to face his father.
                        [/p]
                        [p]
                            Near the end of the fifth week of your stay,
                            Falco outright [b]fingering[/b] your ${virgin ? `virginal` : ``} cunt has become a daily event.
                            While he doesn't [i]turn you on[/i] in the slightest,
                            your body is starting to respond to the attention it's receiving.
                            A single touch leaves you unfazed,
                            but after an entire hour of groping, prodding, fingering and teasing,
                            you sometimes find your folds growing slightly [i]moist[/i] and [b]damp[/b] by the time he's done with you.
                        [/p]
                        [p]
                            Being left flustered is the least of your concerns.
                            The bird's daily, lengthy molestation is eating away at the time you spend cleaning.
                            Luckily, his parents are too busy to notice that you've been [i]slacking off[/i].
                            His mother makes frequent trips to Varanar, and his father is off working the fields day-in, day-out.
                            You wish you had the heart to tell the boy off,
                            but every time you see Romeo, you are reminded of why you put up with his son's behavior.
                            The large human has worked up quite the temper.
                            You think the farming business isn't going so well.
                        [/p]
                        [p]
                            Near the start of the second week of the second month,
                            things deteriorate further.
                            While vigorously squeezing your rear as usual,
                            Falco's motions suddenly grind to a halt.
                            A pensive look is plastered across his face.
                            Like he's had a realization.
                            An epiphany.
                        [/p]
                        [p]
                            The avian fiddles with his belt,
                            unbuckling the leather strap, letting his pants fall to the floor,
                            his fully erect, uncut humanoid member springing free, mere inches away from your rear.
                            For a moment, you fear he's about to [b]rape[/b] you, but instead,
                            he simply gives his shaft a few rapid pumps with his hand,
                            before squirting a hefty load of pungent bird spunk over your bubbly butt.
                        [/p]
                        [p]
                            Shocked, you do nothing but look back at him in horror,
                            while he paints your ass white with the contents of his feathery, low-hanging balls.
                            His orgasm over, he pulls up his pants once more, rebuckles, and wanders off to continue his day,
                            leaving you to deal with the mess he made.
                        [/p]
                        [p]
                            That week, him masturbating while toying with your body becomes commonplace.
                            He always finished on your scales,
                            be it by coating your breasts,
                            lifting your tail and blowing his load on the base,
                            or simply finishing on your shapely behind.
                            You have to remind him several times [b]not[/b] to stain your maid outfit.
                            He begrudgingly listens to your advice,
                            neither of you keen on having his parents find out about this entire or deal,
                            each for your own reasons.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\parents\absent\FarmerMaidPreAbsent.js

// scenes\Enslavement\DayTwo\FarmerMaid\maid\FarmerMaidMaidResist.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidResist(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = FarmerMaidMaidChoice.RESIST;
    var reqController = ctrl.maid;
    var subController = ctrl.postMaid;
    var changeController = false;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new FarmerMaidPreAbusive(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            No.
                            You sternly [b]slap[/b] the boy's hands off of your chest.
                            Turning around, you push him away from you.
                            "[color=yellow]Hey!
                            You're my [b]slave[/b].
                            You can't push me away like that!
                            Want me to go tell my dad you're being [b]rude[/b] to me?[/color]"
                        [/p]
                        [p]
                            You kindly inform the avian that you are [b]not[/b] his slave.
                            You are his [b]father[/b]'s slave, and his [b]maid[/b].
                            You clearly remember the human saying, on the day you were bought, that you are [b]not[/b] a pet.
                            His ogling, you permitted, because it didn't really bother you too much, but this time, he took things too far.
                            If anything, [b]you[/b] should be the one telling Romeo about what happened here.
                        [/p]
                        [p]
                            While you are still not used to talking without teeth, you think you got the point across.
                            Your words clearly upset the avian.
                            He glares at you with an intense hatred in his beady eyes.
                            For a moment, he raises his hand, as though he's about to strike you,
                            yet he manages to refrain.
                            Instead of knocking some sense into you,
                            the bird angrily storms out of the door.
                            That is the last you see of him that day.
                        [/p]
                        [p]
                            The day after, Falco is no longer around to ogle you.
                            In fact, you never witnessed him emerging from the dining room after breakfast.
                            He must have left through the back door.
                            After finishing your duties in the den,
                            you swing open the kitchen door,
                            and stumble upon something you wish you hadn't seen.
                        [/p]
                        [p]
                            The eagle is bending his human mother over the countertop,
                            one of his hands wantonly groping her shirt-covered chest,
                            while he grinds his bulging member against her shapely behind.
                            He doesn't even stop when he notices you,
                            instead shooting a wicked smile your way,
                            pinching Juliet's nipple to make her [b]squeal[/b].
                        [/p]
                        [p]
                            For a moment, you look on in shock,
                            your brain refusing to believe what your eyes are seeing.
                            The boy gives his mother an explicit [b]hump[/b],
                            rubbing his groin against hers,
                            rocking her body back and forth along the countertop.
                            Unsure of how to react, you are frozen in place for a few seconds more.
                            Then, you awkwardly back away,
                            and close the kitchen door like you were never even there,
                            leaving the two to their privacy.
                        [/p]
                        [p]
                            Your heart is racing.
                            Falco molesting his mother?!
                            You wonder if he's doing this because you denied him,
                            or if this was an ongoing thing that you only just now stumbled upon?
                            She didn't seem too happy about it,
                            but she wasn't resisting his grasp either.
                            She could have easily thrown him off if she wanted to.
                        [/p]
                        [p]
                            You briefly wonder whether or not you should [i]intervene[/i],
                            or perhaps tell Romeo about what's happening,
                            but you'd rather not poke that hornet's nest.
                            This is between Juliet and her son.
                            A familial affair.
                            It would be rude of you to butt in.
                            You're a slave, not a relationship counselor.
                            It's none of your business.
                            So you act like you saw nothing.
                            Like everything is [b]fine[/b].
                            Ignoring the events unfolding in the kitchen, you head upstairs and clean the family's rooms.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\maid\FarmerMaidMaidResist.js

// scenes\Enslavement\DayTwo\FarmerMaid\maid\FarmerMaidMaidEncourage.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidEncourage(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = FarmerMaidMaidChoice.ENCOURAGE;
    var reqController = ctrl.maid;
    var subController = ctrl.postMaid;
    var changeController = false;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new FarmerMaidPreAmorous(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            So, the boy is [i]interested[/i] in your body, huh?
                            Scolding him for being curious would be awfully rude of you,
                            not to mention kind of [i]hypocritical[/i].
                            Instead, you decide to give him a little [i]show[/i].
                            Something he will [b]never[/b] forget.
                        [/p]
                        [p]
                            You turn around, the avian removing his hands from your bosom, clearly thinking you're about to tell him off.
                            His face turns to shock, when instead of angrily reprimanding him,
                            you promptly tug down your maid dress, showing your naked tits to the eagle.
                            His eyes go wider still, as you take his hand, and place it upon your bare breast-scales,
                            giving him a reaffirming nod in the process.
                        [/p]
                        [p]
                            Falco eagerly rubs and squeezes your chest, his second hand joining in on the fun.
                            His inexperience is kind of [i]endearing[/i].
                            You only barely manage to suppress your excitement, as he [b]squeezes[/b] one of your nipples.
                            It's like he's never seen a pair of breasts before in his life.
                            Juliet must not have wanted to breastfeed him.
                            You don't blame her -- he [b]does[/b] have a beak, after all.
                        [/p]
                        [p]
                            Speak of the devil, both you and your new avian friend gasp in surprise,
                            as your notice the front door being fiddled with.
                            You instantly fix your dress, and return to cleaning.
                            The bird, panicking, flees up the stairs.
                            Through the front door walks his mother,
                            home from shopping for foodstuffs in Varanar.
                        [/p]
                        [p]
                            She greets you, and with a flushed look on your face, you welcome her home.
                            She suspiciously stares at you for a few tense moments.
                            Shrugging, the woman asks you to help her carry the goods she brought him to the kitchen.
                            And so, your life as a maid resumes.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\maid\FarmerMaidMaidEncourage.js

// scenes\Enslavement\DayTwo\FarmerMaid\maid\FarmerMaidMaidAbide.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidAbide(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = FarmerMaidMaidChoice.ABIDE;
    var reqController = ctrl.maid;
    var subController = ctrl.postMaid;
    var changeController = false;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new FarmerMaidPreAbsent(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            You don't like this.
                            Getting fondled by a bird of questionable age,
                            while dressed up as a skimpy maid,
                            cleaning the house of the farmer that bought you.
                            But you can't stop him.
                            He's the [b]son[/b] of your master.
                            If you don't give him what he wants, he'll cry to his dad.
                            And who knows what Romeo might do to you then?
                            Torture you more?
                            [b]Kill[/b] you?
                        [/p]
                        [p]
                            You can't take that risk.
                            Even if that means getting fondled against your will.
                            You just have to let the avian sate his curiosity.
                            You're certain he'll back off after he's had a good feel or two.
                        [/p]
                        [p]
                            And a good feel he gets.
                            Falco wantonly squeezes your sensitive breasts with his feathery hands,
                            caressing your bosom through the thin, black fabric of your maid attire.
                            He slowly rolls his hips back and forth,
                            grinding his clothed package against your rear,
                            pleasuring his cock by squeezing it between your scaly butt and his thighs.
                        [/p]
                        [p]
                            For a moment, you think the boy is about to [b]rape[/b] you,
                            but then, as quickly as the unwanted fondling began,
                            it ends once more.
                            Suddenly, the bird lets go of you,
                            and before you can even ask him why the [b]hell[/b] he did that,
                            he [b]bolts[/b] up the stairs.
                            You can hear the door to his room opening, closing, and then locking.
                            You've a pretty good idea what he's doing in there.
                        [/p]
                        [p]
                            Anyway, you're glad it's over.
                            You [i]could[/i] go knock on his door and [b]demand[/b] an explanation,
                            but what's the point?
                            He got what he wanted,
                            and you get to live another day [b]without[/b] having your brains caved in for misbehaving.
                            You forget about the entire ordeal,
                            and continue with your day like nothing happened.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\maid\FarmerMaidMaidAbide.js

// scenes\Enslavement\DayTwo\FarmerMaid\maid\FarmerMaidMaid.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidMaid(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.preMaid;
    var subController = ctrl.maid;
    var changeController = false;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";
    var thirdId = arguments.callee.name + "ButtonThree";

    var firstNext = new FarmerMaidResist(ctrl);
    var secondNext = new FarmerMaidAbide(ctrl);
    var thirdNext = new FarmerMaidEncourage(ctrl);

    var firstChoice = FarmerMaidMaidChoice.RESIST;
    var secondChoice = FarmerMaidMaidChoice.ABIDE;
    var thirdChoice = FarmerMaidMaidChoice.ENCOURAGE;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            The next morning,
                            you are awakened by the crowing of a rooster.
                            A feather duster and a broom lie on the floor, next to your basket.
                            Nobody's around but you.
                            You rise to your shaky, mangled feet.
                            Standing upright hurts, and you can [b]barely[/b] walk.
                            You consider fleeing, but you wouldn't get far like this.
                            Especially not with every villager in the hamlet keeping an eye out for you.
                        [/p]
                        [p]
                            That leaves three options.
                            You can make a mess of things, which will piss off your [i]master[/i] to the point where he'll probably [b]kill[/b] you.
                            While death seemed like a good alternative while you were being [i]tortured[/i],
                            right now you'd rather stay alive to see your wounds heal.
                            Alternatively, you could [b]refuse[/b] to work,
                            but given the hell you've been through already,
                            you're kind of [i]scared[/i] to think of what the human might do to you if you fail to live up to his expectations.
                            You can't take much more abuse.
                        [/p]
                        [p]
                            So, that leaves option number three: you clean.
                            As long as you do what your master expects of you,
                            he'll have no reason to [i]hurt[/i] you.
                            And you kind of [b]want[/b] that morsel of food he alluded to.
                            With that, your mind is made up.
                        [/p]
                        [p]
                            Bending down, you pick the broom up off the ground.
                            Gripping things with your fucked up fingers is painful,
                            but you manage to get a loose hold on the handle.
                            Swallowing what little of your pride you have left,
                            you deftly begin to sweep the wooden floor clean of dust, dirt and filth.
                            Due to your injuries, you can't really do a very good job,
                            but you try your best.
                        [/p]
                        [p]
                            Come dinner time, your dilligent efforts are rewarded.
                            You get a small piece of moldy old bread.
                            While your lack of teeth prevents you from [i]chewing[/i],
                            you let the stale, hard crust soak in your mouth,
                            until it disintegrates into pieces,
                            so you can swallow it down more easily.
                            While not much, it's [b]a lot[/b] better than nothing.
                        [/p]
                        [p]
                            The second day goes a lot like the first.
                            Your wounds are healing, your cleaning-technique steadily improving.
                            Growing accustomed to not having teeth, your speech also betters.
                            Another piece of moldy bread keeps you going.
                            The farmer's wife and son mostly ignore you.
                            You pick up their names by eavesdropping when they talk to one another.
                            Juliet and Falco.
                            Weird name for an eagle.
                            You don't dare bring it up, out of fear he'll take offence.
                        [/p]
                        [p]
                            Over the course of the week,
                            you listen in to multiple conversations,
                            trying to understand the [i]family dynamic[/i] between the bird and his [i]parents[/i].
                            From what you gather, Romeo and Juliet got together,
                            one day a bird came to visit,
                            and some time later Falco was born.
                            You don't know how a human gave birth to a bird,
                            but apparently that's what happened.
                            You wonder whether she laid an egg, or if it was a live birth.
                            Maybe he was [i]adopted[/i]?
                        [/p]
                        [p]
                            Near the end of your first week of proper [i]captivity[/i],
                            you notice the farmer's son starting to take an interest in you.
                            He begins to lounge around the house a lot more,
                            staring at you while you work.
                            At first, he tries to hide his curiosity from you,
                            looking away when you return his gaze.
                            As the days go by, he grows more bold.
                            He keeps his eyes fixed on you, sometimes for hours at a time.
                            At the start of the second week, you catch him outright [b]ogling[/b] you,
                            his eyes fixed on your exposed butt.
                        [/p]
                        [p]
                            The lecherous leering gradually becomes more and more commonplace.
                            Especially when you bend over to pick something up, the boy's eyes are trained on your backside.
                            Then, near the end of the second week, while cleaning one of the cabinets in the living room, the situation escalates.
                        [/p]
                        [p]
                            The avian rises from his seat on the couch,
                            and walks up right behind you,
                            his clothing-clad groin pressing into your bubbly rear.
                            You can feel his stiff member prodding against your butt through his pants.
                            Without a word, his hands roam to your chest, and he casually begins to molest your barely covered breasts,
                            his breath audibly growing heavier.
                            You don't know how old he is, but you doubt this is appropriate behavior for his age!
                            How do you react?
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === firstChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${firstId}" ${disabled}>Resist</button>`;

        var tooltip = global.parser.parse(`Be firm, and tell the boy to stop.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 230px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === secondChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${secondId}" ${disabled}>Abide</button>`;

        var tooltip = global.parser.parse(`Let him have his fun. He'll grow tired of touching you soon enough.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 240px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildThirdChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === thirdChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${thirdId}" ${disabled}>Encourage</button>`;

        var tooltip = global.parser.parse(`Teach the kid a thing or two.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 195px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You:</div>`;
        choice += buildFirstChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildThirdChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId), $("#" + thirdId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(firstChoice);
            loadNextPart(firstNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(secondChoice);
            loadNextPart(secondNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerThirdListener() {
        $("#" + thirdId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(thirdChoice);
            loadNextPart(thirdNext);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += firstNext.build();
        part += secondNext.build();
        part += thirdNext.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        firstNext.registerListeners();
        secondNext.registerListeners();
        thirdNext.registerListeners();

        if (subController.has()) {
            return;
        }

        registerFirstListener();
        registerSecondListener();
        registerThirdListener();
    };
}

var FarmerMaidMaidChoice = {
    RESIST: 1,
    ABIDE: 2,
    ENCOURAGE: 3
};

// END scenes\Enslavement\DayTwo\FarmerMaid\maid\FarmerMaidMaid.js

// scenes\Enslavement\DayTwo\FarmerMaid\maid\FarmerMaidRecover.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidRecover(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.recover;
    var subController = ctrl.preMaid;
    var changeController = ctrl.recover;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new FarmerMaidMaid(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var male = ctrl.misc.dick();
        var recap = ctrl.gender.get() === FarmerMaidGenderChoice.BLACKOUT;
        var toReturn = `[p]
                            Some time later, you wake up from a deep, troubled period of unconsciousness.
                            You don't know how long you were out.
                            Minutes?
                            Hours?
                            Days?
                            For a moment,
                            you entertain yourself with the idea that the faint memories of you enduring excruciating torture were nigh but [b]dreams[/b].
                            Delirious nightmares.
                            Fantasies, and nothing more.
                            As your senses slowly drift awake,
                            you become aware once more of the [b]crippling[/b] pain coming from your mouth, your hands and your feet.
                            The illusion is quickly shattered.
                            It really [b]did[/b] happen.
                        [/p]
             ${recap ? `[p]
                            Your head hurts.
                            Your [b]everything[/b] hurts.
                            Your teeth have been removed, pulled out one at a time.
                            Your claws suffered the same fate, your fingers and toes half-[b]mutilated[/b] as a result.
                            To make matters worse, your ass has been branded,
                            the insignia scorched on your scales marking your status as a [b]slave[/b].
                        [/p]` : ``}
                        [p]
                            You painstakingly open your heavy eyelids, to find yourself indoors.
                            You are lying curled up inside of a large and rather comfortable basket.
                            Several clumps of fur make you think this used to belong to a feral dog.
                            You wonder if it got its claws and teeth removed as well.
                            You hope it didn't.
                        [/p]
                        [p]
                            The more awake you get, the more your body aches.
                            You groggily come to an upright, seated position.
                            Your hands and feet look [b]terrible[/b].
                            The bleeding has stopped, but your fingers continually twitch like you're some old [i]witch[/i] casting a [b]curse[/b].
                            Your nerves must have gotten seriously damaged.
                        [/p]
                        [p]
                            You keep on trying to rest your teeth atop one another,
                            but the simple fact is that you [b]have none[/b].
                            As a result, you squish your sensitive,
                            hurting gums against one another time after time again,
                            making you wince in pain over and over.
                        [/p]
                        [p]
                            While your senses slowly grow accustomed to being bombarded with constant pain,
                            you look around the room you're in.
                            It looks like a living room,
                            four shabby, half-rotten wooden walls interrupted only by a trio of doors.
                            One to the kitchen, one which you think [i]might[/i] lead outside,
                            and a third to a stairwell.
                        [/p]
                        [p]
                            A big bench-resembling couch with little padding dominates the room.
                            The basket you're in -- which you presume will be your resting spot for the remainder of your stay here -- is next to the couch.
                            Various aging cabinets and cupboards are lined along the dilapidated walls.
                            Not a single piece of art in sight,
                            apart from a small, plain, cheap vase holding a few backyard flowers atop a piece of wooden furniture.
                        [/p]
                        [p]
                            While [b]massive[/b] compared to your shack in the woods,
                            you understand that this is a [i]poor[/i] home, as far as human households go.
                            Then again, besides Seki's workshop and the [i]mansion[/i] across the road from it,
                            [b]every[/b] home in the hamlet is [i]impoverished[/i].
                            You wonder how the farmer was able to [i]afford[/i] you, but you're certain you wouldn't like the answer even if you knew.
                        [/p]
                        [p]
                            Suddenly, movement.
                            Romeo, the man of the house, walks in through the front door.
                            Glistening sweat rolls down his brow.
                            He must be getting home from working the fields or something.
                            His attention immediately turns towards you, his mere gaze inspiring fear.
                            You curl up into a ball once more, clutching your tail, trembling in fear.
                            "[color=red]Finally awake?
                            I was starting to think you'd slip into a coma.[/color]"
                            A coma?!
                            How long were you out for?
                        [/p]
                        [p]
                            The man moves towards one of the cupboards.
                            Opening it, he reaches in and pulls out a maid outfit, suitable for a child, or a kobold like yourself.
                            Did he get that just for you, or is that something his [i]son[/i] used to wear?
                            He tosses the garment towards you.
                            On closer inspection, it's kind of [i]skimpy[/i].
                            You don't think this will cover your butt [b]at all[/b], and it'll [b]barely[/b] conceal your loins!
                        [/p]
                        [p]
                            You try to voice your objections, but speaking without teeth proves to be quite a bit harder than you'd thought.
                            You don't manage to form any coherent words, apart from some rabid mumbling.
                            Realizing you aren't getting your point across, you end with a reluct, teary sigh.
                            "[color=red]Why I bought you?[/color]"
                            No, that's not what you were asking at all, but there's no point trying to correct him.
                            "[color=red]To clean my house, and to shut my son up about wanting a new pet.[/color]"
                        [/p]
                        [p]
                            A [i]pet[/i]?
                            Great.
                            Just what you needed, to be treated like an [b]animal[/b].
                            You give the human a sour, sulking look.
                            "[color=red]Don't even [b]think[/b] about running away.
                            Every man in town knows you're [b]mine[/b].
                            One look at your ass, and they'll know to capture or kill you.
                            If you're lucky, that is.
                            They might want to keep you for themselves,
                            and I can assure you that I am [b]far[/b] from the worst person in this village.[/color]"
                        [/p]
                        [p]
                            Wow, this guy really knows how to lift your spirits, huh?
                            Then again, these farmers [b]aren't[/b] known for being the most [i]charismatic[/i] fellows.
                            "[color=red]As long as you do what you're told, you'll be treated fairly,
                            and we'll even toss some food your way every now and again.[/color]"
                            Well, at least you won't [i]starve[/i].
                            "[color=red]Oh, and while I've already taken away most of your [i]dangerous[/i] bits,
                            you lay even one hand on my wife or my son, and I will make you [b]wish[/b] you were never born.[/color]"
                            He already has.
                        [/p]
              ${male ? `[p]
                            So, you [i]kind of[/i] understand why he took out your claws and your teeth.
                            You don't [b]agree[/b] with him doing those things, but you understand [b]why[/b] he did them.
                            But one thing that you can not wrap your head around is why exactly he turned you into a [b]girl[/b].
                            Unable to properly speak, you give the human a quizzical, upset look through your teary eyes, whilst pointing towards your groin.
                        [/p]
                        [p]
                            "[color=red]Oh right.
                            My cousin in law told me that [i]male[/i] kobolds tend to get [b]territorial[/b] during mating season.
                            I could have [b]neutered[/b] you instead,
                            but I figured the bloodloss from cutting out your balls might have [b]killed[/b] you.
                            You should [b]thank me[/b], really.[/color]"
                            [i]Territorial[/i]?
                            [b]Mating season[/b]?!
                            You don't know what [b]animal[/b] he's talking about,
                            but the human is grossly misinformed on your kind.
                        [/p]
                        [p]
                            But it's too late to complain.
                            The damage is already done.
                            And even [i]if[/i] you could talk properly,
                            you doubt your voice of reason would be heeded.
                            "[color=red]Besides, have you ever heard of a [b]male[/b] maid?
                            I sure haven't.
                            People might start getting the [i]wrong idea[/i] about me or my kid.
                            Not that I plan on fucking you.
                            I have my wife for that.
                            You're a [b]maid[/b].
                            Not a [b]whore[/b].[/color]"
                            While slightly reassuring, this is getting pretty awkward.
                        [/p]` : ``}
                        [p]
                            "[color=red]Your maid duty starts tomorrow.
                            Get some more rest.
                            You look like you could use it.[/color]"
                            No arguing there.
                            You think you could sleep for an entire [b]month[/b] and [b]still[/b] feel like [b]shit[/b].
                            The man gives you an assertive nod,
                            then walks out of the room.
                        [/p]
                        [p]
                            After wiping your tears on the child-sized maid dress,
                            you reluctantly put it on.
                            While not freezing cold, this house isn't very [i]warm[/i], either.
                            You hope the thin fabric will keep you at least [i]somewhat[/i] heated.
                            At least it'll be warmer than sleeping in the nude.
                            You curl up into a ball once more,
                            cuddling up against the edges of the basket you're in,
                            and cry yourself to sleep.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        global.ui.applyTheme("hamlet_barn");
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\maid\FarmerMaidRecover.js

// scenes\Enslavement\DayTwo\FarmerMaid\arrival\pain\FarmerMaidBrandmark.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidBrandmark(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.teeth;
    var subController = ctrl.recover;
    var changeController = ctrl.brandmark;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = ctrl.fragments.recover;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            No.
                            The men still aren't letting go.
                            You are bent over forwards.
                            Your tail is yanked up.
                            Are they going to [b]rape[/b] you?!
                            After all of this?
                        [/p]
                        [p]
                            After wiping them clean, Romeo puts his tongs back where they belong.
                            Stepping over to the kiln next to the shed,
                            he pulls out one of the sizzling irons, tipped with a blazing-hot insignia.
                            As the human steps behind you, the other men reinforce their grip on you.
                            Like they know you're about to [b]struggle[/b].
                        [/p]
                        [p]
                            And struggle you do.
                            Your owner mercilessly [b]rams[/b] the blazing brand against your right buttcheek,
                            a simmering sound muffled by your panicky screams, your scales [b]searing[/b], even the flesh underneath [b]burning[/b].
                            You wriggle your body around as best you can, trying but failing to get away from the scorching pain.
                            "[color=red]Keep'er [b]steady[/b]!
                            The pain might [b]kill[/b]'em if I have to do this twice.[/color]"
                        [/p]
                        [p]
                            He holds it in place for what seems like an [b]eternity[/b].
                            There is no escape.
                            Your eyes roll into the back of your head.
                            Your entire body goes limp.
                            You finally pass out.
                            Death or unconsciousness, you welcome them both.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\arrival\pain\FarmerMaidBrandmark.js

// scenes\Enslavement\DayTwo\FarmerMaid\arrival\pain\FarmerMaidTeeth.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidTeeth(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.claws;
    var subController = ctrl.teeth;
    var changeController = ctrl.teeth;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new FarmerMaidBrandmark(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            While the searing pain still inhibits much rational thought,
                            your nerves calm a very little, believing your torment to be over.
                            Nothing could be further from the truth.
                            As your breathing starts to stabilize, you notice the men haven't [i]let go[/i] of you yet.
                            Are they [i]not[/i] finished yet?
                        [/p]
                        [p]
                            A pair of filthy hands finds its way inside of your gaping maw,
                            and spreads your jaws open wide.
                            You are far too worn out to resist.
                            Romeo shallowly presses one of his fingers into your muzzle,
                            rubbing the tips of the bottom row of your sharp teeth.
                            Giving a reaffirming nod to his [i]friends[/i], he ominously nears your mouth with the pliers.
                        [/p]
                        [p]
                            Realizing what is about to happen, you struggle as hard as you can, but your drug-weakened,
                            weary body is no match for the multitude of strong farmers holding you in place.
                            Even your jaws, otherwise extremely powerful,
                            with teeth capable of biting even through thin metal,
                            are easily overpowered by a single set of hairy, grimy fingers.
                            You are completely powerless to stop them,
                            and that fact hurts you far more than their torture ever could.
                            Or so you hope.
                        [/p]
                        [p]
                            Your owner clamps one of your sharp fangs in between the jaws of his pliers.
                            You audibly weep, shivering from pain, shock and trauma.
                            But he doesn't care.
                            Your claws were dangerous.
                            So are your teeth.
                            He can't let a [b]wild animal[/b] into his house without [i]disarming[/i] it first.
                            For all he knows, you could tear his son's throat out, or scar his wife for life.
                            And he's not going to let that happen.
                        [/p]
                        [p]
                            Romeo tormentingly wriggles your tooth about, so hard you fear he might [b]break it off[/b].
                            But that's not his plan.
                            He's merely [b]loosening[/b] it.
                            After a few agonizing moments, he [b]pulls[/b] backwards, [b]yanking[/b] the fang straight out of your mouth,
                            tearing the very roots of your tooth from your gums.
                            You [b]scream[/b] out in pain, louder than you have ever screamed before.
                            Your mouth floods with blood, which oozes from your muzzle, diluted with spit.
                        [/p]
                        [p]
                            This is hell.
                            You fell off the stage at the auction, broke your neck and [b]died[/b].
                            These [b]demons[/b] are torturing you.
                            Your head is tilted upwards, your own blood running down into your throat.
                            You have no choice but to swallow it.
                            Your second fang is taken in between the pliers.
                            At least this time he doesn't wriggle it around.
                            A single [b]tug[/b] sends a new soul-crushing wave of torment coursing throughout your body.
                            Another tooth lost.
                        [/p]
                        [p]
                            You are defanged.
                            But still they do not let go.
                            What more do they want?
                            Oh no.
                            The farmer you belong to wipes the blood off of his pliers,
                            before pressing them into your mouth once more.
                            This time, he takes hold of an incisor next to the hole where one of your fangs used to be.
                            Then you realize.
                            It's not just your fangs.
                            He wants to remove [b]all[/b] of your teeth.
                            With that thought, your mind goes blank once more, unable to cope with the situation at hand.
                        [/p]
                        [p]
                            You come to your senses halfway through your teeth-removal,
                            prodded awake by a [i]new[/i] type of pain.
                            Working on one of your back teeth, Romeo has accidentally placed his pliers too high.
                            Instead of clamping on to the molar he was aiming for, his tongs sink into your soft, sensitive gums.
                            Not realizing his mistake, he presses down hard with both of his hands,
                            [b]squeezing[/b] your flesh in between the two metal jaws hard enough to [b]draw blood[/b].
                            You let out an agonized gurgle, coughing up some of the various fluids pooling at the back of your throat.
                            Only after several seconds of [b]crushing[/b] your upper jawbone to the point of [b]shattering[/b] it,
                            does he readjust his grip, and manage to pull the tooth out in a single rip.
                        [/p]
                        [p]
                            While you, [i]sadly[/i], don't manage to have any more mini-black outs,
                            events somewhat start to blur together after your owner's [i]mishap[/i].
                            One tooth gets yanked out after the other, and before you know it, your entire mouth is empty and barren.
                            The scruffy fingers are removed from your mouth,
                            and your aching jaw can come to a rest.
                            You make the mistake of fully closing your mouth, pressing your bleeding gums against one another,
                            the sudden pain almost making you [b]choke[/b] on your own spit.
                        [/p]
                        [p]
                            As your head is let go of, you let it limply hang off your neck,
                            letting the blood seep from your muzzle onto the ground,
                            which is already running red from the liquid still spilling from your fingers and toes.
                            At least it's over.
                            It [b]is[/b] over, right?
                            There's nothing left of you to remove.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\arrival\pain\FarmerMaidTeeth.js

// scenes\Enslavement\DayTwo\FarmerMaid\arrival\pain\FarmerMaidClaws.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidClaws(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = FarmerMaidGenderChoice.CLAWS;
    var reqController = ctrl.gender;
    var subController = ctrl.claws;
    var changeController = ctrl.claws;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new FarmerMaidTeeth(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var dick = ctrl.misc.dick();
        var toReturn = `[p]
                            That sickness you felt before returns, but in a [i]different[/i] way.
                            Like you know something [b]horrible[/b] is about to happen,
                            but you are powerless to stop it.
                            You meekly struggle against the men, but they barely even [b]feel[/b] your weakened limbs attempting to move.
                            Since your arm is already extended, your [i]owner[/i] decides to start with your hand.
                            Your palm is firmly grasped, and one of your fingers is held out.
                            The human catches your claw in between the flat ends of the tongs,
                            squeezing so tightly, the metal almost digs into the keratin.
                        [/p]
                        [p]
                            He starts to pull, to tug at your talon, stretching your finger to its limits.
                            One of the other men holds the digit in place, as the farmer ups his efforts,
                            heavily tugging at your sharp claw.
                            You wince in discomfort, the very flesh surrounding your nail exerted to its very limits.
                            Then, a sudden fierce [b]yank[/b].
                            A sickening [b]rip[/b] reaches your ears.
                            Your scales tear, and your claw is ripped whole from the tip of your finger,
                            blood oozing from the strained digit.
                        [/p]
                        [p]
                            [b]Pain[/b] clouds your hazy mind.
                            You [b]shout[/b] out in agony,
                            not even the numbing draught suffice to quell the [b]tormenting torture[/b]
                            of having one of the parts of your body physically [b]torn[/b] away from you.
                            One of the men wants to silence you, but another halts him, picking up a dirty stick from the ground,
                            and shoving it into your maw.
                            You bite down almost hard enough to [b]break[/b] the old branch, the immense pain almost too much to bear.
                            And they're not done yet.
                            They're just getting started.
                        [/p]
                        [p]
                            Your second claw comes out a bit more easily,
                            but excruciatingly painful nonetheless.
                            Tears flow liberally from your eyes, your already blurry vision distorted further,
                            making this entire thing seem like a [b]bad dream[/b] filled with mind-shattering torment.
                            You almost lose consciousness for a bit, barely even noticing the third and fourth of your claws being removed,
                            your pain-receptors overloaded and then some.
                        [/p]
                        [p]
                            The first talon of your other hand, however, hurts every bit as much as the very first one did.
                            It feels as though your very arm is being broken,
                            as the small bit of bone holding your claw in place is [b]ripped[/b] from your finger.
                            The agony is so severe, it almost makes you want to [b]vomit[/b], but your stomach holds too few contents to hurl up.
                        [/p]
                        [p]
                            Your mind goes blank.
                            You space out.
                            You don't know for how long.
                            When you come to, your hands are shaking.
                            Your claws are gone.
                            Your fingers are oozing blood.
                            Is the torture over, at last?
                        [/p]
                        [p]
                            No.
                            The men are still holding you.
                            Your [i]owner[/i] is kneeling in front of you.
                            Extra hands are placed on your leg.
                            The tongs find their way to one of your toes.
                            [i]Oh no[/i].
                            Not more.
                            Please not more.
                            You can't [b]handle[/b] any more!
                        [/p]
                        [p]
                            They seem to have gotten the technique down.
                            One of the men grasps your toe,
                            holding it steady, while Romeo [b]jerks[/b] the claw from your skin.
                            The anguish is immeasurable.
                            Every tug feels like they're [b]scraping[/b] at your very [b]soul[/b].
                            It's not just your hands and feet.
                            Your entire [b]body[/b] hurts.
                        [/p]
                        [p]
                            The next toe-claw goes less smoothly.
                            Your talon doesn't come out in one yank.
                            You soon learn that it hurts even [b]more[/b] when the claw [b]doesn't[/b] come out,
                            your scaly flesh tearing, but not [b]completely[/b], a nasty gash forming at the tip of your toe,
                            like the entire thing is about to be torn off.
                            While you can't see due to all the drugs and the tears,
                            it feels like part of your toe gets [b]ripped[/b] off during the second tug.
                        [/p]
                        [p]
                            You should have passed out already,
                            but the inhibiting potion shot into your veins keeps you awake.
                            It slightly [b]dulls[/b] the pain, to the point where it doesn't outright [b]kill[/b] you,
                            forcing you to tolerate this [b]hellish[/b] endeavour without granting you the sweet release of unconsciousness.
                            If you could still speak any coherent words, you'd be [b]begging[/b] for death right now.
                        [/p]
                        [p]
                            Another small blackout.
                            One of your eyelids is twitching.
                            Spit oozes liberally from your gaping maw.
                            The stick in your mouth has long-since cracked and been spat out.
                            You are breathing heavily.
                            You feel like you're about to [b]die[/b].
                            But they're at your final claw.
                            A little longer.
                            One more.
                        [/p]
                        [p]
                            This one doesn't come out.
                            Your owner messes up.
                            He tugs the wrong way.
                            Another loud crack.
                            You fear he might have broken your bones,
                            but there's very little pain.
                            Perhaps you're simply not feeling it.
                            Then, you realize it was your nail that cracked.
                            Surely, that will suffice, right?
                        [/p]
                        [p]
                            "[color=red]Can't have that growing back.[/color]"
                            Romeo grabs the leftover stump with his pliers,
                            and [b]slowly[/b] pulls out the remainder,
                            the fleshy sound of tendons and scales ripping [b]burning[/b] into your mind.
                            After a few moments of absolute [b]horror[/b], a small [i]snap[/i] indicates that it is finally coming to an end.
                            You have been fully declawed.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\arrival\pain\FarmerMaidClaws.js

// scenes\Enslavement\DayTwo\FarmerMaid\arrival\FarmerMaidGender.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidGender(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = ctrl.arrival;
    var subController = ctrl.gender;
    var changeController = ctrl.gender;

    var firstId = arguments.callee.name + "ButtonOne";
    var secondId = arguments.callee.name + "ButtonTwo";

    var firstNext = ctrl.fragments.recover;
    var secondNext = new FarmerMaidClaws(ctrl);

    var firstChoice = FarmerMaidGenderChoice.BLACKOUT;
    var secondChoice = FarmerMaidGenderChoice.CLAWS;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var dick = ctrl.misc.dick();
        var toReturn = `[p]
                            The men advance on you, each grabbing on to part of your body with their large, coarse hands, fully restraining you.
                            They're going to [b]rape[/b] you, aren't they?
                            You knew you should have [b]begged[/b] Fenrir to be allowed to stay with him.
                            But it's too late now.
                            This is your fate.
                            But, instead of groping you and touching your genitals like you expected,
                            the hands remain in place, simply holding you and nothing more.
                            Are they waiting for [i]approval[/i] or something?
                        [/p]
                        [p]
                            The thought of fighting against the men's grip occurs to you,
                            but it'd do more bad than good.
                            There's too many of them for you to put up any sort of real resistance.
                            Why aren't they getting this over with already?!
                            You're mentally prepared for the [b]worst[/b].
                            But this eerie [i]calm before the storm[/i] is completely [b]nerve-racking[/b].
                        [/p]
                        [p]
                            The only person not holding you, one of the horses, is rummaging around in his pockets.
                            The dreaful silence that had begotten the group is broken by your human captor.
                            "[color=red]Well? Do you have it, or not?![/color]"
                            What the hell are they talking about?
                            "[color=purple]Gimme a minute! Don't want to stab [b]myself[/b] with that stuff.[/color]"
                        [/p]
                        [p]
                            Encouraged by the human's impatience, the equine searches around his expansive pant-pockets a bit [i]less[/i] carefully.
                            After a few more moments, he retrieves a large syringe from his trousers,
                            filled with a swirling, muddy-pinkish liquid.
                            An aphrodisiac?
                            Before you can even object, your arm is forcibly stretched,
                            and the needle is brutishly [b]rammed[/b] into your flesh,
                            piercing your scales with ease.
                            You let out a pained yelp, but your muzzle is squeezed shut by one of the men before you can shout for help.
                        [/p]
                        [p]
                            The horse injects the fluid into your arm,
                            You immediately begin to feel [b]weak[/b] and [b]drowsy[/b].
                            Not enough to knock you out, but if it weren't for the restraining hands on every part of your body,
                            you doubt your own legs could support your weight.
                            Your vision grows blurry, and you grow exceedingly [b]dizzy[/b].
                            Like you're drunk beyond belief,
                            the entire world starts to twirl.
                            Not an aphrodisiac after all.
                        [/p]
              ${dick ? `[p]
                            You sense [i]something[/i] happening to your loins, but it's [b]not[/b] arousal.
                            Your slit-sheathed member feels [b]odd[/b].
                            Like it's being [b]tingled[/b] by a thousand little feathers.
                            Through your drug-induced haze, you can't quite figure out what's happening, until it's too late.
                        [/p]
                        [p]
                            Your cock shrinks, retracting into your body, vanishing entirely.
                            Your internal testicles wither away, rapidly replaced by fully-functional ovaries,
                            a freshly formed cervix connecting your cockslit-turned-cunt to your new reproductive organs.
                            Your chest tingles, a small pair of budding breasts growing atop your otherwise smooth, scaly torso.
                            As the transformation comes to an end, a small clitoris forms at the front-end of your slit.
                        [/p]
                        [p]
                            [c][b]You are now a girl![/b][/c]
                        [/p]` : ``}
                        [p]
                            Its contents emptied into your veins, the syringe is yanked from your arm, and discarded to the side.
                            Your muzzle is let go of.
                            You pant loudly, whining like a scolded dog.
                            "[color=red]This is for your own good, slave.
                            It'll make the next part a whole lot more bearable.[/color]"
                            Your owner reaches into the shack, and pulls out a large set of metal tongs,
                            the kind used in smithing...and in torture.
                            "[color=red]Let's start by removing those [b]dangerous[/b] claws of yours.[/color]"
                        [/p]
                        [p]
                            [sneak]
                                Choose wisely.
                                Once the [i]preparation[/i] begins, it will be too late to black out still,
                                and you will be forced to live through [b]all[/b] of it, until the very end.
                            [/sneak]
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildFirstChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === firstChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${firstId}" ${disabled}>Black out</button>`;

        var tooltip = global.parser.parse(`Retreat into a lower level of consciousness to avoid witnessing the [b]horrible[/b] things about to take place.`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 180px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildSecondChoice() {
        var disabled = subController.has() ? "disabled" : "";
        var isSelected = subController.get() === secondChoice;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice dangeraura ${selected}" id="${secondId}" ${disabled}>Endure</button>`;

        var tooltip = global.parser.parse(`Stay awake enough to remember every single last detail of your torture. [warn]You will regret this.[/warn]`);
        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 175px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer"><div class="inlinechoiceheader">You:</div>`;
        choice += buildFirstChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildSecondChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + firstId), $("#" + secondId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerFirstListener() {
        $("#" + firstId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(firstChoice);
            ctrl.recover.continue();
            loadNextPart(firstNext);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerSecondListener() {
        $("#" + secondId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.set(secondChoice);
            loadNextPart(secondNext);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        if (subController.get() === FarmerMaidGenderChoice.BLACKOUT) {
            part += firstNext.build();
        }
        part += secondNext.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        if (subController.get() === FarmerMaidGenderChoice.BLACKOUT) {
            firstNext.registerListeners();
        }
        secondNext.registerListeners();

        if (subController.has()) {
            return;
        }

        registerFirstListener();
        registerSecondListener();
    };
}

var FarmerMaidGenderChoice = {
    BLACKOUT: 1,
    CLAWS: 2
};

// END scenes\Enslavement\DayTwo\FarmerMaid\arrival\FarmerMaidGender.js

// scenes\Enslavement\DayTwo\FarmerMaid\arrival\FarmerMaidArrival.js

/**
 * Farmer's maid ending.
 * @param {FarmerMaidController} controller The Varanar, Afternoon Three controller.
 */
function FarmerMaidArrival(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = false;
    var subController = ctrl.arrival;
    var changeController = false;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new FarmerMaidGender(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            Tugging you by your arm, the farmer leads you towards a shack, not too far away from his home.
                            The two of you come to a halt in front of it.
                            Instead of stepping inside, the human turns around, keeping a firm hold on you to make sure you don't [i]escape[/i].
                            He seems to be waiting for someone, or [i]something[/i].
                        [/p]
                        [p]
                            You're too [i]intimidated[/i] by the farmer's solid grasp and broad posture to ask what it is you are doing here.
                            Instead, you inspect the building.
                            Through the open door, you can see various metal tools hanging from the wooden wall.
                            A well-lit kiln stands next to it, the handles of a few iron pokers sticking out.
                            This must be the [i]workshop[/i] the human was talking about.
                            Looks kind of like a miniature smithy, although you don't see any anvils around.
                        [/p]
                        [p]
                            After more than a minute of silent waiting, a group of burly men approach from far side of the village.
                            The anthro horses from the auction are there,
                            along with several humans who look like they've working the fields for their entire lives.
                            They seem to know your new [i]owner[/i].
                            Seeing the entourage, you swallow deeply, fearing this might be a [i]sexual[/i] thing.
                            He's going to [b]sell[/b] your body to every man in town!
                        [/p]
                        [p]
                            The men heartily greet the farmer.
                            "[color=purple]Hey Romeo.[/color]"
                            Romeo?
                            Is that his name?
                            Or is he being made fun of?
                            "[color=purple]So this is the new purchase, eh?[/color]"
                            asks one of the horses, referring to you.
                            They're all going to take turns fucking you, aren't they?
                            "[color=purple]Two hundred, was it? Expensive little lizard.[/color]"
                            You feel sick.
                            Your stomach starts to churn.
                            "[color=red]Yeah, but my house'll finally be clean, for once.
                            If only my wife was less lazy, eh?[/color]"
                        [/p]
                        [p]
                            Any minute now, they're going to lower their pants,
                            whip out their dicks and fuck you until you can barely even walk anymore.
                            "[color=red]Anyway, let's get down to business, shall we?
                            I've got crops to water before dark.[/color]"
                            Oh no.
                            This is it.
                            "[color=red]Did you bring the goods?[/color]"
                            Wait, what?
                            [i]The goods[/i]?
                            "[color=purple]Yeah, yeah.
                            Hold'em still.[/color]"
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        global.ui.applyTheme("hamlet_day");
        ctrl.bgm.loop();
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}

// END scenes\Enslavement\DayTwo\FarmerMaid\arrival\FarmerMaidArrival.js

// scenes\Enslavement\DayTwo\FarmerMaid\FarmerMaidController.js

/**
 * Controller for the Farmer's Maid scene.
 * @param {string} sceneId The id of the scene.
 */
function FarmerMaidController(sceneId) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var id = sceneId;
    SceneController.call(this, id);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    // PUBLIC MEMBERS \\        this.public = "test";
    this.nextSceneReady = false;
    this.nextSceneName = "SlaveAfternoonTwo";
    this.nextFolderName = "Enslavement/DayTwo";

    this.misc = new MiscController(id, "misc");

    this.arrival = new ContinueController(id, "arrival");
    this.gender = new ChangeController(id, "gender", function () {
        if (that.misc.gender() !== GenderEnum.FEMALE) {
            global.kobold.body.setGender(GenderEnum.FEMALE);
        }
    }, function () {
        return "";
    });
    this.claws = new ChangeController(id, "claws", function () {
        global.kobold.status.physical.decrease(30, "Claw removal");
        global.kobold.status.mental.decrease(30, "Claw removal");
        global.kobold.status.stamina.decrease(30, "Pleading for mercy");
    }, function () {
        return "";
    });
    this.teeth = new ChangeController(id, "teeth", function () {
        global.kobold.status.physical.decrease(30, "Tooth removal");
        global.kobold.status.mental.decrease(30, "Tooth removal");
        global.kobold.status.stamina.decrease(30, "Screaming for help");
    }, function () {
        return "";
    });
    this.brandmark = new ChangeController(id, "brandmark", function () {
        global.kobold.status.physical.decrease(30, "Brandmarked");
        global.kobold.status.mental.decrease(30, "Brandmarked");
        global.kobold.status.stamina.decrease(30, "Begging for death");
    }, function () {
        return "";
    });
    this.recover = new ChangeController(id, "recover", function () {
        if (that.gender.get() === FarmerMaidGenderChoice.BLACKOUT) {
            global.kobold.status.physical.decrease(90, "Claws and teeth removed");
            global.kobold.status.mental.decrease(90, "Claws and teeth removed");
            global.kobold.status.stamina.decrease(90, "Screaming, pleading and begging");
        }
        global.kobold.status.exertion.decrease(90, "A slave is always ready");
        global.kobold.inventory.equipment.wear(new MaidOutfit());
    }, function () {
        return "";
    });
    this.preMaid = new ContinueController(id, "preMaid");
    this.maid = new ChoiceController(id, "maid");
    this.postMaid = new ContinueController(id, "postMaid");
    this.preParents = new ContinueController(id, "preParents");
    this.parents = new ChoiceController(id, "parents");
    this.postParents = new ContinueController(id, "postParents");
    this.amorousFuck = new ChangeController(id, "amorousFuck", function () {
        global.kobold.body.vaginalVirgin = false;
    }, function () {
        return "";
    });
    this.absentBlowjob = new ChangeController(id, "absentBlowjob", function () {
        global.kobold.body.oralVirgin = false;
    }, function () {
        return "";
    });
    this.daily = new ContinueController(id, "daily");
    this.amorousDaily = new ChangeController(id, "amorousDaily", function () {
        global.kobold.body.analVirgin = false;
        global.kobold.body.oralVirgin = false;
    }, function () {
        return "";
    });

    this.toofar = new ChoiceController(id, "toofar");
    this.toofarRun = new ChangeController(id, "toofarRun", function () {
        global.kobold.body.analVirgin = false;
        global.kobold.body.oralVirgin = false;
    }, function () {
        return "";
    });
    this.toofarTell = new ChoiceController(id, "toofarTell");
    this.toofarServe = new ChangeController(id, "toofarServe", function () {
        global.kobold.body.vaginalVirgin = false;
    }, function () {
        return "";
    });

    this.girlfriend = new ChoiceController(id, "girlfriend");
    this.jealous = new ChoiceController(id, "jealous");
    this.girlfriendKill = new ChangeController(id, "girlfriendKill", function () {
        global.kobold.body.vaginalVirgin = false;
    }, function () {
        return "";
    });
    this.frame = new ChoiceController(id, "frame");


    this.drunk = new ChoiceController(id, "drunk");
    this.postDrunk = new ContinueController(id, "postDrunk");
    this.preDeath = new ContinueController(id, "preDeath");
    this.death = new ChoiceController(id, "death");


    this.parentsChoice = {
        LEAVE: 1,
        WATCH: 2,
        HANDJOB: 3,
        BLOWJOB: 4,
        NOPEN: 5,
        FUCK: 6
    };

    this.fragments = {};
    this.fragments.dog = new FarmerMaidDrunkDeclineDog(this);
    this.fragments.satisfied = new FarmerMaidDrunkSatisfy(this);
    this.fragments.amorousDaily = new FarmerMaidAmorousDaily(this);
    this.fragments.absentDaily = new FarmerMaidAbsentDaily(this);
    this.fragments.abusiveDaily = new FarmerMaidAbusiveDaily(this);
    this.fragments.blowjob = new FarmerMaidAbsentBlowjob(this);
    this.fragments.handjob = new FarmerMaidAbsentHandjob(this);
    this.fragments.recover = new FarmerMaidRecover(this);

    this.subControllers = {};

    this.bgm = new AudioController(id, "res/audio/enslavement/maid.mp3", 100);

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

}

// END scenes\Enslavement\DayTwo\FarmerMaid\FarmerMaidController.js

// scenes\Enslavement\DayTwo\FarmerMaid\FarmerMaid.js

/**
 * Farmer's Maid Enslavement Ending.
 */
function FarmerMaid() {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var sceneId = "FarmerMaid";
    var sceneName = "Farmer's Maid";
    var sceneSubfolder = "Enslavement/DayTwo";
    var ctrl = new FarmerMaidController(sceneId, this);
    var arrival = new FarmerMaidArrival(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Sets all the required global variables such as scene id, scene name,
     * scene stack and theme.
     */
    function setGlobals() {
        global.currentScene = that.id;
        global.currentSceneName = that.name;
        global.currentSceneFolder = that.subfolder ? that.subfolder : "";
        global.kobold.history.addToSceneStack(that.id);
    }

    /**
     * Builds the tab as a HTML string.
     * @returns {string} The tab, as a HTML string.
     */
    function buildTab() {
        var tab = global.ui.buildGenericHeader();
        tab += global.parser.parse(`[t]Enslavement[/t]`);
        tab += global.parser.parse(`[st]Farmer's maid[/st]`);
        tab += arrival.build();
        tab += global.ui.buildGenericFooter();
        return tab;
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = sceneId;
    this.name = sceneName;
    this.subfolder = sceneSubfolder;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Loads this scene.
     */
    this.load = function () {
        setGlobals();
        var tab = buildTab();
        global.ui.loadToMain(tab);
        arrival.registerListeners();
        ctrl.autosave();
    };

    /**
     * Resets the scene to the starting point.
     */
    this.reset = function () {
        global.kobold.history.set(id, {});
    };
}

global.sceneLoader.queueRegister(function () {
    var scene = new FarmerMaid();
    global.sceneLoader.registerScene(scene.id, scene);
});

// END scenes\Enslavement\DayTwo\FarmerMaid\FarmerMaid.js



// END SCENE FarmerMaid

